2016-10-08  Shiro Kawai  <shiro@acm.org>

	* Release 0.9.5

2016-10-02  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_ClockGetTimeMonotonic,Scm_ClockGetResMonotonic):
	  Add workaround of XCode8 issue that it pretends clock_gettime
	  and clock_getres available but it's not true until OSX 10.12.
	  The workaround code directly calls mach APIs.

	* src/system.c (Scm_WinGetPipeName),
	  src/libsys.scm (sys-win-pipe-name): Windows-specific API to obtain
	  pipe name.
	* src/libsys.scm (%sys-mintty?): Determine if gosh's input is
	  connected to mintty on msys.

	* src/main.c (enter_repl, has_terminal): On Windows, Use %sys-mintty?
	  so that we get REPL on MSYS shell.

2016-10-01  Shiro Kawai  <shiro@acm.org>

	* src/Makefile.in, lib/Makefile.in: Ensure removing *.sci and *.dll
	  with 'make clean'---they're supposed to be cleaned by xlink script
	  but when it fails remaining *.sci and *.dll may interfere the
	  build process.

2016-09-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive/toplevel.scm: Add ,sh toplevel command.
	  Change define-toplevel-command so that each command can choose
	  how the arguments are parsed.

2016-09-25  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/array.scm: Add u8array, s8array, ..., f64array
	  constructors, for the consistency.

2016-09-24  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/generator.scm (ginterval): Added experimentally.
	  The name is still provisional---it may be called gflip-flop.
	  I used 'interval' now because it takes data between the one
	  that satisfies the start predicate and the one that satisfies
	  the end predicate.  But it may be confusing that the interval
	  is about sequence, not about the value range.

2016-09-21  Shiro Kawai  <shiro@acm.org>

	* lib/check-script: Added.

2016-09-19  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/package.scm (find-gauche-package-description): Fix
	  an issue on Windows.
	  http://chaton.practical-scheme.net/gauche/a/2016/09/17#entry-57dc9a84-c61da

2016-09-11  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/base.scm (gauche.base): Extend gauche.keyword as well,
	  so that R7RS code that does (import (gauche base)) can call
	  Gauche procedures with keyword arguments just like Gauche code.

2016-09-06  Shiro Kawai  <shiro@acm.org>

	* libsrc/srfi-133.scm (vector-cumulate): Switched argument order,
	  according to the errata.

2016-08-31  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (find-load-file),
	  src/compile.scm (pass1/open-include-file): Treat include paths
	  beginning with "./" and "../" as relative pathname to the
	  includer file.  The original behavior is consistent with 'load',
	  but it doesn't make much sense for 'include', which is compile-time
	  operation, unlike 'load' being run-time operation.
	  This is INCOMPATIBLE CHANGE as the previous behavior was documented,
	  but I hope it won't affect existing code.

2016-08-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/macroutil.scm (quasirename): Handle unquote-splicing.

2016-08-24  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-113.scm: Fix collection framework implementation.  Bags
	  must honor item count.

2016-08-23  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-113.scm: Fix single-argument case in set-union etc.

2016-08-19  Shiro Kawai  <shiro@acm.org>

	* ext/tls: Updated to axTLS-2.0.0

2016-08-18  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/extended-lambda): Compare extended
	  lambda-list keywords hygienically.  If GAUCHE_KEYWORD_IS_SYMBOL,
	  keywords inserted by macros are wrapped by identifiers and
	  we should compare it just like symbols inserted by macros.

	* src/hash.c (Scm_Hash, Scm_PortableHash): Take care of the effect
	  of keyword-symbol integration.  If a keyword is a symbol, its name
	  includes prefix ':', while if they're disjoint, keyword's name
	  doesn't include ':'.  For portable hash, we include ':' in the
	  calculation.  For legacy hash, we don't.

2016-08-15  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvector.scm (port->uvector): Added.

2016-08-14  Shiro Kawai  <shiro@acm.org>

	* gc/libatomic_ops/configure.ac (AM_INIT_AUTOMAKE):
	  Add no-dependencies option to avoid complication in distclean.
	  Here's the story: Automake adds 'include' command in
	  gc/libatomic_ops/src/Makefile to incorporate dependencies in
	  .deps/*.Plo which are generated during running configure.
	  On 'make distclean', the .deps directories are removed, but
	  both gc/ and libatomic_ops/ tries to do so; if we run distclean
	  in gc/ then in libatomic_ops/, the latter fails since Makefile
	  cannot include .deps/*.Plo.  If we run distclean in libatomic_ops/
	  first then gc/, the latter fails since somewhere in
	  automake-generated rules needs to refer to libatomic_ops/src/.deps.
	  If we only run distclean in gc/, it succeeds, but leaves Makefiles
	  in libatomic_ops/ unerased.
	  (Note: If you have system libatomic_ops, gc uses that and you
	  won't see this problem.)
	  It's too much trouble to fight with automake; turning off the
	  dependency tracking avoids the trouble altogether.

2016-08-11  Shiro Kawai  <shiro@acm.org>

	* gc/: Updated to bdwgc 7.6.0 by qykth-git.
	  https://github.com/shirok/Gauche/pull/224

2016-08-05  Shiro Kawai  <shiro@acm.org>

	* test/process.scm: In pipeline tests, emulate cat and grep commands
	  so that the tests work on MinGW.

	* src/system.c (win_prepare_handles): Ensure close handles that should,
	  and not to close ones that shouldn't.

	* src/port.c (file_closer): Check the return value of close(), and
	  raise <system-error> if failed.  It may be annoying if you want
	  to call close-port "just to be safe" on potentially broken port,
	  but checking the error here would catch a bug that would cause
	  difficult-to-diagnose bug later.

2016-08-04  Shiro Kawai  <shiro@acm.org>

	* src/class.c, src/proc.c: EXPERIMENTAL: Use 'locked' flag of
	  <method> for "method-locked".  Locked method prohibits redefining
	  the methods with the same signature.  Intended to use methods
	  important for correct behavior of the language runtime.
	* src/compile.scm, src/libobj.scm (define-method): Allow method
	  qualifiers; currently only ':locked' is recognized.

2016-08-02  shiro  <shiro@acm.org>

	* src/libcmp.scm, src/libomega.scm, lib/gauche/computil.scm:
	  Changed default-comparator extension mechanism.  Instead of
	  dispatching _before_ falling back to system default, we just
	  use system default stuff (equal?, compare, default-hash) and
	  dispatch to custom comparators via fallback methods
	  (object-equal?, object-compare and object-hash).  This way
	  we won't sacrifice performance of default-comparator for builtin
	  types.  Caveat: (1) This mechanism relies on we catch the base
	  case of object-equal? etc.; it breaks if anybody redefines
	  (object-equal? <top> <top>), for example.  (2) You can't use
	  _both_ Gauche's way (defining (object-compare <mytype> <mytype>)
	  and srfi-128 way (registering a comparator for <mytype>); you have
	  to choose one.

2016-08-01  Shiro Kawai  <shiro@acm.org>

	* ext/tls/axTLS: Update to axTLS-1.5.4.

2016-07-30  Shiro Kawai  <shiro@acm.org>

	* tools/gc-configure.gnu-gauche.in: Add --disable-gcj-support;
	  GC tests fail without it on msys2+mingw-w64.

	* src/class.c (Scm_GenericObjectEqualP, Scm_GenericObjectCompare):
	  Use fallback routine of those gfs to handle the default case,
	  instead of defining (<top> <top>) method.  It's cleaner, and we
	  need to define (<top> <top>) method to handle
	  comparator-register-default! later.

2016-07-29  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm: Allow internal define-inline; it's the same as
	  internal define.  Since the compiler can figure out inlinable
	  internal defininitions the programmer doesn't need to use
	  internal define-inline, but it can appear as the result of
	  macro expansion.  In fact, this fixes the bug that caused
	  internal define-record-type being a compile error.

2016-07-23  shiro  <shiro@acm.org>

	* lib/util/unification.scm: Added.

2016-07-22  shiro  <shiro@acm.org>

	* lib/gauche/computil.scm (comparator-register-default!): Implement
	  srfi-128 mechanism of extending default comparator.

2016-07-20  shiro  <shiro@acm.org>

	* src/libcmp.scm, lib/srfi-114.scm (make-car-comparator)
	  (make-cdr-comparator): Moved these to srfi-114.

2016-07-19  shiro  <shiro@acm.org>

	* src/libcmp.scm, lib/srfi-114.scm (comparator-equal?): Move
	  this to srfi-114, for =? covers its usage.

2016-07-17  shiro  <shiro@acm.org>

	* src/libcmp.scm, lib/srfi-114.scm (comparator-comparison-procedure?)
	  (comparator-hash-function?, comparator-type-test-procedure):
	  Move some srfi-114-specific procedures from builtin to srfi-114.
	  Code that relies on them being builtin must be changed to use
	  srfi-128 procedures.  Various internal code has been fixed to
	  use srfi-128 ones.

2016-07-10  Shiro Kawai  <shiro@acm.org>

	* src/gauche/priv/dws_adapter.h: We need to stick 32bit siphash
	  for the portable hash regardless of the platforms, though we
	  do want 64bit siphash for the default hash on 64bit platform.
	  To workaround name conflicts, we applied some ducttaping so
	  we can have consistent internal interface.  See the comment
	  in the file for the details.

2016-07-05  Shiro Kawai  <shiro@acm.org>

	* src/hash.c, src/libdict.scm, src/libomega.scm:
	  We make Scm_Hash() and 'hash' deprecated, and will
	  keep it only for the backward compatibility.  Add 'portable-hash'
	  for replacement, which takes explicit salt.  Also provide
	  'default-hash', ala srfi-128, which honors hash-salt and is
	  used for equal hashtable.
	  The object-hash method now takes two arguments, an object to
	  hash and the hash function to be recursively called when necessary.
	  To avoid breaking the existing code of object-hash that takes
	  one argument and recursively calls 'hash' procedure, we tweaked
	  'hash' so that it dispatches to the appropriate hash function
	  if it's called recursively.

2016-07-04  Shiro Kawai  <shiro@acm.org>

	* src/hash.c (Scm_HashString), src/dwsiphash.[ch], src/dws32hash.[ch]:
	  Replaced default string hash function with siphash, and using
	  per-processs random salt to prevent hash collision attack.

2016-07-03  Shiro Kawai  <shiro@acm.org>

	* src/hash.c (legacy_flonum_hash): Legacy hash fn for flonums had
	  stepped on the undefined behavior.  To keep portability and
	  compatibility, we try to emulate existing behavior.  Note that
	  there are already discrepancies between platforms; we can't achieve
	  perfect backward compatibility.  But after this fix we'll at least
	  eliminate platform dependency.

2016-07-02  Shiro Kawai  <shiro@acm.org>

	* lib/data/ideque.scm (make-ideque): Changed API to be consistent
	  with other container datatypes.

2016-07-01  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-134.scm: Finalized, so we document data.ideque and
	  make srfi-134 alias of it.

2016-06-27  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/process.scm (run-process-pipeline): Add an intermediate
	  convenience API to run pipelined commands.

2016-06-26  Shiro Kawai  <shiro@acm.org>

	* gc/m4/*, gc/libatomic_ops/m4/*: Check-in libtool-related m4 files,
	  which can be automatically generated by autoreconf, but we avoid
	  relying on it in case the platform doesn't have matching autoconf
	  macro libraries (specifically, OSX doesn't have libtool-related m4
	  macros with the default installation).

2016-06-25  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (select-module, export, export-all, import)
	  (extend, require): Evaluates to zero values instead of #<undef>.
	  Better for REPL (less cluttering, no messing history).
	  This is technically an incompatible change, but we assume nobody
	  has ever used the return value of those forms.

2016-06-24  Shiro Kawai  <shiro@acm.org>

	* src/hash.c (Scm_Hash): Make sure portable hash value is masked
	  by HASHMASK.  Shouldn't affect existing code as far as they're
	  using lower <=32 bits, but the whole point of portable hash value
	  is that it's portable, so it's better to ensure that.
	  (legacy_number_hash): Fixed a bug that caused to produce different
	  bignum hash value between 32bit long and 64bit long platforms.
	  (This changes the portable hash value of bignums on 64bit platforms;
	  crossing fingers that won't break things)

2016-06-21  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vm/debugger.scm: Add thread vmid to '#?=' output
	  so that output from different threads can be distinguished
	  easily.  The id is omitted for primordial thread.

	* gc/*: Bumped up to gc-7.4.4.
	  See https://github.com/shirok/Gauche/pull/210

2016-06-17  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/mop/bound-slot.scm: Experimentally added.

2016-06-16  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvector.scm (s8vector->string, u8vector->string):
	  Add 'terminator' optional argument, which recognizes terminating
	  character as the end of string.  Convenient to extract
	  NUL-terminated string from fixed size buffer, for example.

2016-06-14  Shiro Kawai  <shiro@acm.org>

	* src/hash.c (Scm_EqvHash): Improve hash value of flonums.
	  (Scm_Hash): Decouple from Scm_EqvHash to use original code for
	  number hash, in order to maintain backward compatibility.
	* src/libdict.scm (portable-hash): Added - better name to indicate
	  portable hash value.

2016-06-13  Shiro Kawai  <shiro@acm.org>

	* src/liblazy.scm (lrange): Fix handling zero and negative steps.

	* src/hash.c (Scm_HashSaltRef, Scm_HashSaltSet),
	  src/libdict.scm (hash-salt): Built-in support of hash salt (not yet
	  used, but this is the starting point.)

2016-05-27  Shiro Kawai  <shiro@acm.org>

	* src/libio.scm, lib/gauche/interactive.scm:
	  Drop read-consuming-trailing-whitespaces,
	  for it turned out it can't be used meaningfully.  For toplevel
	  commands we have to call read-line after the first word,
	  so the first word reader must not consume trailing newline
	  immediately.  We create consume-trailing-whitespaces instead.

	* src/read.c: Fix erroneous read behavior such as
	  (read-from-string "#:") => #:|| and
	  (read-from-string "#: foo") => #:| foo|.  We now reject if '#!'
	  and '#:' aren't immediately followed by a valid symbol.

2016-05-26  Shiro Kawai  <shiro@acm.org>

	* src/libio.scm (read-consuming-trailing-whitespaces): Useful
	  extension of 'read' for REPL.
	* lib/gauche/interactive.scm,
	  lib/gauche/interactive/editable-reader.scm: Dropped
	  %skip-trailing-ws and use r-c-t-w above, for the previous code
	  won't work when we're not reading from the current input port.

2016-05-25  Shiro Kawai  <shiro@acm.org>

	* src/number.c (read_number): EXPERIMENTAL: Recognize 'pi' suffix
	  in polar complex notation, e.g. 2@1pi => -2.0.

2016-05-24  Shiro Kawai  <shiro@acm.org>

	* src/gauche/system.h (ScmStat): Switch definition of struct stat
	  on GAUCHE_WINDOWS.
	* src/gauche/win-compat.h (stat): Use _wstat64() for stat(), to
	  handle filenames with multibyte characters.

2016-05-21  Shiro Kawai  <shiro@acm.org>

	* src/main.c (enter_repl): Better error reporting for an error
	  thrown during loading gauche.interactive.  It helps
	  troubleshooting bugs in gauche.interactive and/or .gaucherc.

2016-05-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/hashutil.scm, lib/gauche/computil.scm,
	  src/autoloads.scm:
	  Added srfi-128 APIs

2016-05-16  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/hashutil.scm, src/autoloads.scm:
	  Added srfi-128 type-specific hash functions.

2016-05-11  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm,
	  lib/gauche/interactive/editable-reader.scm: EXPERIMENTAL: Enable
	  line-editing input when the environment variable GAUCHE_READ_EDIT
	  is set and the terminal is known to be capable of editing.
	  If you see a prompt "gosh$ ", read-edit is enabled.
	  Note: The editing capability depends on text.line-edit, and we
	  still have a few unresolved issues---the display breaks when
	  multiline input goes beyond the screen height, and multibyte
	  characters aren't handled correctly, to name a few.  This mode
	  is to ease debugging of the feature and not for general use yet.

2016-05-08  Shiro Kawai  <shiro@acm.org>

	* src/portapi.c (Scm_PortSeek): Take ungotten char / scratch buffer
	  into account of port offset.  Based on the patch from Koguro.

2016-05-05  Shiro Kawia  <shiro@acm.org>

	* src/gauche/priv/codeP.h: Make C API of code buliding stuff
	  private, and also changed the signature of
	  Scm_MakeCompiledCodeBuilder (crossing fingers).  These C API
	  should only be called from code.c and libcode.scm; other internal
	  parts should depend on Scheme API.
	* src/compile.scm (pass5/lambda),
	  src/libcode.scm (compiled-code-attach-source-info!):
	  Fill signature-info by the signature with extended pair, having
	  source code location info.  With this, the source code location
	  info is carried over to (~ <closure>'info) by Scm_MakeClosure.

2016-05-03  Shiro Kawai  <shiro@acm.org>

	* src/gauche/code.h, src/libcode.scm: Rename 'info' and 'arg-info'
	  slots of <compiled-code> to 'debug-info' and 'signature-info',
	  respectively, to clarify the roles of those slots. (mere 'info'
	  doesn't mean much!)  Technically this is C source-level
	  incompatible change (code that refers to those slots must be
	  changed) but we hope third party code won't touch such internal
	  info (crossing fingers).
	  The Scheme slot names are also renamed, but we leave old names as
	  aliases, in order to allow precompiler work with 0.9.4.  We'll
	  drop the old names sometime after releaseing 0.9.5.

2016-05-02  Shiro Kawai  <shiro@acm.org>

	* src/gauche/code.h, src/code.c: Change the info kept in
	  ScmCompiledCode->argInfo; see the comment of code.h for the details.
	  (1) We include the procedure name in the <signature> part.  We've
	  calculated it every time in Scm_MakeClosure before, which is a
	  waste.
	  (2) Allow to hold more information than arguments in argInfo; a
	  plan is to keep unused args so that it could be used for further
	  optimization, but that part hasn't been written.

2016-04-26  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/parameter.scm (parameterize): Further cleanup.
	  Avoid nested dynamic-wind.  Removed auxiliary macros.

2016-04-23  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-113.scm (sob-hash): Fix - hash function must not rely
	  on the visiting order of hash-table-for-each.

	* libsrc/gauche/parameter.scm (%parameterize-1): Fix a bug that
	  appears when the converter isn't idempotent.

2016-04-22  Shiro Kawai  <shiro@acm.org>

	* src/vm.c, src/gauche/vm.h: Add vmid slot to Scm_VM for numeric id
	  of each VM.  It is intended to ease debugging multithreaded
	  programs (e.g. attach numeric id for messages).  It's not to
	  be used as a handle for a thread.

2016-04-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/configure.scm (cf-init): Check dependent module version
	  requirements, if given in package.scm.

2016-04-19  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/version.scm (valid-version-spec?, version-satisfy?):
	  Added.

2016-04-18  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/uri.scm (uri-decompose-authority): Handle IPv6 address
	  as host part, e.g. "[::1]:8080".

	* lib/gauche/package.scm: Enhanced <gauche-package-description> to
	  keep metainformaton provided by the package author.  The package
	  auther can put package.scm in the top dir, which provides metainfo;
	  cf-init can now read package.scm (package name and version can be
	  taken from it) and cf-make-gpd emits gpd file that combines
	  package.scm and build-time info.
	* lib/gauche/configure.scm (cf-init, cf-make-pkg): Adapted the flow
	  using package.scm.
	* ext/template.package.scm: Template package.scm
	* examples/spigot: Adopt package.scm
	* src/gauche-package.in: 'gauche-package generate' copies package.scm
	  template.

2016-04-17  Shiro Kawai  <shiro@acm.org>

	* ext/text/unicode.scm -> ext/gauche/unicode.scm: Changed text.unicode
	  to gauche.unicode, for r7rs string case folding depends on it.
	  R7rs-compatible srfis that deal with string case folding also
	  require r7rs string-ci behavior.

2016-04-11  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm, lib/gauche/cgen/stub.scm: Save
	  source info of precompiled SUBRs and closures.  They can be
	  useful during development.

	* src/libcode.c (compiled-code-definition): Added.  This will be
	  the basis of source-code (gauche/procedure.scm) and
	  <cgen-scheme-code> literal (gauche/cgen/precomp.scm).  Since
	  0.9.5 must be compiled by 0.9.4, we'll defer changing `source-code'
	  etc until after 0.9.5 release.
	* lib/gauche/cgen/literal.scm: Add support of serializing
	  extended pair.  NB: We don't automatically serialize extended-pair,
	  for pair attributes may contain unnecessary info.  Instead,
	  a special proxy object is provided that would be serialized as
	  an extended pair.

2016-04-10  Shiro Kawai  <shiro@acm.org>

	* src/list.c (Scm_MakeExtendedPair): Added.

2016-04-09  Shiro Kawai  <shiro@acm.org>

	* examples/spigot, examples/mqueue-cpp: Switched to use
	  gauche.configure instead of autoconf.

	* lib/gauche/configure.scm: Add framework to run compiler tests.
	  New apis: cf-arg-var, cf-check-tool, cf-prog-cxx, cf-lang,
	  cf-lang-program, cf-lang-io-program, cf-lang-call,
	  cf-try-compile, cf-try-compile-and-link.

	* lib/gauche/process.scm (shell-tokenize-string): Added.

2016-04-08  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/process.scm (shell-escape-string): Add optional flavor
	  argument to allow cross-platform processing.

	* src/libsys.scm (%sys-escape-windows-command-line): Fixed to follow
	  msvc runtime behavior more closely.

2016-04-06  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/mop/singleton.scm: Made it thread-safe.

2016-04-04  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive/toplevel.scm: Allow abbreviation of
	  toplevel commands.  Based on a patch from Hamayama.

2016-04-02  Shiro Kawai  <shiro@acm.org>

	* lib/util/levenshtein.scm: Added.

2016-03-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interpolate.scm (%string-interpolate): Slight
	  optimization to avoid unnecessary string-append.

	* lib/gauche/cgen/cise.scm (result): Allow more than three values.
	  Patch from pclouds.

2016-03-26  Shiro Kawai  <shiro@acm.org>

	* ext/srfi/srfi-133.scm -> libsrc/srfi-133.scm: moved
	* ext/srfi/srfi-43.scm: Rewrote on top of srfi-133.

2016-03-25  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive/info.scm: Include module and class names
	  for the lookup entry.  Make the initial table set-up thread safe.

2016-03-24  Shiro Kawai <shiro@acm.org>

	* ext/data/queue.scm (mtqueue-num-waiting-readers): Added.

2016-03-23  Shiro Kawai  <shiro@acm.org>

	* src/load.c (Scm_Require): 'require' now loads a file into
	  a sealed module #<module gauche.require-base>.  This guarantees
	  the forms like define-module or define-library to be visible
	  from the loaded file, and also catches when the loaded file
	  inadvertently inserts toplevel bindings without specifying
	  a module.
	  Note: This change may triggers an error in existing code.  Such
	  code has just "happened to work"; they should be fixed.

	* src/compile.scm (pass4): Use local environment instead of inserting
	  new global identifiers for lifted lambdas.   Inserting new global ids
	  has an issue of where module the global binding should be inserted.

2016-03-22  Shiro Kawai  <shiro@acm.org>

	* ext/srfi/srfi-133.scm: Added srfi-133 support.  The common part
	  of srfi-133 and r7rs is now fully covered by built-in.

2016-03-20  Shiro Kawai  <shiro@acm.org>

	* src/comple.scm (when, unless): Require at least one expr in the
	  body.  Allowing empty when/unless is only marginally useful (maybe
	  some macros can be written more concisely) but it might be better
	  to be strict to catch errors.

2016-03-18  Shiro Kawai  <shiro@acm.org>

	* src/module.c, src/libmod.scm (%seal-module!): Add the 'sealed' flag
	  in ScmModule.  Sealed modules won't allow to create or modify
	  its bindings, nor to newly import modules.

2016-03-17  Shiro Kawai  <shiro@acm.org>

	* src/libcmp.scm, src/compare.c: Integrating srfi-128.
	  INCOMPATIBLE-CHANGE: Built-in make-comparator is now compatible to
	  srfi-128.  Srfi-114 compatible constructor is renamed to
	  make-comparator/compare.
	  It is no longer safe to directly refer to comparator->compareFn
	  and comparator->hashFn in C code; they may be filled lazily.
	  You should call Scm_ComparatorComparisonProcedure() and
	  Scm_ComparatorHashFunction() respectively.
	* various files: Changes according to above; mostly just replacing
	  make-comparator to make-comparator/compare.  Later we may refine
	  the code so that we can use make-comparator whenever it's more
	  efficient.

2016-03-16  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/process.scm: Reject if the same symbol is used more
	  than once as the pipe name in redirects.
	  https://github.com/shirok/Gauche/issues/182

2016-03-12  Shiro Kawai  <shiro@acm.org>

	* lib/text/console.scm (%read-char/timeout): Support mintty/MSYS.
	  (getch): clear the input buffer before finishing.
	  (query-cursor-position): Queue any ESC sequence to input buffer
	  when it is not a cursor position report.
	  (ensure-bottom-room): Rename from last-scroll to indicate
	  what it does, and export this.
	* lib/text/console/windows.scm (%getch-sub): Handle surrogate pairs.
	  (get-raw-chars): Added.
	  (clear-screen, clear-to-eos): Clear to the end of buffer instead
	  of just on-screen area.  Because of IME, it's difficult to properly
	  determine on-screen area size.
	  (ensure-bottom-room): Rename from last-scroll, and add workaround
	  of full-width case.

2016-03-11  Shiro Kawai  <shiro@acm.org>

	* ext/tls/*: Add basic server-side certificate support.  Patch
	  from pclouds.  See https://github.com/shirok/Gauche/pull/180

2016-03-10  Shiro Kawai  <shiro@acm.org>

	* ext/termios/termios.scm: Support mintty on MSYS - the communication
	  between mingw process and mintty isn't direct (it goes through
	  MSYS runtime) so we need to rely on external stty command.
	  See the comment in msys-get-stty.  Originally done by
	  Hamayama ( https://github.com/shirok/Gauche/pull/173 ), and
	  we incorporated with some style adjustements.
	* lib/text/console.scm: has-windows-console? is moved to
	  gauche.termios.

2016-03-07  Shiro Kawai  <shiro@acm.org>

	* src/portapi.c (getc_scratch): Fix: peek-byte could break the
	  following read-char when input contains invalid byte sequence.

2016-03-06  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm: Generate stub record in 'decl' part
	  instead of after the function body, so that the cproc body
	  can refer to the decl body.

2016-03-05  Shiro Kawai  <shiro@acm.org>

	* ext/bcrypt: Update bcrypt implementation to crypt_blowfish 1.3,
	  and changed the default from 2a to 2b.
	  See https://github.com/shirok/Gauche/pull/175 and
	  https://github.com/shirok/Gauche/pull/176.

2016-02-27  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm (.funcall/rec, .funcall/cps): Allow to
	  specify the module from which the procedure is looked for.

2016-02-26  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm: Add .funcall/rec and .funcall/cps to
	  call Scheme function from cproc body easily.

2016-02-24  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm: Add .cproc cise macro, which retrieves
	  ScmObj of c-defined procedure in the same cgen unit.

2016-02-13  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-131.scm: Added.

2016-02-12  Shiro Kawai  <shiro@acm.org>

	* examples/get-raw-chars.scm: Added.  Useful to check what kind of
	  key sequence is sent by the terminal.
	* lib/text/console.scm (get-raw-chars): Added.

2016-02-07  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/unit.scm (cgen-emit-h): Always generate .h file
	  even h-file slot of the unit is #f.

2016-02-06  Shiro Kawai  <shiro@acm.org>

	* libsrc/file/util.scm (copy-file) : Added support of :if-exists :append.

2016-02-04  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test.scm (test-script): Added test-script to test script
	  files quasi-statically.

2016-01-31  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/macroutil.scm (quasirename): Renamed from with-renaming
	  to (1) indicate it is a macro and (2) can be used like quasiquote.

2016-01-28  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (start-socket-connection): properly handle
	  ipv6-style server address spec, e.g. "[::1]:8888".

2016-01-23  Shiro Kawai  <shiro@acm.org>

	* src/gauche/class.h, src/class.c: Add Scm_Allocate() API.

2016-01-22  Shiro Kawai  <shiro@acm.org>

	* src/gauche/class.h, src/class.c: API clean up on allocation
	  protocol.   Dropped Scm_ObjectAllocate, for it is trivial and
	  it's rather confusing to have.  Renamed SCM_ALLOCATE and
	  Scm_AllocateInstance for SCM_NEW_INSTANCE and Scm_NewInstance,
	  to indicate they're lowest level of API (akin to SCM_NEW family)
	  that handles very raw allocation (with minimal initialization).
	  We also call SCM_SET_CLASS in Scm_NewInstance, for they should
	  always go together anyway.  The old API is kept during 0.9.x
	  series but will be removed on 1.0.  See the comment in
	  class.h for the details.

2016-01-21  Shiro Kawai  <shiro@acm.org>

	* lib/compat/chibi-test.scm: Handle 'include' form inside
	  chibi-test specially, so that we can say
	  (chibi-test (include "test-file-written-for-chibi.scm")).

2016-01-11  Shiro Kawai  <shiro@acm.org>

	* src/unicode-data.scm: Updated to Unicode 8.0.0

2016-01-10  Shiro Kawai  <shiro@acm.org>

	* lib/text/unicode/ucd.scm, src/gen-unicode.scm: Changed the build
	  flow so that, instead of pre-generating char_attr.c etc., we
	  keep unicode-data.scm in the source tree, which is generated
	  from Unicode character database files; char_attr.c is generated
	  during build (from source tree).
	* src/unicode-data.scm: Added.  Pre-converted data from Unicode
	  character database.
	* src/char_attr.c, ext/text/unicode_attr.h: Removed from the source
	  tree; they are regenerated during clean build.

2016-01-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm (declare): Moved handling code from
	  compile-toplevel-form to *special-handlers*, so that macro-generated
	  declare form can be recognized.
	* src/compile-0.scm (define-simple-struct): Keep generated macros
	  in the compiled binary.  Other compiler-related tools may want to
	  use them.

2015-12-25  Shiro Kawai  <shiro@acm.org>

	* src/port.c (Scm_{Get|Set}PortReaderLexicalMode): Save port-local
	  reader lexical mode in port attr.  Directives such as #!r7rs
	  should only affect port-local mode, not the global parameter.
	* src/read.c: Changed references to Scm_ReaderLexicalMode() to
	  Scm_GetPortReaderLexicalMode().

2015-12-24  Shiro Kawai  <shiro@acm.org>

	* src/system.c, src/libsys.scm (sys-mkdtemp): Added mkdtemp support.
	  Patch from enami.

2015-12-22  Shiro Kawai  <shiro@acm.org>

	* configure.ac: AC_PREREQ(2.69) -> AC_PREREQ(2.68), since mingw32
	  still uses 2.68.  There seems not much disruptive changes
	  between them (notable exception is CONFIG_SHELL, but we don't
	  require it in general); so this appears to be a reasonable
	  workarond.  Once mingw32 adopts autoconf 2.69 we can switch back.

2015-12-19  Shiro Kawai  <shiro@acm.org>

	* ext/text/unicode.scm: Update grapheme-break / word-break
	  states to support additional break properties added in
	  Unicode 6.1.0 and after.

2015-12-18  Shiro Kawai <shiro@acm.org>

	* src/gen-unicode.scm, lib/text/unicode/ucd.scm: Move
	  general UCD-related code to a separate module.

2015-12-13  Shiro Kawai  <shiro@acm.org>

	* ext/vport/vport.scm: Added input generator ports.

2015-12-12  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/parameter.scm (parameterize): Fix a bug that failed
	  to restore parameter values when aother parameter in the same
	  parameterize throws an error from the filter proc.
	  See the added test in ext/gauche/test-parameter.scm.
	  NB: This fix is very inefficient when there are lots of
	  parameters bound by a parameterize.  The better way is to split
	  parameter object's operation of appling filter proc and setting
	  new value.  That would require changing the protocol of
	  non-<parameter> parameter-like thingies (a procedure that takes
	  zero or one arguments), though.

2015-12-09  Shiro Kawai  <shiro@acm.org>

	* libsrc/srfi-13.scm (xsubstring): Fixed a bug when from is negative.

2015-12-08  Shiro Kawai  <shiro@acm.org>

	* src/port.c (Scm__SetupPortsForWindows): Set up trapper ports
	  for all standard ports; so that gosh-noconsole script can
	  do input from allocted console as well.

2015-12-03  Shiro Kawai  <shiro@acm.org>

	* lib/data/immutable-deque.scm: Added.

2015-11-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/cise.scm: Catch invalid syntax even under
	  keyword-symbol integration.

2015-11-26  Shiro Kawai  <shiro@acm.org>

	* lib/dict/immutable-map.scm: Renamed from ftree-map.scm.

2015-11-21  Shiro Kawai  <shiro@acm.org>

	* src/number.c (read_real): Fix the case of reading zero with big
	  exponent, e.g. 0e325.  Also make sure to return negative zero
	  for something as -1e-10000.

2015-11-20  Shiro Kawai  <shiro@acm.org>

	* src/load.c: Replaced dso_list for dso_table.

2015-11-18  Shiro Kawai  <shiro@acm.org>

	* lib/lang/asm/x86_64.scm: Renamed from x86.scm

2015-11-16  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (length<=?): Fix bug when x is empty list.
	  Also added all variations of comparison family: length=?,
	  length<?, length>? and length>=?.

2015-11-15  Shiro Kawai  <shiro@acm.org>

	* lib/lang/asm/x86.scm: Salvaged from experiment_jit branch.  Nothing
	  serious yet, but may be useful to play around machine instructions.

2015-11-13  Shiro Kawai  <shiro@acm.org>

	* src/libsym.scm (identifier->symbol): Call Scm_UnwrapIdentifier to
	  make sure it returns the symbol.  Note that identifier-name can
	  still return an identifier, for it just unwraps outermost identifier.
	  (symbol-append): Fix for the case args have a nested identifier.

2015-11-09  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/generator.scm: Added the rest of srfi-121. Now
	  it's a superset of srfi-121.  (NB: Since srfi-121 hasn't been
	  finalized, we may change this according to how the srfi goes.)

2015-11-06  Shiro Kawai  <shiro@acm.org>

	* src/libmisc.scm (debug-label): Added.  Useful to print out
	  anonymous objects.

2015-11-03  Shiro Kawai  <shiro@acm.org>

	* src/libnum.scm (%log): Explicitly handle the cases when input
	  is infinity.

2015-10-28  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/generator.scm (gtake, gtake*): INCOMPATIBLE CHANGE:
	  Changed optional argument spec of gtake - now it's in sync with
	  oncoming srfi-121.  For the existing code, we provide gtake*.
	  The name is better to indicate the consistency with take*.
	  (gremove, gdelete, gdelete-neighbor-dups): Added for srfi-121.

2015-10-26  Shiro Kawai  <shiro@acm.org>

	* src/module.c (Scm_MakeBinding): Only auto-export interned symbols
	  when module has exportAll flag set.  The compiler may insert
	  toplevel bindings as the result of lambda lifting, but they should
	  not be exported.  They have uninterned symbols as name, so they'll
	  never match, anyway (unless you programatically extract the
	  uninterned symbols).

2015-10-25  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/generator.scm (uvector->generator): Added.

	* ext/uvector/uvector.scm (uvector-ref, uvector-set!): Added generic
	  accessor and mutator for the convenience.

	* src/libvec.scm (%uvector-ref): We unboxed k twice, breaking the
	  whole procedure.  It never surfaced, because the way we used
	  %uvector-ref has always been expanded into UVEC-REF instruction
	  by the compiler so the procedure has never been called.

	* lib/data/ftree-map.scm: Added.

2015-10-24  Shiro Kawai  <shiro@acm.org>

	* lib/www/css.scm (parse-css, parse-css-file): INCOMPATIBLE CHANGE:
	  Changed the name from css-parse-file for the consistency.
	  Also, use `:or'instead of `or' in SxCSS, for the bare symbol
	  could be ambiguous when we have an element named `or'.

2015-10-23  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vm/profiler.scm (with-profiler): Added.

2015-10-21  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (er-renamer): Allow ER's rename procedure
	  to take lists and vectors; all variables inside it will be
	  renamed.

2015-10-17  Shiro Kawai  <shiro@acm.org>

	* src/macro.c (match_identifier): Further fix to make sure using
	  free-identifier=? to compare literals.  See the added test in
	  test/macro.scm.  This fix is grossly inefficient and should be
	  optimized soon.
	* src/compile.scm (env-lookup-int): Further fix on macro-defining
	  macros. See the added test in test/macro.scm.

2015-10-16  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (env-lookup-int), src/compaux.c (Scm_CopyIdentifier):
	  One step toward fixing macro-defining-macros.  Now identifier can
	  be wrapped with multiple layers, e.g. identifier->name may be
	  another identifier.
	  NB: We may still have places where identifier->name is assumed to
	  be symbol; we need to fix as we find them.

2015-10-15  Shiro Kawai  <shiro@acm.org>

	* src/load.c (Scm__InitLoad): Give *.sld higher precedence to
	  *.sci and *.scm, for it seems the consensus among r7rs.
	  NB: This could pose a problem that if we already have Gauche-optimized
	  library then the user installs r7rs library, the former may be
	  ignored.  In that case, however, we might ask r7rs one to include
	  cond-expand to load Gauche-specific one.

2015-10-14  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (Scm__VMInsnOffsets): Make the offset of insn handlers
	  available without conditional compilation, for easier micro
	  profiling.

2015-10-10  Shiro Kawai  <shiro@acm.org>

	* lib/text/line-edit.scm: Added.
	* examples/line-editor.scm: Sample & test for text.line-edit

2015-10-02  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (user_eval_inner): Use Scm_Exit instead of exit() to ensure
	  flushing output buffers.  This code path is executed only when
	  the C program calls Scm_EvalRec/ApplyRec directly without
	  outer Scm_Eval/Apply.
	  (Scm_VMDefaultExceptionHandler): vm->cstack shouldn't be NULL
	  when this is called, so we use SCM_ASSERT instead of check and exit.

2015-10-01  Shiro Kawai <shiro@acm.org>

	* src/error.c (Scm_ShowStackTrace): Moved to Scheme.
	* src/libeval.scm (%vm-show-stack-trace): Reimplement stack trace
	  printing in Scheme (the actual work is done in %show-stack-trace).
	  Addition: If the expression is the result of macro expansion, show
	  the original source form as well, with its source location.

	* src/libeval.scm (%source-info): Common internal API to extract
	  source info.
	* lib/gauche/vm/debugger.scm (debug-source-info): Rewrote to use
	  %source-info.
	* src/libomega.scm (report-mixin-condition): Ditto.

2015-09-30  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (call-macro-expander): EXPERIMENTAL: Add original
	  source before macro expansion to the pair attribute of the expanded
	  form.  Could be used for better error reporting.

2015-09-26  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (builtin-inliner): Fixed a bug that builtin
	  inliners inserted global identifiers unhygienically.  It caused
	  a problem when (1) a macro expands into a procedure call X with
	  builtin inliner (2) the arguments are such that no optimization
	  can be done, and (3) macro use scope has different global binding
	  of the X.  See the added test in test/module.scm for the concrete
	  case.
	  The case we inserted global identifiers was when we couldn't do
	  do any optimization, so we can just return #<undef> to make
	  pass1/expand-inliner give up the optimization.

2015-09-23  Shiro Kawai  <shiro@acm.org>

	* lib/data/ring-buffer.scm: Added.

2015-09-22  Shiro Kawai  <shiro@acm.org>

	* lib/text/console.scm (getch): Support special keys by parsing
	  vt100 input escape sequences.

	* ext/data/queue.scm (queue-internal-list): This name is better.

	* ext/termios/termios.scm (with-terminal-mode): Turn off port buffering
	  if raw or rare mode is specified.

2015-09-21  Shiro Kawai  <shiro@acm.org>

	* ext/data/queue.scm (queue->internal-list): Add this one,
	  corresponding to srfi-117's list-queue-list.

	* lib/data/trie.scm (trie-exists?): Fix a bug that it returned #t
	  even if the given key doesn't exist, but merely a prefix of
	  other keys.
	  (trie-partial-key?): Added to check if the given seq is a prefix
	  of existing keys.
	  (make-trie): New optional argument, tab-empty?.

2015-09-14  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-112.scm: Added.

2015-09-10  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (iform->sexpr): Use identifier's name instead of
	  just stringify the identifier to reconstruct lvar name, for
	  better-looking output.  Patch from wasao:
	  https://github.com/shirok/Gauche/pull/90

2015-09-09  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-117.scm: Added support of srfi-117.

	* lib/compat/chibi-test.scm: Added to adopt srfi test suite easily.

2015-09-06  Shiro Kawai  <shiro@acm.org>

	* lib/text/info.scm: Modified to parse '(line DDD)' part of the menu
	  entries, so that we can jump to the entry inside a page.
	  (info-extract-definition): New API to extract definition inside
	  a node.
	* lib/gauche/interactive/info.scm (info): Changed to show only the
	  entry looked for.
	  (info-page): This one shows entire info node, as the old info command
	  did.

2015-09-04  Shiro Kawai  <shiro@acm.org>

	* doc/HOWTO-mingw.txt: Renamed from mingw-memo.txt

2015-08-31  Shiro Kawai  <shiro@acm.org>

	* ext/tls: Upgraded to axTLS-1.5.3.

2015-08-23  Shiro Kawai  <shiro@acm.org>

	* lib/text/csv.scm (make-csv-writer): Add special-char-set argument
	  to allow to include wider range of characters to cause the field
	  quoted.

2015-08-22  Shiro Kawai  <shiro@acm.org>

	* src/libio.scm (write, write-shared, display): Allow flexible order
	  of port and write-controls arguments.
	* src/libfmt.scm (format): Allow write-controls to be passed as the
	  argument.  (format [port/control1] [port/control2] fmtstr arg...).

2015-08-21  Shiro Kawai  <shiro@acm.org>

	* src/write.c (Scm_WriteWithControls): Added.  In retrospect, this
	  should be named as Scm_Write(), for it's more generic.
	* src/libio.scm (write, write-shared, display): Accept another optional
	  argument for <write-controls>.

2015-08-18  Shiro Kawai  <shiro@acm.org>

	* src/libio.scm (ScmWriteControls): Made it ScmObj.  We'll
	  eventually drop global (dynamic) write control variables, so
	  the tests are commented out.

2015-08-15  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h, src/gauche/writer.h: Renamed WriteParameter to
	  WriteControls, to avoid confusion with srfi-39 parameters.

2015-08-07  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (macroexpand-all, iform->sexpr): Experimentally added.
	  See the comment for the current limitations.

2015-08-05  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h: Add a new flag SCM_CLASS_AGGREGATE to ScmClass,
	  indicating it represents aggregate type.  A new macro
	  SCM_DEFINE_BUILITIN_CLASS_FLAGS for declaring a class with extra
	  flags.
	* src/vector.c: Make vectors and uniform vectros SCM_CLASS_AGGREGATE.
	* src/write.c (write_rec): Recognize SCM_CLASS_AGGERGATE flag for
	  print-level check.
	* src/gauche/vm.h, src/vm.c (Scm_VMWriteParameter): Accessor.

2015-08-03  Shiro Kawai  <shiro@acm.org>

	* src/libio.scm (print-length, print-level, print-base, print-radix):
	  Added.

2015-08-01  Shiro Kawai  <shiro@acm.org>

	* src/gauche/writer.h: Introduced ScmWriteParameter to keep various
	  write customization parameters - *print-level* etc. in CL.
	* src/gauche/vm.h, src/vm.c: Keep the current ScmWriteParameter
	  in VM.
	* src/write.c: Refer to vm->writeParameters.

2015-07-30  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-118.scm, src/srfis.scm: Added srfi-118.

2015-07-29  Shiro Kawai  <shiro@acm.org>

	* src/read.c (read_num_prefixed): Recognize CL-ish #<radix>r syntax.

2015-07-26  Shiro Kawai <shiro@acm.org>

	* src/portapi.c (seek_istr, Scm_PortSeek): Clear scrcnt when seek
	  happens.  Patch from tomonacchi.

2015-07-23  Shiro Kawai <shiro@acm.org>

	* src/libnum.scm, src/number.c, src/bignum.c: Various fixes from
	  Takeshi Abe: Fix 'exact' for integer around SCM_SMALL_INT_MAX and
	  LONG_MAX; RnRS conformance on (negative? +nan.0), (expt 0 z),
	  (magnitude exact-number).

2015-07-19  Shiro Kawai  <shiro@acm.org>

	* lib/data/random.scm (samples$): Added.

2015-07-18  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm: Avoid generated code from being warned
	  for unused variables or unused labels.

2015-07-17  Shiro Kawai  <shiro@acm.org>

	* src/port.c (Scm_OpenFilePort): Fix an issue that port-tell doesn't
	  return the size of the file write after opening it in append mode.

2015-07-14  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm (%reader): In REPL, read ahead trailing
	  whitespace characters including the first newline after an sexpr;
	  It's been a source of confusion that typing (read-char) or (read-line)
	  on REPL read the trailing newline.

2015-07-13  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/cise.scm (funcall): Add to allow the case
	  when calling a function computed at runtime.

2015-07-10  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/lazy.scm: Add lappend-map
	* libsrc/gauche/generator.scm: Add gflatten

2015-07-05  Shiro Kawai  <shiro@acm.org>

	* lib/text/csv.scm: Add make-csv-header-parser, make-csv-record-parser,
	  csv-rows->tuples.  NB: We removed <csv> definition, for it was
	  never used.

2015-07-02  Shiro Kawai  <shiro@acm.org>

	* ext/tls: Inhibit building & running ssltest when --disable-threads,
	  since the test program requires thread support.  Ideally, even
	  we say --disable-threads, the test program should be able to
	  use threads as long as the system has it; but that requires more
	  trick in build process, so this is a temporary remedy.

2015-06-30  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive/toplevel.scm: Start adding Scheme48-style
	  REPL toplevel commands.  Will play with this for a while to see
	  how it works.

2015-06-27  Shiro Kawai  <shiro@acm.org>

	* src/write.c, src/libio.scm, src/gauche/port.h:
	  Step 2 of improving writer.  Rename port->recursiveContext
	  to port->writeState.

2015-06-26  Shiro Kawai  <shiro@acm.org>

	* src/write.c, src/libio.scm, src/gauche/priv/writerP.h:
	  Step 1 of improving writer.  Made recursive context into an
	  instance of <write-state>.

2015-06-25  Shiro Kawai  <shiro@acm.org>

	* lib/text/console.scm: Add call-with-console to abstract console
	  mode handling
	* doc/modutil.texi: Document text.console.

2015-06-20  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c: Add RE_ANYR, RE_MATCH1R and RE_MATCHR to support
	  the patterns like #/.+/ efficiently.  We should be able to
	  avoid backtrakcking for all rep-while case, but if the repeated
	  element has structure, we'll need another instruction ("if the
	  next immediate element fails, reset input and continue") that
	  requires some modification in VM (we have to save the input pos
	  without consuming stack), so we'll put it off for future.

2015-06-19  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/computil.scm (make-tuple-comparator): Added.

2015-06-09  Shiro Kawai  <shiro@acm.org>

	* src/libnum.scm (fixnum-width): Fix - been misunderstood r6rs spec.

2015-05-29  Shiro Kawai  <shiro@acm.org>

	* lib/data/cache.scm: Added.

2015-05-21  Shiro Kawai  <shiro@acm.org>

	* src/libsys.scm (sys-setgroups): Added.

2015-05-20  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm: Save closure arginfo to ScmCompiledCode.
	  Taking procedure-info of the closure now returns not only
	  the procedure name, but procedure name + formals.

2015-05-17  Shiro Kawai  <shiro@acm.org>

	* src/system.c (nanosleep), src/gauche/system.h (struct timespec):
	  Workaround for the mingw timespec incompatibility.

2015-05-14  Shiro Kawai  <shiro@acm.org>

	* src/load.c (Scm_LoadFromCString): Added.

2015-05-12  Shiro Kawai  <shiro@acm.org>

	* gc/darwin_stop_world.c: Backported iOS 8 support from bdwgc
	  upstream.
	* configure.ac, gc/configure.ac: The above change requires to link
	  CoreFoundation on darwin.  (The upstream bdwgc doesn't have
	  this modification, so there may be another way; if we figure it
	  out, we might revert this change.)

2015-05-10  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/unit.scm (gauche.cgen.unit): Renamed and moved
	  c-safe-string-literal to here as cgen-safe-string, for the
	  consistency.

2015-05-08  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/literal.scm (<cgen-scheme-integer>): Fix
	  cross-compiling issue - we may generate code for 32bit architecure
	  using 64bit gosh.

2015-05-01  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h (SCM_NORETURN): Allow using
	  __attribute__((__noreturn__)) in gcc.

	* lib/gauche/cgen/cise.scm (define-cfn): Allow :inline qualifier.

2015-04-25  Shiro Kawai <shiro@acm.org>

	* lib/gauche/interactive/ed.scm (ed): Add 'ed' in REPL.

2015-04-24  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (%exit): Allow arbitrary Scheme objects for
	  the argument, to conform r7rs.

2015-04-21  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vm/profiler.scm (profiler-show-load-stats): Fix a bug
	  that didn't exclude time for subloads.  Patch from Duy Nguyen.

2015-04-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm (describe): Show the source location
	  for a procedure, if available.

2015-04-13  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/mime.scm -> libsrc/rfc/mime.scm,
	  ext/rfc: Precompile rfc.mime.

2015-04-12  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/json.scm: Updated to follow rfc7159 (allow any value
	  on the toplevel of json).

2015-04-10  Shiro Kawai  <shiro@acm.org>

	* src/genconfig.in: Allow multiple arguments to gauche-config
	  for the convenience.

2015-04-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/record.scm -> libsrc/gauche/record.scm,
	  ext/gauche/Makefile.in: Precompile gauche.record

	* src/libsym.scm (identifier-append): Added (experimental)

2015-04-08  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-78.scm: Added.

2015-04-04  Shiro Kawai  <shiro@acm.org>

	* src/libsym.scm (symbol-append): Added.

2015-03-31  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/sequence.scm (common-prefix, common-prefix-to): Added.

2015-03-30  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (er-comparer): Check if args are variable; without
	  this check, compiler barfs with assertion failure if the user passes
	  non-variable arg to 'compare' proc of er-transformer.

2015-03-28  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass5/emit-local-env-jump),
	  src/vminsn.scm (LOCAL-ENV-SHIFT, BOX),
	  src/vm.c (local_env_shift): Improvement of the last commit - instead
	  of changing BOX behavior to add another 'mode', we split
	  LOCAL-ENV-JUMP insn to LOCAL-ENV-SHIFT + JUMP, and insert boxing
	  operatins inbetween when necessary.  If there's no mutable variable
	  in the frame, we use LOCAL-ENV-JUMP as before.

2015-03-27  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass5/prepare-args, pass5/box-mutable-lvars):
	  Fix incorrect insertion of BOX instruction.  The mutable variable
	  in local environment must be BOXed after all the values in the
	  env are evaluated, otherwise the result would be incorrect if
	  a continuation is captured in one of the init expression of
	  the variable and restarted.  See the added test in test/dynwind.scm
	  to reproduce the issue.  Thansk to @gengar68 for finding the bug.
	* src/vminsn.scm (BOX): We enhanced BOX insn with negative parameter;
	  we need to support both cases of the env frame is already created
	  and is yet to be created.

2015-03-21  Shiro Kawai  <shiro@acm.org>

	* src/gauche-package.in, ext/template.DIST: Retire DIST script;
	  we no longer need autoconf (DIST gen), and DIST tgz is handled
	  by 'gauche-package make-tarball'.

2015-03-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/package/util.scm (find-package-name-and-version): Added.
	* lib/gauche/package/build.scm, src/gauche-package.in:
	  Added "make-tarball" command; this will replace "DIST tgz".

2015-03-19  Shiro Kawai  <shiro@acm.org>

	* lib/util/dominator.scm: Added.  (NB: If we have enough graph-related
	  libraries, we may want to have util.graph.* subcategory).

2015-03-14  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-status-code->description): Added.

2015-03-09  Shiro Kawai  <shiro@acm.org>

	* ext/tls/tls.scm (make-tls): Expose flags and num-sessions argument
	  of ssl_ctx_new to Scheme.  Useful for debugging by giving
	  SSL_DISPLAY_BYTES and/or SSL_DISPLAY_STATES, for example.

	* lib/rfc/uri.scm (uri-ref): added.

2015-03-07  Shiro Kawai  <shiro@acm.org>

	* gc/libatomic_ops/src/atomic_ops/sysdeps/gcc/mips.h:
	  mips64el support.  Patch from James Cogwill.

	* src/gauche/priv/portP.h: Fix race condition in PORT_UNLOCK
	  by adding a memory barrier.  Patch from James Cogwill.

2015-03-06  Shiro Kawai  <shiro@acm.org>

	* ext/sparse/sparse.scm: Add sparse matrix.

2015-03-04  Shiro Kawai  <shiro@acm.org>

	* ext/sparse/spvec.c: Add default value to sparse vectors.

2015-02-24  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/cise.scm: Renamed cgen-context to cgen-ambient,
	  for the term 'context' is also used in the local C context
	  (toplevel, stmt, expr) and confusing.

2015-02-22  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm: During expanding stub procedures
	  (define-cproc etc) we set up a custom cise context to override
	  "return" macro; so that we can say (return something) safely
          in the stub procedures, instead of (result something), which
	  is somewhat awkward.  The difference from C return is that
	  it can handle multiple return values.
	  Note that this 'return' macro really behaves like return---it
	  skips the rest of the procedure, unlike the 'result' macro that
	  merely assigns SCM_RESUT values.  The code that relies the
	  'result' macro to continue execution (which is a bad habit)
	  can't just replace 'result' to 'return'.

2015-02-11  Shiro Kawai  <shiro@acm.org>

	* ext/net/netaux.scm (make-server-sockets): Handle the case when
	  port is 0.  Also avoid using cond-expand, for this file can be
	  precompiled on different platform than the target.

2015-02-10  Shiro Kawai  <shiro@acm.org>

	* ext/net/netaux.scm (make-server-socket): Allow passing multiple
	  ports and let the function choose an available one.

2015-02-03  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/common-macros.scm (and-let1): Allow multiple exprs
	  in body.  Added doc (so it's official).

2015-02-01  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/common-macros.scm (and-let1): Added experimentally.
	  I feel that I wrote single-binding and-let* enough times.

2015-01-31  Shiro Kawai  <shiro@acm.org>

	* ext/vport/vport.scm (open-input-char-list, open-input-byte-list):
	  Added list ports.
	* src/liblazy.scm (port->char-lseq, port->byte-lseq, port->string-lseq)
	  (port->sexp-lseq): Added for the convenience.

2015-01-30  Shiro Kawai  <shiro@acm.org>

	* src/prof.c (Scm_ProfilerStart): Use Scm_TmpDir to get temporary
	  directory, instead of hardcoding "/tmp".

2015-01-29  Shiro Kawai  <shiro@acm.org>

	* src/portapi.c (Scm_UngottenChars, Scm_UngottenBytes): API
	  to retrieve bufferd chars/bytes.  Note that the current getc-ungetc
	  API may be changed in future, so don't rely on these too much.
	  (The semantics of "ungetting" isn't well defined, especially when
	  binary i/o and character i/o are mixed.)
	* src/libio.scm (%port-ungotten-chars, %port-ungotten-bytes):
	  Exposing above in gauche.internal module.

2015-01-24  Shiro Kawai  <shiro@acm.org>

	* lib/text/gap-buffer (text.gap-buffer): Added experimentally.

2015-01-17  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_GetIntegerUMod): Added - a convenience routine to
	  extract lower u_long bits from an exact integer.

2015-01-15  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-69.scm, src/srfis.scm, test/srfi.scm, doc/modsrfi.texi:
	  Added srfi-69 support.

2015-01-14  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/record.scm: Fix a bug when there's one argument
	  given to the custom constructor.

	* src/libvec.scm (%uvector-ref), src/vector.c (Scm_VMUVectorRef):
	  Fixed a bug that leaked #<unbound>.  Patch from wasao.

2015-01-09  Shiro Kawai  <shiro@acm.org>

	* src/compare.c (comparator_compare): Make equal? to compare
	  comparator's elements.

2015-01-08  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-113.scm: Added srfi-113.

2015-01-07  Shiro Kawai  <shiro@acm.org>

	* src/error.c (Scm_ReportError), src/libexc.scm (report-error):
	  Added optional sink argument to specify where the message go.
	  We want to change C API Scm_ReportError accordingly; to keep
	  0.9 ABI compatibility, there's some transient code in place.

2015-01-06  Shiro Kawai  <shiro@acm.org>

	* src/compare.c (Scm_Compare): Handle comparison of different
	  type of objects even if their types are not the one mentioned
	  in srfi-114.

2015-01-02  Shiro Kawai  <shiro@acm.org>

	* doc/corelib.texi (report-error): Documented.

2014-12-31  Shiro Kawai  <shiro@acm.org>

	* ext/threads/threads.c (make-thread): Set custom-error-reporter
	  of newly created thread to suppress the default error message;
	  the unhandled error (which causes error message by default)
	  should be handled by the caller of thread-join!.  If one wants
	  to report an error within the thread, use guard and report-error.

	* src/libeval.scm (%vm-custom-error-reporter-set!): Renamed from
	  vm-set-custom-error-reporter, and moved to gauche.internal module.
	  This is something you don't need to touch daily, so no reason to
	  expose it by default.

	* src/vm.c (Scm_VMDefaultExceptionHandler),
	  src/error.c (Scm_ReportError): Instead of calling
	  vm->customErrorHandler in Scm_ReportError, we lifted the check
	  to Scm_VMDefaultExceptionHandler; if vm->customErrorHandler is
	  set, it is called directly, and Scm_ReportError always print
	  the default message and stack trace.  This seems the sane way
	  to do it - we don't remember why we chose to dispatch inside
	  Scm_ReportError initially.

	* ext/threads/threads.c (Scm_MakeThread): Do not alter
	  customErrorReporter in the new thread.  Instead, we just drop
	  call of Scm_ReportError in thread_entry.  If the programmer
	  needs the thread to report error, she can call report-error
	  within guard clauses.

2014-12-30  Shiro Kawai  <shiro@acm.org>

	* src/gauche/vm.h: INCOMPATIBLE CHANGE: Renamed
	  ScmVM.defaultEscapeHandler for customErrorReporter.  The name was
	  misleading as if it would handle escaping situation caused by
	  exceptions; in fact, we have totally separate mechanism to handle
	  exceptions, and the said slot is merely called by Scm_ReportError,
	  which is the default action when the exception isn't handled at
	  all.
	  ABI compatibility is kept, but any extension code that refers to
	  this slot would break.  Since this is undocumented niche feature,
	  we hope this won't affect much.
	* src/libeval.scm: vm-set-default-exception-handler becomes
	  vm-set-custom-error-reporter, as well.

2014-12-27  Shiro Kawai  <shiro@acm.org>

	* lib/Makefile.in: Don't forget to install srfi-18.scm
	* ext/threads/threads.scm: Re-export current-thread

2014-12-23  Shiro Kawai  <shiro@acm.org>

	* src/module.c: Introduced gauche.keyword module to allow R7RS
	  modules to use keyword default bindings.  See the comment.

2014-12-21  Shiro Kawai  <shiro@acm.org>

	* src/load.c: Support '.sld' suffix by default.

2014-12-18  Shiro Kawai  <shiro@acm.org>

	* configure.ac, ext/*/*.ac, src/Makefile/in, src/genconfig.in:
	  Add --static-libs option to gauche-config, which lists all
	  libraries needed for statically linked binary.

2014-12-17  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/macroutil.scm (with-renaming): Experimentally added
	  a utility to construct the result form within er macro transformer.
	  NB: The old undocumented macros defined in macroutil.scm are removed,
	  for they aren't used much after all.

2014-12-14  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/unit.scm (cgen-safe-name{-friendly}): Allow ':'
	  to be in C name, so that we can call C++ namespace-qualified
	  functions.

2014-12-13  Shiro Kawai  <shiro@acm.org>

	* lib/data/heap.scm (binary-heap-swap-{min|max}!): Added.

2014-12-12  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/configure.scm (parse-command-line-arguments):
	  Made ./configure -V|version option output the package name and
	  the package version in the same format as autoconf-generated
	  configure scripts.

2014-12-09  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/sequence.scm (break-list-by-sequence)
	  (break-list-by-sequence!): Added.

2014-12-07  Shiro Kawai  <shiro@acm.org>

	* ext/sparse/sparse.scm: Added missing generic ref and
	  call-with-iterator methods.

	* libsrc/util/match.scm (in): Fixed a bug that emits incorrect
	  matching code.  See addition in ext/util/test.scm for the
	  specific pattern to exhibit this bug.

2014-12-06  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/dictionary.scm (dict-clear!): Added missing export.

2014-12-05  Shiro Kawai <shiro@acm.org>

	* libsrc/gauche/sequence.scm (sequence-contains): Renamed for clarity.
	  (sequence->kmp-stepper): Expose KMP search element.

2014-12-01  Shiro Kawai  <shiro@acm.org>

	* src/gauche/vm.c (ScmIdentifier):
	* src/compaux.scm (Scm_MakeIdentifier, Scm_OutermostIdentifier)
	  (Scm_UnwrapIdentifier, Scm_IdentifierGlobalBinding):
	  Allow nested identifier, that is, identifier to wrap another
	  identifier.  Will be needed to support nested hygienic macros.
	  This changes the signature of Scm_MakeIdentifier, so
	  various files are touched to accomodate it.

2014-11-30  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/sequence.scm (sequence-scan): Added.

2014-11-29  Shiro Kawai  <shiro@acm.org>

	* lib/data/trie.scm (trie-longest-match): Added.

2014-11-26  Shiro Kawai  <shiro@acm.org>

	* src/libcode.scm (compiled-code-push-info!): Added.
	* src/compile.scm (pass5/lambda): Add 'definition debug info
	  to the compiled code created by $LAMBDA node.
	  (pass1/define): Attach original source code info to
	  the transformed lambda form.
	* lib/gauche/procedure.scm (source-code, source-location): Added.

2014-11-25  Shiro Kawai  <shiro@acm.org>

	* src/error.c (Scm_Warn), src/libmisc.scm (warn): Allow suppressing
	  warning by environment variable GAUCHE_SUPPRESS_WARNING.

2014-11-18  Shiro Kawai  <shiro@acm.org>

	* gc/pthread_support.c (start_mark_threads): Experimantally added
	  code to set up signal masks for parallel marker threads.  Eventually
	  this should be more generalized API and submitted to upstream,
	  but for the time being, let's see if this solves the "lost signal"
	  problem (the issue that delivered signal is discarded when it's
	  delivered to one of the marker threads instead of Gauche threads.)

2014-11-12  Shiro Kawai  <shiro@acm.org>

	* src/gauche/port.h (SCM_PORT_CASE_FOLDING): Renamed the macro name
	  from SCM_PORT_CASE_FOLD, which is the same name for the flag name
	  and could be confusing.

2014-11-11  Shiro Kawai  <shiro@acm.org>

	* src/main.c: Enable -fcase-fold in REPL mode, too (we only had it
	  work on scripts).
	* src/port.c (Scm_GetPortCaseFolding, Scm_SetPortCaseFolding): APIs
	  to get/set port's case folding mode.

2014-11-10  Shiro Kawai  <shiro@acm.org>

	* lib/r7rs.scm (r7rs-import): Warn when a programmer say
	  (import (gauche)) in r7rs program.  It's probably the first
	  attempt for her to use Gauche's builtin bindings in r7rs programs,
	  and it's better to guide her to (import (gauche base)).

	* src/srfis.scm: For built-in srfi modules, make public symbols
	  exported so that r7rs programs can see them with (import (srfi N)).
	  From Gauche programs, those symbols are visible by default since
	  the module inherits the gauche module, so we haven't been careful
	  about exports.  However, with r7rs programs we need to set them up
	  correctly.

2014-11-08  Shiro Kawai  <shiro@acm.org>

	* ext/tls: Upgraded to axTLS-1.5.0.

2014-11-07  Shiro Kawai  <shiro@acm.org>

	* src/gauche/char_utf_8.h (Scm__CharIsExtraWhiteSpace): Do not treat
	  U+180e as a whitespace char.  It was changed from Zs to Cf in
	  Unicode 6.3.0.  (NB: We also need update char_attr.[ch] for
	  char-general-category to reflect the change.)

2014-11-05  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test.scm (test*): Rewrote using er-macro so that
	  importing only 'test*' but not 'test' will still work.

	* src/compile.scm (pass1/define): Rename toplevel identifier inserted
	  by a macro, to keep hygiene.  RnRS does not specify this behavior
	  and implementations make different choices, but it seems that this
	  is the most straightforward way for Gauche to do the right thing.
	  Note that the code relying the (officially undefined) behavior,
	  that macro-injected toplevel binding appear in the macro calling
	  module, will break with this change.

2014-11-04  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test.scm (test-none-of): Added.

2014-11-02  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (%make-er-transormer),
	  lib/gauche/common-macros.scm (er-macro-transformer): Added to
	  give a shot.
	* src/libmod.scm (global-identifier=?, free-identifier=?): Moved
	  from compile.scm

2014-10-30  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_MinMax): Return NaN if any of the arguments is NaN.

2014-10-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/numerical.scm (encode-float): Added.

2014-10-27  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/lazy.scm: Added linterweave.

2014-10-25  Shiro Kawai  <shiro@acm.org>

	* src/port.c: Experimentally allow access port information as
	  slots.

2014-10-23  Shiro Kawai  <shiro@acm.org>

	* src/libdict.scm (combine-hash-value): Expose internal COMBINE
	  to be used from other places.  Not sure yet if this is general
	  enough, so for the time being this is EXPERIMENTAL.

2014-10-22  Shiro Kawai  <shiro@acm.org>

	* lib/data/trie.scm: Renamed util.trie -> data.trie.

2014-10-21  Shiro Kawai  <shiro@acm.org>

	* lib/data/heap.scm: Added find/remove!/delete! operations.

2014-10-20  Shiro Kawai  <shiro@acm.org>

	* lib/data/heap.scm: Using backing storage vector from element 0,
	  by offsetting the index.  It is simpler in terms of API, and
	  in the long run it will win.

2014-10-19  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/sortutil.scm (sorted?): Fixed a bug - the condition of
	  (sorted? (... x y ...)) should be (not (less? y x)) for every
	  consecutive pairs, instead of (less? x y).  For example,
	  (sorted? '(1 1) <) should be #t.
	* lib/gauche/sortutil.scm, lib/gauche/generic-sortutil.scm:
	  Accept comparators as well as less-than procedure.

2014-10-18  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vecutil.scm (vector-tabluate): Made it restart-safe.
	  (reverse-list->vector): Implement in core instead of srfi-43.
	* test/vector.scm: Added.

2014-10-17  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/computil.scm: Changed make-field-comparator to
	  make-key-comparator, for the consistency.

2014-10-16  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/computil.scm: Added make-reverse-comparator,
	  make-field-comparator, make-car-comparator and make-cdr-comparator.

2014-10-13  Shiro Kawai  <shiro@acm.org>

	* lib/data/heap.scm: EXPERIMENTAL: Added binary min-max heap.

2014-10-11  Shiro Kawai  <shiro@acm.org>

	* ext/sparse/*: Renamed util.sparse -> data.sparse.

2014-10-10  Shiro Kawai  <shiro@acm.org>

	* src/libcmp.scm: Add srfi-114 primitive applicators as SUBR,
	  for the performance.
	* lib/gauche/cgen/cise.scm: Make logand, logior and logxor n-ary.

2014-10-09  Shiro Kawai  <shiro@acm.org>

	* ext/sparse/sparse.scm: Allow make-sparse-table to take comparator.
	  Add sparse-table-comparator and sparse-vector-comparator to
	  conform new dictionary protocol.

2014-10-08  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/dictionary.scm (dict-comparator): A new dictionary
	  protocol API to retrieve a comparator.  It is useful to implement
	  generic meta-operations on dictionaries.

2014-10-07  Shiro Kawai  <shiro@acm.org>

	* src/libdict.scm (%make-tree-map),
	  lib/gauche/treeutil.scm (make-tree-map): Save a comparator
	  instead of closure in core->data field.
	* src/libdict.scm (tree-map-comparator): Added to retrieve
	  the comparator.

2014-10-06  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/treeutil.scm (make-tree-map): Allow to take a
	  comparator.

2014-10-05  Shiro Kawai  <shiro@acm.org>

	* src/hash.c, src/libdict.scm: Support general hash table
	  using comparators.

2014-10-04  Shiro Kawai  <shiro@acm.org>

	* src/libproc.scm (applicable?): Moved from lib/gauche/procedure.scm.
	  Needed in core in order to construct built-in comparators.

	* src/libalpha.scm (case-lambda-info): Encapsulate interpretation
	  of case-lambda dispatch vector in this procedure, so that other
	  parts won't depend on the structure of the dispatch vector.
	* lib/gauche/procedure.scm (disasm): Changed accordingly.

2014-10-03  Shiro Kawai  <shiro@acm.org>

	* src/libsys.scm (sys-sleep, sys-nanosleep): Changed to retry
	  sleep/nanosleep by default if it is interrupted by as signal.
	  They can be interrupted very often, for GC may use signals
	  to synchronize threads.  We assume it's very unlikely that
	  there are programs that relies on the previous behavior,
	  but if you do need those procedures to return by signals,
	  give #t to the optional argument.

2014-10-02  Shiro Kawai  <shiro@acm.org>

	* src/cross-compile-ios.scm: A script to compile Gauche as an iOS
	  framework.  This is kind of old---tested on 2013/07 with iOS6
	  and haven't updated since then.  Just put it in repo for
	  a reference.

2014-10-01  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/computil.scm : Added.  Provides some basic comparators.
	* src/autoload.scm: Autolaod computil.scm

2014-09-29  Shiro Kawai  <shiro@acm.org>

	* src/compare.c (Scm_Compare): Handle complex number ordering.

2014-09-28  Shiro Kawai  <shiro@acm.org>

	* src/compare.c (Scm_Compare): Implement ordering of different types,
	  according to srfi-114.

2014-09-27  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (define-syntax): Fix the case when toplevel
	  macro is inserted by another hygienic macro.  We may need to
	  revisit interpretation of toplevel identifier renaming; see
	  the comment in pass1/define.

2014-09-26  Shiro Kawai  <shiro@acm.org>

	* src/compare.c (Scm_Compare), src/vector.c, src/symbol.c: Enhanced
	  domain of Scm_Compare to support srfi-114.  Now booleans, lists,
	  symbols, vectors and uvectors can be compared each other.
	* src/libcmp.scm (comparator-*): Added some srfi-114 comparator API.

2014-09-25  Shiro Kawai  <shiro@acm.org>

	* src/libvec.scm: Added uvector?

2014-09-24  Shiro Kawai  <shiro@acm.org>

	* ext/util/queue.scm, ext/data/queue.scm: util.queue -> data.queue.

2014-09-23  Shiro Kawai  <shiro@acm.org>

	* ext/math/mt-lib.stub: Merged to mt-random.scm

2014-09-22  Shiro Kawai  <shiro@acm.org>

	* ext/gauche/fcntlib.stub: Merged to fcntl.scm

2014-09-21  Shiro Kawai  <shiro@acm.org>

	* ext/zlib/zliblib.stub: Merged to zlib.scm

2014-09-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm (without-precompiling): Added a special
	  directive to put the forms into *.sci file, without precompiling them.
	  If we want to cond-expand at load time, we can't precompile it.

	* ext/termios/termiolib.stub: Merged to termios.scm
	* ext/binary/binarylib.stub: Merged to io.scm

2014-09-19  Shiro Kawai  <shiro@acm.org>

	* examples/snake.scm: Added a sample of text.console.

2014-09-18  Shiro Kawai  <shiro@acm.org>

	* lib/text/console.scm: Added.  Still unofficial & experimental.

2014-09-16  Shiro Kawai  <shiro@acm.org>

	* ext/termios/termios.scm (with-terminal-mode): Experimentally added.

2014-09-15  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm (describe): Improve output of
	  (describe <generic>).

2014-09-13  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h (SCM_FOREIGN_POINTER_REF): Calls Scm_ForeignPointerRef.
	* src/class.c (Scm_ForeignPointerRef, Scm_ForeignPointerInvalidP)
	  (Scm_ForeignPointerInvalidate): Added.  When the object pointed
	  by a foreign pointer became obsoleted (e.g. freed), you can mark
	  the foreign pointer "invalid", so that the subsequent dereference
	  of the pointer raises an error.
	* src/libmisc.scm (foreign-pointer-invalid?, foreign-pointer-invalidate!):
	  Scheme interface for the above.

	* ext/windows/console.stub (sys-set-screen-buffer-size): Fixed a bug.

	* ext/vport/vport.scm (open-output-uvector):
	  Allow option to make the output buffer extendable.
	  (get-output-uvector): Added to enable retrieving the accumulated
	  result, needed when the buffer is extendable.
	* lib/r7rs.scm (open-output-bytevector, get-output-bytevector):
	  Rewritten using above.

2014-09-12  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm (define-cptr): Fix a bug that passes
	  unboxer and boxer names in reverse (thanks to KOGURO Naoki).

	* ext/uvector/uvector.scm (uvector-class-element-size)
	  (uvector-copy): Added.

2014-09-11  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvector.scm (make-uvector): Added generic uvector
	  constructor.

	* ext/template.configure: FIX: Added missing default_prefix setup.

	* src/error.c (Scm_Raise), src/libexc.scm (raise),
	  src/vm.c (Scm_VMThrowException): The last fix of r7rs#raise
	  wasn't enough, for it invoked the second error with the same
	  exception handler as the first raise.

2014-09-10  Shiro Kawai  <shiro@acm.org>

	* lib/r7rs.scm (raise): Adjust r7rs#raise to be compatible with r7rs,
	  instead of using gauche#raise (srfi-19 compatible).

2014-09-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vecutil.scm (vector-for-each, vector-for-each-with-index):
	  Fix bugs when more than one vectors are given.

	* lib/gauche/common-macros.scm (dotimes): Return #<undef> unless
	  the result clause is provided.  It doesn't really matter, but better
	  to make it explicit that the return value is undefined.

2014-09-07  Shiro Kawai  <shiro@acm.org>

	* src/module.c (Scm_ImportModule): Fix a bug in dupe elimination
	  of imported modules.  We should allow modules that have the same
	  origin, for they may have different qualifications; in such a case,
	  eliminating one will change the semantics.

2014-09-06  Shiro Kawai  <shiro@acm.org>

	* lib/Makefile.in: Don't forget to install gauche/base.scm.

	* ext/util/queue.scm (dequeue-int): Clear the slots of dequeued
	  pair, to ensure weak-GC safety.
	* lib/text/html-lite.scm: Support HTML5 elements and doctype
	  (patch from Takashi Fujita).

2014-09-04  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_StringToNumber): Allow '_' to be inserted between
	  digits when a number is explicitly prefixed.  This is for the
	  readability, e.g. #b1101_1000_0001_1101 etc.  We don't allow
	  unprefixed numbers, though, for the possible incompatibility
	  (e.g. 3_2 may be interpreted as a symbol.)

2014-09-03  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm (describe): When object is char or integer,
	  print alternative representation / useful info if relevant.

2014-08-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm (handle-define-syntax): Allow
	  Scheme-defined low-level macro transformer to be compiled
	  into *.c file, instead of emitting it to *.sci file.

	* src/libmod.scm (%insert-syntax-binding): Added.  Currently our
	  runtime don't distinguish toplevel value binding and syntax binding,
	  so %insert-binding can do both, but in future we may treat syntactic
	  binidng specially.
	* src/compile.scm: Changed accordingly.

2014-08-24  Shiro Kawai  <shiro@acm.org>

	* src/gauche/macro.h -> src/gauche/priv/macroP.h: Moved macro
	  implementation details to private header.  ScmSyntax and
	  ScmMacro should be treated as opaque objects.  Various files
	  adjusted.
	* src/macro.c (Scm_MakeMacro): Changed ScmMacro structure and
	  the signature of Scm_MakeMacro.  Now ScmMacro is simply a wrapper
	  of macro transformer (Sexpr, Env -> Sexpr), with an optional
	  name.   Technically this is an incompatible change, but we
	  expect nobody was directly using this interface.
	  We also change the way the macro expander is called; we pass
	  CENV, instead of a list frames, to the expander procedure.
	  This was never specified explicitly, and actually we had it wrong---
	  tye synrule expander expected frames, and the primitive expander
	  expected cenv.  It happened to work because we hadn't used env
	  argument of primitive-expander yet.
	* src/libeval.scm (macro-transformer): Added.
	  (call-macro-expander): Pass CENV to the third arg.

2014-08-23  Shiro Kawai  <shiro@acm.org>

	* src/macro.c (Scm_VMMacroExpand): Obsoleted.  Implement it in
	  compile.c (%internal-macro-expand).
	* src/libeval.scm (macroexpand, macroexpand-1): Changed accordingly.

2014-08-21  Shiro Kawai  <shiro@acm.org>

	* src/error.c (Scm_PrintDefaultErrorHeading),
	  src/libexc.scm (print-default-error-heading): Implement this in
	  Scheme for the better maintainability.
	* src/libomega.scm (report-mixin-condition): Generalized handling
	  mixin conditions.
	  Note: The above two changes may be a dangerous move, which
	  can make it difficult to diagnose when we mess up then runtime
          in a way that error reporting can't be carried out.  Especially,
	  now we rely on working method dispatch to display mixin condition
	  messages.  If this becomes an issue, we may replace the mixin
	  condition mechanism to more primitive ones, like manual dispatch.
	* src/libexc.scm (<compile-error-mixin>),
	  src/compile.scm (compile): Handle compile error using mixin
	  condition.

2014-08-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/exception.h, src/error.c (<load-condition-mixin>):
	  Added a mixin condition type to attach load context to
	  errors occurred during loading.
	  (Scm_PrintDefaultErrorHeading): Add load context information
	  when available.
	  (Scm_ExtractSimpleCondition): Added.
	* src/libeval.scm (load-from-port): Intercept a thrown condition to
	  attach <load-condition-mixin>.

	* lib/gauche/test.scm (<test-error>, test-check): Checks the
	  result condition considering compound conditions.  In order to
	  use condition-has-type?, now <test-error> instance holds
	  the actual condition object.
	* lib/gauche/condutil.scm, src/libomega.scm: Moved
	  definition of (slot-missing <condition-meta> <compound-condition>
	  <top>) from the former to the latter; Slots of compound conditions
	  may be referred without condutil being autoloaded.

2014-08-19  Shiro Kawai  <shiro@acm.org>

	* lib/binary/pack.scm (make-packer): Made cached? argument :optional
	  for the consistency with the doc.

2014-08-18  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (primitive-macro-transformer): Added experimentally;
	  the plan is to build all other macro system on top of this.  See
	  if it's feasible.
	  (cenv-lookup-variable, cenv-lookup-syntax, env-lookup): Split
	  cenv-lookup into these APIs; mainly to avoid construction of
	  temporary cenv when we already have module and frames separately.
	* src/libmod.scm (id->bound-gloc): Moved from compile.scm.
	* src/macro.c (Scm_MakeMacroTransformer): Changed signature of
	  the transformer - now it takes form and macro-use environment.

2014-08-16  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (ensure-identifier): Properly capture the environment
	  into the created identifier.
	  (%bind-inline-er-transformer): Fix incorrect initialization of
	  cenv.
	  (%attach-inline-er-transformer): Make compare closure work.
	  (free-identifier=?): Added.

2014-08-14  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_AvailableProcessors),
	  src/syslib.scm (sys-available-processors): Added to query # of
	  available processors.

2014-08-13  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vm/debugger.scm (debug-funcall), src/read.c (#?,):
	  Experimentally added a new debug form, #?,(proc arg ...).  Unlike
	  debug-print (#?=), this displays the value of arg ....

2014-08-11  Shiro Kawai  <shiro@acm.org>

	* src/load.c, src/libeval.scm (load-from-port): Rewrote load-from-port
	  in Scheme.  Scm_VMLoadFromPort is no longer used.  An internal
	  procedure Scm__RecordLoadStart is also obsoleted.
	  Also dropped LOAD_MAIN_SCRIPT flag.  This flag is introduced on
	  2011-01-02, but has never been used, and never been officially
	  announced.

2014-08-10  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h etc.: Removed pre-0.9 compatibility macro definitions.
	  It's been almost 5 years since 0.9 release and it's about time.
	  The compatibility routines (*Compat()) are kept in *.c file so
	  that the old compiled binaries keep working until 1.0 release.
	  However, newly compiled binaries should adopt 0.9 API.

	* libsrc/util/match.c: Fixed a bug that doesn't handle match
	  expressions generated by hygienic macros.  The `quote' in
	  patterns may become an identifier in the macro output.

2014-08-09  Shiro Kawai  <shiro@acm.org>

	* src/symbol.c: Enabled support of symbol-keyword unification,
	  though it's off by default for the backward compatibility.
	  Setting environment variable GAUCHE_KEYWORD_IS_SYMBOL turns on
	  the feature.  At some point in future we flip the default,
	  so the feature will be on by default, and setting enviornment
	  variable GAUCHE_KEYWORD_DISJOINT turns off.

2014-08-07  Shiro Kawai  <shiro@acm.org>

	* src/write.c (Scm_Write): Avoid using srfi-38 notation if
	  (display <string>) is called within write-shared.  It doesn't
	  contribute readability at all (since you can't know what the
	  label refers), and sometimes interferes with user-defined
	  object writer.

2014-08-04  Shiro Kawai  <shiro@acm.org>

	* ext/termios/termiolib.stub (sys-termios-copy): Added.

2014-08-02  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/*, src/vector.c: Restructured the sources.
	  Now we name the resulting DSO as gauche--uvector.so, consistent
	  to other extension modules.  IMPORTANT: This means we no longer
	  allow other extension modules to link with -lgauche-uvector.
	  We used to need it for extension modules to access uvector features,
	  but now the basic uvector support is in the core and we no longer
	  need it.  Besides, building one SO for both dlopen and -l linking
	  doesn't work on OSX.  Some legacy extension modules may still
	  referring -lgauche-uvector; they should be updated.
	  Since gauche--uvector.so is now purely accessed through Scheme,
	  it doesn't make sense to provide full line of C API; so some of
	  them are folded into define-cproc.
	  The uvector reader is moved to src/vector.c as well, so that
	  reading uvector literals won't cause autoloading gauche.uvector.

2014-07-31  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvlib.stub.tmpl (string->[us]32vector!): Added.

	* src/load.c, src/gauche/load.h: Turn dlobj record to ScmObj.  This
	  is for better introspection, and for preparation of exposing dlopen
	  to Scheme.

2014-07-29  Shiro Kawai  <shiro@acm.org>

	* src/srfis.scm: Consolidate info of supporting srfis in one file,
	  to generate files that need to reflect the info.
	* ext/srfi/generate-srfi.scm: Superseded by src/srfis.scm

2014-07-28  Shiro Kawai  <shiro@acm.org>

	* src/libmisc.scm (box etc.): srfi-111 support.  This is merely to
	  expose internal box object to the Scheme world.  We still use
	  srfi-111 namespace, though.
	* src/box.c (box_compare): compare contents.

2014-07-27  Shiro Kawai  <shiro@acm.org>

	* src/libomega.scm, src/load.c: Mark all built-in modules as provided,
	  so that (use <built-in-module>) won't complain.  This used to be
	  done in load.c, but we kept the module list separately which had
	  gone out-of-sync.

2014-07-24  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/configure.scm (parse-command-line-arguments): Fix
	  handling --enable-*, --disable-*, --with-* and --without-* options.

2014-07-23  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/base.scm: Split gauche.base form r7rs.scm, for it may
	  be used from Gauche code by (use gauche.base); see the document
	  for the use case.

2014-07-22  Shiro Kawai  <shiro@acm.org>

	* src/module.c (search_binding): Fixed a bug - when a module exports
	  an inherited binding with renaming, it wasn't searched properly.
	  Another bug fix - if phantom binding is exported with renaming,
	  and then renamed on import, this bug sufraces.

2014-07-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/configure (cf-make-gpd): A cf api to generate gpd file.
	  (cf-echo): Fix a bug that drops last two arg if the output is not
	  redirected (thanks to KOGURO Naoki).  Also made it appear in
	  config.log.
	* ext/template.configure: Added call to cf-make-gpd.

	* ext/template.Makefile.in (maintainer-clean),
	  src/gauche-package.in (generate): Do not delete
	  configure in maintainer-clean if we create skeletons to use
	  gauche.configure.

2014-07-19  Shiro Kawai  <shiro@acm.org>

	* release 0.9.4

	* lib/gauche/configure.scm (check-for-program): Fixed a bug that refer
	  to the variable 'paths' that's being defined, i.e.
	  (define paths (... paths ...)).

2014-07-18  Shiro Kawai  <shiro@acm.org>

	* src/libio.scm, lib/r7rs.scm (read-string): Support R7RS-compatible
	  read-string in the core.
	* ext/text/parse.scm (read-string): Redefined on top of built-in
	  read-string.

2014-07-16  Shiro Kawai  <shiro@acm.org>

	* src/macro.c (compile_rules): Allow syntax-rules to have no rules,
	  as the spec permits.

	* lib/scheme/*.scm: Placed dummy modules to use R7RS stdlibs
	  from Gauche

2014-07-14  Shiro Kawai  <shiro@acm.org>

	* lib/r7rs.scm, src/libvec.scm: Moved vector->string and string->vector
	  from r7rs to core, for less confusion.

2014-06-25  Shiro Kawai  <shiro@acm.org>

	* src/read.c (read_internal): In strict-r7 reader mode, read :foo
	  as a symbol.  This would be unnecessary once we make keywords
	  a subtype of symbols, but for now, it would help using third-party
	  r7rs libraries.

2014-06-22  Shiro Kawai  <shiro@acm.org>

	* ext/windows/console.stub (sys-fill-console-output-attribute)
	  (sys-fill-console-ouptut-character, sys-flush-console-input-buffer):
	  Added.
	  (<win:input-record>): Made key.virtural-key-code return
	  VirtualKeyCode, and let key.virtual-scan-code return
	  VirtualScanCode.
	  (sys-read-console-input): Fix.
	  Patch from https://github.com/Hamayama.

2014-06-21  Shiro Kawai  <shiro@acm.org>

	* src/read.c: Split reader-lexical-mode from <read-context> and made
	  it an individual parameter.  The mode can be changed during Scm_Read()
	  if we encoundter #!r7rs etc., so it doesn't work to carry the info
	  inside read-context.
	* src/load.c, src/libio.scm: Changed accordingly.

2014-06-20  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-42.scm: Incorporated bug fixes in srfi-42 reference
	  implementation.

2014-06-18  Shiro Kawai  <shiro@acm.org>

	* gc/*: Updated to gc-7.4.2 (libatomic_ops stays 7.4.2)

2014-06-05  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_GetDouble): exact->inexact conversion didn't
	  work in denormalized range.
	  (Scm_EncodeFlonum): Added as an inverse of Scm_DecodeFlonum;
	  not made public in the header yet.

2014-05-25  Shiro Kawai  <shiro@acm.org>

	* configure.ac: Add -static-libgcc flag when building DLLs on MinGW,
	  in ordre to avoid dependency on libgcc_s_dw2-1.dll.

2014-05-21  Shiro Kawai  <shiro@acm.org>

	* gc/*: Updated to gc-7.4.0 and libatomic_ops-7.4.2

2014-05-16  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h, src/string.c (SCM_STRDUP, SCM_STRDUP_PARTIAL): Added
	  these, for I felt I wrote SCM_MALLOC+memcpy too many times.
	* src/dl_win.c, src/port.c, src/system.c: Changed accordingly.

2014-05-15  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_GetEnv): Provide a wrapper so that we can mutex
	  getenv/putenv properly.

2014-05-09  Shiro Kawai  <shiro@acm.org>

	* src/win-compat.c (mbs2wcs, wcs2mbs): Allow libgauche version of
	  those functions to choose allocator; we need to malloc (instead
	  of GC_alloc) if we pass the resulting string to OS.

2014-05-07  Shiro Kawai  <shiro@acm.org>

	* src/main.c (main): Changed handling of command-line args on Windows
	  so that it can get wide characters properly.   Based on a patch
	  from SAITO Atsushi.

2014-05-05  Shiro Kawai  <shiro@acm.org>

	* ext/text/unicode.scm (%foldcase): Fixed string-foldcase behavior.
	  See the discussion in R7RS mailing list:
	  http://lists.scheme-reports.org/pipermail/scheme-reports/2014-May/004055.html
	* test/r7rs-tests.scm: The test for string-foldcase was incorrect.
	  Fixed along above.

2014-05-01  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvlib.stub.tmpl (u8vector->string, s8vector->string):
	  Avoid copying the content when the source vector is immutable and
	  certain conditions are met.  See the comment in bytevector->string
	  for the details.

2014-04-29  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvlib.stub.tmpl (string->u8vector, string->s8vector):
	  Added optional immutable? flag; if #t, the result vector becomes
	  immutable, and we avoid copying the string body.

2014-04-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/common-macros.scm (unwind-protect): Fixed the bug that
	  cleanup clause wasn't called when applications exit within the body.

2014-04-27  Shiro Kawai  <shiro@acm.org>

	* src/libio.scm (close-port, call-with-port): Support these r7rs procs
	  natively.  They're useful.  (Actually, we didn't have call-with-port
	  even in r7rs module; it was an oversight.)

2014-04-17  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/json.scm (%unicode, print-string): Properly support
	  unicode surrogate pairs.

2014-04-12  Shiro Kawai  <shiro@acm.org>

	* src/write.c (Scm_Write): Fixed a race condition that, while
	  one thread was in circular-safe writing mode, another thread's
	  call to Scm_Write mistook that it was within recursive Scm_Write
	  call.

2014-04-09  Shiro Kawai  <shiro@acm.org>

	* configure.ac: Add -DUNICODE when compiling MinGW with utf-8 encoding.
	  src/genconfig.in, src/gauche/win-compat.h, src/port.c, src/system.c,
	  src/win-compat.c: Fixes to enable mbs2wcs/wcs2mbs stuff and *W
	  windows API to deal with unicode pathnames.  Based on a patch
	  by SAITO Atsushi.

2014-04-05  Shiro Kawai  <shiro@acm.org>

	* src/compare.c, src/gauche/compare.h, src/libcmp.scm: Start
	  adding comparator (srfi-114) experimentally.

2014-04-04  Shiro Kawai  <shiro@acm.org>

	* src/libbool.scm (eq-compare): Added.

2014-03-20  Shiro Kawai  <shiro@acm.org>

	* lib/www/css.scm: Added.  Still experimental.

2014-03-06  Shiro Kawai  <shiro@acm.org>

	* ext/tls/tls.c, ext/tls/tls.scm (tls-destroy): Added explicit
	  destruction of TLS context.  An axtls context grabs an fd for
	  /dev/urandom, and sometimes GC isn't triggered often enough
	  before unfinalized contexts use up all fds.
	* lib/rfc/http.scm (shutdown-secure-agent): Destroy TLS context.

2014-03-01  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_ClockGetTimeMonotonic, Scm_ClockGetResMonotonic),
	src/libsys.scm (sys-clock-gettime-monotonic, sys-clock-getres-monotonic):
	  Added monotonic time clock to be used for TAI time.  If the system
	  doesn't provide clock_gettime()/clock_getres(), these API return
	  special values, so that the caller can make up whatever fallback
	  values suitable for their needs; the gist is that it's often easier
	  to implement fallback in Scheme.

2014-02-27  Shiro Kawai  <shiro@acm.org>

	* src/libfmt.scm (with-format-params): Fixed a bug in 'v' formatter
	  parameter handling; we shouldn't set! to the variable for the
	  parameter, since a formatter can be called multiple times and
	  every time we should fetch from the arglist.

2014-02-22  Shiro Kawai  <shiro@acm.org>

	* lib/r7rs.scm (gauche.base): Added gauche.base module to allow
	  R7RS programs to access Gauche's builtin bindings by
	  (import (gauche base)).  See the comment for the reason we don't
	  simply export bindings from the gauche module.

2014-02-20  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (%repl-print): Changed to use write (r7rs write,
	  which doesn't show shared structure but does show cycles) in the
	  default REPL.  Showing shared structure by default has been a source
	  of confision for newcomers; now we can avoid that, yet we can
	  retain circular-safety.

2014-02-13  Shiro Kawai  <shiro@acm.org>

	* ext/peg/peg.scm: Consolidated $<< and $fmap and renamed to $lift.
	  Allow $->rope, $->string, $->symbol to take multiple parsers.
	* lib/rfc/json.scm: Changed accordingly.

2014-02-11  Shiro Kawai  <shiro@acm.org>

	* src/gauche-package.in: Switched using Gauche-based configure
	  script by default in 'gauche-package generate',
	  unless --autoconf option is given.

	* lib/gauche/configure.scm: Added cf-arg-with, cf-arg-enable, and
	  cf-help-string.  Put more stuff in usage.

	* src/libmisc.scm (warn), src/error.c (Scm_FWarn): Rewrote 'warn'
	  in Scheme, avoiding calling obsoleted Scm_Format.  Also obsoleted
	  Scm_FWarn.

2014-02-10  Shiro Kawai  <shiro@acm.org>

	* src/libmod.scm (import): Added user#import that dispatches either
	  gauche#import or r7rs#import, to support r7rs script natively.

2014-02-07  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_NumCmp): Fixed Scm_NumCmp when comparing a flonum
	  and an exact bignum or ratnum.  In that case we need to convert
	  the flonum to exact (as opposed to converting exact one to inexact),
	  for the latter would break transitivity of '='.

2014-02-06  Shiro Kawai  <shiro@acm.org>

	* src/core.c (init_cond_features): Added r7rs feature identifier.

	* src/write.c, src/libio.scm: Changed the default behavior of
	  'Scm_Write' and 'write' alinged to r7rs, that is, it detects
	  circular structures and use datum labels.  'Display' also does
	  2-pass circular detection.   The original 'write' behavior
	  is realized by 'write-simple'.  SRFI-38 behavior is still
	  realized by write/ss and write*, which are merely alises of
	  r7rs 'write-shared'.

	  The 'mode' of Scm_Write and ScmWriteContext is slightly modified
	  to adopt this change; now, SCM_WRITE_WRITE works as the updated
	  'write' (circular-safe), and SCM_WRITE_SHARED works as 'write-shared'.
	  To get 'write-simple' behavior you have to specify SCM_WRITE_SIMPLE.

	  To distinguish circular-only and shared mode, we have to
	  add that info to the port flags as well, for the write context
	  info isn't passed to the user-defined write-object.  SCM_PORT_WRITESS
	  flag is used for the purpose (the meaning of flag has been
	  changed).

2014-02-05  Shiro Kawai  <shiro@acm.org>

	* src/read.c (char_word_constituent): Refined checking symbol
	  constituent characters beyond ASCII range, following R6RS.
	  For example, \u3000 followed by 'a' used to be a part of
	  symbol, but now it correctly delimits a symbol 'a'.

2014-02-04  Shiro Kawai  <shiro@acm.org>

	* src/write.c, src/libfmt.scm (format): Rewrote format in Scheme.
	  NB: We might reconsider the semantics of format/ss; the output
	  of format is usually unreadable by 'read', so using srfi-38
	  notation isn't really a point.  The point of format/ss is to
	  guarantee that it returns even if the arg has circular structure.

2014-02-02  Shiro Kawai  <shiro@acm.org>

	* src/port.c, src/libio.scm (with-port-locking): Moved the definition
	  from C to Scheme.

	* src/write.c, src/port.c, src/portapi.c, src/read.c: Another step
	  to improve the writer.  Now we don't create a dummy 'walker' port,
	  for merely marking the port->flags suffice.  Also placed a cleanup
	  procedure to remove transient stuff from the port.

2014-02-01  Shiro Kawai  <shiro@acm.org>

	* src/boolean.c (Scm_EqualP), src/libbool.scm (%interleave-equal?):
	  Made equal? to handle cyclic structures, as specified in R[67]RS.
	  For the time being, we don't consider cycles involving user-defined
	  objects and object-equal? method.

	* src/vminsn.scm (LREF-UNBOX): Added.

2014-01-31  Shiro Kawai  <shiro@acm.org>

	* src/code.c, src/vminsn.scm, src/geninsn, lib/gauche/vm/insn-core.scm:
	  The instruction combiner now allows preceding specialized LREFs
	  such as LREF0 or LREF21 to be combined into generic LREF-STNG(n,m)
	  (instead of having LREF0-STNG, LREF21-STNG, etc. separately).
	  Such combined insn is indicated by :fold-lref flag.

2014-01-30  Shiro Kawai  <shiro@acm.org>

	* src/vm.c, src/vminsn.scm (UNBOX), src/compile.scm: Finishing explicit
	  boxing/unboxing.  NB: Although this fix makes the compile emit
	  necessary BOX/UNBOX instructions for set!-table lvars, we do not
	  drop implicit unboxing feature yet, since 0.9.4 compiler and runtime
	  are compiled by 0.9.3.3 compiler that doesn't emit UNBOX insns.
	  See the comment about auto-unboxing in vm.c; we'll remove
	  auto-unboxing stuff once we release 0.9.4.
	* test-0.9.4.sh: A temporary shell script to test BOX/UNBOX stuff.
	  Ordinary test run doesn't test this, since 0.9.4 build still use
	  implicit unboxing.  This shell script build 0.9.4, then build it
	  again _using_0.9.4_compiler_, so that we can test BOX/UNBOX thingy.
	  We'll remove this script once we release 0.9.4.

2014-01-28  Shiro Kawai  <shiro@acm.org>

	* src/vminsn.scm (BOX): Changed to be used to box procedure parameters.
	  (ENV-SET): New instruction to initialize env slot (used with
	  LOCAL-ENV-CLOSURES). 	 We used to use LSET, but we'll box all
	  set!-able lvars and LSET will do set-box! instead of directly setting
	  env slot.
	* src/compile.scm: Changed to emit ENV-SET and new BOX insn.

	* src/geninsn, lib/gauche/vm/insn-core.scm: Allow insn definitions
	  to have alternative num-params, so that we can build Gauche
	  using the previous version of Gauche even if we change the
	  num-params of insns.

2014-01-27  Shiro Kawai  <shiro@acm.org>

	* lib/www/cgi.scm (read-complete-block): Fixed a bug in the case
	  when content-length is zero.

2014-01-19  Shiro Kawai  <shiro@acm.org>

	* src/gauche/vm.h (ScmContFrame): Added a slot to save current PC.
	  This isn't needed for execution, but useful to get a sensible
	  stack trace.
	  In a sense, this info records "who created this continuation?".
	  A concern is the impact on the performance, for we have one extra word
	  to push for each continuation.  Let's see how it goes.

2014-01-12  Shiro Kawai  <shiro@acm.org>

	* src/write.c: Rewriting to clean up the control flow regarding recursive
	  situation.  The recursive context should be solely held in the port,
	  not in the write context.  The slot name of the port is renamed
	  from 'data' to 'recursiveContext' to indicate the role.
	  Obsoleted Scm_WriteCircular, for it can be handled by either
	  Scm_Write or Scm_WriteLimited.

2014-01-07  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm: Bind auxiliary syntactic keywords to a dummy
	  expander; it'd be easier to work with modules if we have toplevel
	  bindins instead of leaving them undefined.

2013-12-30  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test.scm (closure-grefs): Include PUSH-GREF-CALL
	  and PUSH-GREF-TAIL-CALL insns to check arity mismatch.

2013-12-24  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (import): Show a descriptive error message when
	  Gauche's import is called as if R7RS import.

2013-12-22  Shiro Kawai  <shiro@acm.org>

	* src/genconfig.in: Add site-specific directories to --incdirs and
	  --archdirs options.  Some extention libraries (e.g. Gauche-gl)
	  installs header files and DSOs there, and libraries depending
	  on them need to see them at compile time.

2013-12-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/dictionary.scm (make-bimap, bimap-put!): Allow bimap
	  to have the default on-conflict setting.

2013-12-19  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-106.scm (*ai-v4mapped*): Workaround for the platforms
	  where AI_V4MAPPED may not be defined even if ipv6 is provided.

2013-12-13  Shiro Kawai  <shiro@acm.org>

	* src/libnum.scm (sqrt): Improved performance.  We did extra sqrt
	  calculation when the arg was exact but not a square of exact number.

2013-11-27  Shiro Kawai  <shiro@acm.org>

	* lib/www/cgi.scm (cgi-get-query): Fixed a bug that caused the
	  procedure not to retrieve the entire POST request body, if
	  the input port wasn't fully buffered.

2013-11-26  Shiro Kawai  <shiro@acm.org>

	* libsrc/srfi-13.scm (string-filter, string-delete): We noticed that
	  we got the argument order of these wrong for long time.  The order
	  is corrected, but to support code written for the old order, we
	  permit the caller to use the old API as well.

2013-11-24  Shiro Kawai  <shiro@acm.org>

	* libsrc/text/tr.scm (build-char-array): Fixed a bug that prevented
	  having '\' in spec.

2013-11-22  Shiro Kawai  <shiro@acm.org>

	* src/read.c, src/libstr.scm, lib/gauche/interpolate.scm:
	  Enabled the new string interpolation syntax #"... ~expr ...".
	  Still needs appropriate check according to the reader mode.

2013-11-19  Shiro Kawai  <shiro@acm.org>

	* src/libdict.scm (make-hash-table): Experimentally added
	  optional 'init-size' argument.  We might change the API later,
	  so this is unofficial.

2013-11-13  Shiro Kawai  <shiro@acm.org>

	* ext/text/unicode.scm (%foldcase): Fixed handling of final sigma---
	  we need the same treatment as string-downcase.

2013-11-12  Shiro Kawai  <shiro@acm.org>

	* test/r7rs.scm, test/r7rs-test.scm: Added r7rs test taken from Chibi.
	  Run r7rs.scm, which is a Gauche wrapper to execute r7rs-test.scm.
	  Not yet added to TESTS, for we have a few missing features.

2013-11-10  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c (rex_rec): Fixed submatch capture failure. Patch
	  from leque.

2013-11-08  Shiro Kawai <shiro@acm.org>

	* src/port.c, src/portapi.c (Scm_PortAttrGet etc.): Port attributes.
	  This is to generalize accessing various information on ports,
	  and eventually allow ports to abstract broader external
	  resources (e.g. accessing httpd via ports).

2013-11-07  Shiro Kawai  <shiro@acm.org>

	* src/char.c (Scm_DigitToInt, Scm_IntToDigit): More generalized
	  treatment of non-ASCII digit characters.  THIS CHANGE BREAKS ABI
	  COMPATIBILITY.  We think it's better to make it clean, hoping
	  no external modules rely on this API.
	* src/libchar.scm (digit->integer, integer->digit): Extended
	  accordingly.  In Scheme level it's backward compatibile.

2013-11-02  Shiro Kawai  <shiro@acm.org>

	* src/gauche/priv/portP.h: Splitted internal stuff from port.h.

2013-10-31  Shiro Kawai  <shiro@acm.org>

	* lib/data/random.scm (sequences-of): Added.

2013-10-28  Shiro Kawai  <shiro@acm.org>

	* src/write.c, src/class.c, src/gauche/priv/writerP.h:
	  Made ScmWriteContext a Scheme object.  Another step towards
	  rewriting 'write' subsystem.

2013-10-26  Shiro Kawai  <shiro@acm.org>

	* src/write.c (write_walk), src/libio.scm (%write-walk-rec): A
	  step towards rewriting 'write' subsystem - rewrote the walk pass
	  in Scheme.

2013-10-25  Shiro Kawai  <shiro@acm.org>

	* src/gauche/system.h, src/signal.c: Changed handling of SIGPIPE.
	  If Gauche is asked to take care of SIGPIPE, we do nothing for
	  it by default.  The program can handle the situation by
	  capturing EPIPE <system-error> anyway.
	* src/gauche/port.h, src/libio.scm, src/port.c, src/portapi.c:
	  Added an internal flag that can terminate the process if
	  writing raised EPIPE.  By default, only stdout and stderr have the
	  flag set.  This makes casual tools that write to stdout to be piped
	  together behave the similar way as other Unix commands, while
	  other use of pipes (e.g. sockets) won't cause annoying termination
	  via SIGPIPE.
	  NB: We still need an API to change this flag.
	  NB: Code that has been accessed ScmBufferedPort.mode needs to be
	  changed to use the new API Scm_GetPortBufferingMode etc.
	  (Scm_KeywordToBufferingMode, Scm_GetPortBufferingModeAsKeyword):
	  More descriptive API name than Scm_BufferingMode and
	  Scm_GetBufferingMode.  The latter will be removed after 1.0 release.

2013-10-20  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c (rc1_parse, rc3_rec): Fixed a bug handling
	  (?(condition)yes-pattern).  It should take into account of
	  empty no-pattern, e.g. (?(condition)yes-pattern|), which makes
	  the pattern always match if condition doesn't hold.
	  Patch from leque.
	* lib/gauche/regexp.scm (regexp-unparse): Ditto.

2013-10-13  Shiro Kawai  <shiro@acm.org>

	* lib/text/diff.scm (diff): Bug fix: 'Equal' keyword argument was
	  ignored.  Patch from Rui Ueyama.

2013-10-12  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_PrintNumber, Scm_PrintDouble): Changed to return
	  # of characters written.
	* src/write.c (write_char): Use numeric notation for unprintable
	  characters.  NB: Currently, we print with internal encoding,
	  which is incompatible to R7RS if Gauche is compiled with euc-jp
	  or sjis.  We eventually need some writer-mode switch.

2013-10-10  Shiro Kawai  <shiro@acm.org>

	* src/read.c, src/gauche/reader.h, src/gauche/priv/readerP.h:
	  Moved ScmReadContext implementation delcs into a private header.
	  Added public API to modify reader lexical compatibility mode.
	  Use parameter to keep the default read context.
	  Integrate WARN_LEGACY flag to read context instead of vm runtime flag.
	* src/libio.scm: Added parameter-like procedure read-lexical-mode
	  and supported #!gauche-legacy and #!r7rs switch.

2013-10-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/priv/*.h: Moved some private header files into separate
	  directory. builtin-syms.h is now private---the index changes between
	  versions, so external binaries shouldn't rely on that.
	  We'll go through other header files and split private parts into
	  priv/*P.h.

2013-10-06  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/sortutil.scm, lib/gauche/generic-sortutil.scm:
	  Adapted to SRFI-95, and also handles generic <sequence>.

2013-10-04  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/configure.scm: Added support for directory stuff
	  (srcdir etc.), and added tests.

2013-09-28  Shiro Kawai  <shiro@acm.org>

	* src/read.c: Issue warning when we see legacy \xNN hex-digit escape,
	  if SCM_READER_WARN_LEGACY runtime flag is set.  We'll also use
	  this flag for some other planned syntax changes (e.g. string
	  interpolation syntax).
	* src/main.c: Added -fwarn-legacy-syntax option that turns on the
	  SCM_READER_WARN_LEGACY flag.  For the time being we treat it
	  unofficial, let's see how useful it is.

2013-09-25  Shiro Kawai  <shiro@acm.org>

	* src/module.c (search_binding): Fixed a bug in transitive export; the
	  bug prevented the 'only' modifier work on transitively exported
	  symbols.

	* src/compile.scm (pass1/body-rec): Support internal syntax definitions.

2013-09-24  Shiro Kawai  <shiro@acm.org>

	* src/gauche/exception.h, src/error.c: Changed the role of 'message'
	  slot in ScmMessageCondition, to enable R7RS error-object-message
	  and error-object-irritants with keeping ABI compatibility.
	  Scheme-level interface is compatibile, but C code accessing
	  message field directly would get something a bit different from
	  what it got in previous versions.  Those code should use
	  Scm_ConditionMessage() API instead of direct field access.

2013-09-23  Shiro Kawai  <shiro@acm.org>

	* src/libsys.scm (sys-errno->symbol, sys-symbol->errno): Mapping
	  between integer error numbers and their symbolic names.

2013-09-22  Shiro Kawai  <shiro@acm.org>

	* src/read.c (Scm_ReadXdigitsFromString, Scm_ReadXdigitsFromPort):
	  Rewritten to handle \x, \u and \U hex-digit escapes consistently,
	  with the support of bothnew R7RS-style syntax and legacy syntax.
	  They used to be in char.c, but moved to read.c.  The API has been
	  changed (INCOMPATIBLE CHANGE).

2013-09-18  Shiro Kawai  <shiro@acm.org>

	* src/read.c (read_string), src/string.c (string_putc): Switched to
	  R7RS compatible hex-escape syntax (\xNNN;).  Reading the legacy
	  syntax (without ';' terminator) is supported by default, as far as
	  the input can't be interpreted as R7RS syntax.
	  For output, currently we only support R7RS style.  Might add
	  compatibility mode if needed.

	* src/string.c (Scm_DStringPeek): Added.  Useful to avoid allocation
	  when we use dstr just as a temporary variable-sized buffer.

2013-09-17  Shiro Kawai  <shiro@acm.org>

	* src/gen-unicode.scm: Added code generator for unicode numeric value
	  attribute.
	* src/char_attr.c: Regenerated.
	* src/char.c (Scm_DigitToInt): Handles all Nd characters.

2013-09-16  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/dictionary.scm (dict->alist): Provide fallback methods
	  using dict-fold.
	  (<stacked-map>): Added stacked map experimentally.

2013-09-12  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/numerical.scm (real->rational): Fixed a bug in refine/c
	  that doesn't find simplest rational when two continued fraction has
	  (x0 ... xn xn+1 ...) and (y0 ... yn), where xi = yi (0 <= i <= n-1)
	  and |xn - yn| > 1.  Original code just picked the shorter series,
	  but picking min(xn + 1, yn) makes the result simpler.

2013-09-11  Shiro Kawai  <shiro@acm.org>

	* src/libstr.scm (string=? etc): Support more than two arguments.
	* ext/text/unicode.scm (string-ci=? etc): Provide R7RS compatible
	  full-string case folded comparison.
	* lib/r7rs.scm (string-ci=? etc): Use text.unicode version instead of
	  built-in version.

2013-09-10  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/defvalues.scm (define-values): Support <formals> in
	  the variable list position, as specified in r7rs.  Also make it
	  possible to use define-values mixed in internal defines.

	* src/macro.c (match_synrule): Supports trailing items after ellipsis,
	  according to r7rs (e.g. (a b ... c) etc.)

2013-09-08  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-request): Fixed broken behavior of redirect
	  handling.  The body of 3xx request shouldn't be retrieved with
	  caller-supplied receiver.

2013-09-02  Shiro Kawai  <shiro@acm.org>

	* src/macro.c (Scm_CompileSyntaxRules),
	  src/compile.scm (pass1/syntax-rules): Support alternative ellipsis
	  as in R7RS.

2013-09-01  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (define-builtin-inliner-/, pass2/const-numop1)
	  (pass2/const-numop2): Avoid constant-folding for exact div-by-zero
	  case.  We should leave it to be handled at runtime.

2013-08-26  Shiro Kawai  <shiro@acm.org>

	* lib/www/cgi.scm (cgi-parse-parameters): Fixed a bug when multiple
	  values with the same parameter name are passed via
	  multipart/form-data.

	* lib/rfc/uri.scm (uri-compose-data, uri-decompose-data): Added
	  'data:' uri scheme support.

2013-08-22  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/uri.scm (uri-encode): Use uppercase for percent-encoding
	  of special chars, as recommended in RFC3986.

2013-08-20  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-106.scm, doc/modsrfi.texi: Changed according to final
	  spec, and documented.

2013-08-19  Shiro Kawai  <shiro@acm.org>

	* lib/data/random.scm: Fixed some bugs.
	* doc/modutil.texi: Document data.random.  Now it's official.

2013-08-16  Shiro Kawai  <shiro@acm.org>

	* src/vm.c, src/vminsn.c: Some runtime optimizations to improve
	  tight-loop routines (sequence of vm instruction loops that doesn't
	  call extra functions much).  We reduced the check of attentionRequest,
	  and detect value-yielding insn followed by PUSH.  See the comment
	  near NEXT_PUSHCHECK in vm.c for the details.

2013-08-14  Shiro Kawai  <shiro@acm.org>

	* src/libnum.scm (expt): Try to return an exact result when the power
	  is exact rational and result can be exact.
	  E.g. (expt 8/125 2/3) => 4/25.

2013-08-13  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/configure.scm: Added.  Not completed yet.

2013-08-11  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvutil.scm (u8vector-append etc): Added.

2013-08-10  Shiro Kawai  <shiro@acm.org>

	* src/module.c (Scm_FindBinding): Support transitive export, i.e.
	  allow exporting symbols that are imported or inherited, without
	  explicitly defining it in the module.
	* libsrc/srfi-1.scm, libsrc/srfi-13.scm, lib/srfi-14.scm, lib/srfi-60.scm
	  Changed accordingly.

2013-08-08  Shiro Kawai  <shiro@acm.org>

	* lib/file/filter.scm (file-filter): Fixed a bug that the outputfile
	  is not created when :temporary-file #t :leave-unchanged #t.

	* libsrc/text/tr.scm (complement-char-array): Fixed a bug that
	  made complement yield incorrect set when from-str isn't in
	  increasing order of character codes.

2013-08-05  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/libutil.scm (library-has-module?): Quick fix to recognize
	  R7RS define-library form as well.  The 'library' clause of cond-expand
	  relies on this procedure (via library-exists?) so it's critical to
	  handle R7RS here.

2013-08-03  Shiro Kawai  <shiro@acm.org>

	* src/module.c, src/libmod.scm: Updated the list of builtin modules.
	* ext/srfi/generate-srfi.scm: Autogenerate srfi/N.scm for supported
	  srfi-N to make (import (srfi N)) work in r7rs mode.

2013-08-02  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-106.scm: Added.  Since srfi-106 is still a draft, the API
	  may be changed according to its final version.

2013-08-01  Shiro Kawai  <shiro@acm.org>

	* src/core.c: Defined some feature identifiers specified in R7RS
	  Appendix B. (Not exhaustive yet).

2013-07-30  Shiro Kawai  <shiro@acm.org>

	* src/main.c, lib/r7rs.scm: In R7RS toplevel mode, set the default
	  environment to #<module r7rs.user> instead of #<module user>.
	  Keeping #<module user> able to operate in Gauche mode is convenient
	  to evaluate .gaucherc in #<module user> regardless of whether Gauche
	  is invoked in -r7 or not.
	  We also define a variable *r7rs-mode* in #<module user> if invoked
	  with -r7, so that gauche.interactive can do extra set up if necessary.
	* lib/gauche/interactive.scm: Modified accordingly.

2013-07-28  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (throw_continuation): Fixed a bug that failed to save
	  living continuations on stack when a ghost continuation is invoked,
	  which caused the conitnuation frames to be clobbered.
	  See the comment for the details.

2013-07-26  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_SinPi, Scm_CosPi, Scm_TanPi): EXPERIMENTAL:
	  Added sinpi(x) = sin(x*pi) etc. to allow avoiding errors in
	  certain cases.  From Scheme they're %sinpi etc.  Not yet documented.
	  See if they're worth having.
	* src/number.c (scm_expt): Use Scm_SinPi etc. so that
	  (expt <negative-integer> n+1/2) can return pure imaginary number.

2013-07-18  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/base64.scm (base64-decode, base64-encode): Support url-safe
	  keyword argument to encode/decode url-safe version of characters.
	  Patch from Rui Ueyama.

2013-07-14  Shiro Kawai  <shiro@acm.org>

	* src/read.c: Support R7RS-style inline hex escape in symbol literals.
	* src/char.c: Changed Scm_ReadXdigitsFromPort to recognize delimiter
	  of inline-hex escape.  NB: Technically this changes ABI, but
	  the function isn't intended for public use and I doubt it's
	  used by extension packages.

2013-07-06  Shiro Kawai  <shiro@acm.org>

	* src/gauche-init.scm: Retire gauche-init.scm.  We can already
	  precompile Scheme initialization routine, so we no longer need to
	  keep it.  And it is inconvenient for embedding use.
	  Various files are modified to remove reference to gauche-init.scm.

	* src/genconfig.in, src/paths.c, src/Makefile.in: No longer generate
	  gauche/arch.h; having architecture-dependent header file is just
	  an annoyance.  Besides we don't really need to make the info in the
	  header file since those info can be retrieved through API at
	  runtime.  This change removes preprocessor symbols GAUCHE_ARCH,
	  GAUCHE_LIB_DIR, GAUCHE_ARCH_DIR, GAUCHE_SITE_LIB_DIR and
	  GAUCHE_SITE_ARCH_DIR.

2013-07-05  Shiro Kawai  <shiro@acm.org>

	* ext/tls: Updated to axTLS 1.4.9

2013-07-04  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm: Support letrec*.

2013-07-03  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/common-macros.scm (dotimes, dolist): Support omission
	  of 'variable'.

2013-07-02  Shiro Kawai  <shiro@acm.org>

	* src/libnum.scm (%log): Handle input even if it can't fit in
	  IEEE double e.g. (log (expt 2 2048)) => 616.5094311198334

2013-06-30  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm (define-cptr): Experimentally added
	  stub form to declare a foreign pointer class using ScmForeignPointer.

2013-06-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vecutil.scm: Added.  Supports R7RS vector-map and
	  vector-for-each.  Also includes vector-tabulate.
	* src/autoloads.scm: Autoload gauche.vecutil.
	* lib/r7rs.scm: Changed accordingly.

	* ext/srfi/srfi-43.scm: Define vector-map etc. as an alias of
	  vector-map-with-index etc.

2013-06-26  Shiro Kawai  <shiro@acm.org>

	* ext/text/unicode.scm (utf8->string, string->utf8): Added these
	  r7rs procedures here.
	* lib/r7rs.scm: Use above procedures.

2013-06-25  Shiro Kawai  <shiro@acm.org>

	* ext/dbm/dbm.ac: Added --with-dbm=DBM,... configure option, to
	  exclude some dbm libraries that would be compiled by default.

2013-06-22  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass2/intermediate-lref-removal): Fixed a bug
	  that does incorrect transformation under existence of side-effects.

2013-06-19  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-0.scm (cond-expand): Support R7RS 'library' feature test.
	* lib/r7rs.scm, lib/gauche/libutil.scm: Moded library-name->module-name
	  from r7rs to gauche.libutil, for it is needed by srfi-0.

2013-06-15  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/open-include-file): Searches also
	  *load-path* for specified file.  We now use find-load-file,
	  so the load-path-hook stuff can also work.

	* src/liblist.scm, libsrc/srfi-1.scm (concatenate, concatenate!,
	  append-reverse, append-reverse!, append-map, append-map!):
	  Further migration of srfi-1 procedures into core.
	* lib/gauche/parseopt.scm: Removed dependency on srfi-1.

2013-06-14  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm, libsrc/srfi-1.scm (count, reduce, reduce-right,
	  partition): Move from srfi-1.scm to liblist.scm, so that
	  gauche.procedure won't depend on srfi-1.
	* lib/gauche/procedure.scm: Removed dependency on srfi-1.

2013-06-12  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm, src/libobj.scm, src/autoloads.scm,
	  lib/gauche/procedure.scm, lib/gauche/experimental/app.scm,
	  lib/gauche/cgen/precomp.scm: Flushed suspended changes and temporary
	  kludges to build 0.9.3 gauche by pre-0.9.2 gauche.

2013-06-10  Shiro Kawai  <shiro@acm.org>

	* src/code.scm, src/libcode.scm (compiled-code-copy!): Added.
	* lib/gauche/cgen/precomp.scm, lib/gauche/cgen/optimizer.scm:
	  Experimentally added extra optimization at precompile time
	  (it's off by default now).

2013-06-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vm/insn-core.scm (vm-insn-size): Added.

	* ext/util/queue.scm (%mtqueue-overflow?): Bug fix from @tabe via
	  pullreq.  It didn't return boolean value properly.

2013-06-07  Shiro Kawai  <shiro@acm.org>

	* src/libcode.scm, src/compile.scm: Splitted VM code generation API
	  into gauche.vm.code module.

	* lib/gauche/cgen/precomp.scm (compile-toplevel-form): Execute export
	  operation during initialization when the compilation does not
	  produce *.sci file.

2013-06-05  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass5/if-final): Micro-optimization to eliminate
	  one JUMP instruction in certain cases.

	* src/libio.scm (eof-object): Mark it :constant, so that the calls
	  would be inlined.

2013-06-01  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c (rc1_parse): Fixed a bug in backreference to the nested
	  group case (see the added tests for the details).

2013-05-31  Shiro Kawai  <shiro@acm.org>

	* ext/Makefile.in: Reordered SUBDIRS: uvector must be built before
	  threads, since gauche.records used by threads now depends on uvector.

	* Makefile.in, ext/Makefile.in: Exits abnormally if any of submake
	  inside for loop fails.

	* lib/text/csv.scm (make-csv-reader): Rewrote in straightforward way.
	  It turned out the naive "read one char at a time, accumulate into a
	  list, and list->string to make a field" approach is 5x faster than
	  the previous string-scanning code.  Also the port argument for
	  the returned reader is now optional.

2013-05-30  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm (compile-toplevel-form): Avoid emitting
	  the toplevel pattern CLOSURE - DEFINE - RET generated by toplevel
	  definitions.  Instead we call Scm_MakeBind at initialization.
	  This reduces code vector size slightly.

2013-05-25  Shiro Kawai  <shiro@acm.org>

	* various files: Removed unnecessary "use"-dependencies, and put
	  less-frequently used features into autoloads, in order to speed
	  up initial startup, especially for www.cgi.
	  libsrc/gauche/parameter.scm - autoload hook features
	  lib/rfc/mime.scm - splitted parts that needs gauche.vport
	  lib/gauche/portutil.scm, src/libio.scm - move port-tell and
	  port-position-prefix from portutil to libio.

2013-05-24  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/logical.scm (copy-bit-field): Fixed the argument order
	  to comply SRFI-60.  THIS IS AN INCOMPATIBLE CHANGE.  A note is
	  added to the manual entry about it.

2013-05-22  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (find-load-file): Experimentally allow to trigger
	  load hooks by "" in the PATHs list.  Convenient to be used when
	  Scheme sources are embedded in the executing binary.

2013-05-21  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/literal.scm (c-safe-string-literal): replace '?'
	  in the string as well.  A cheap workaround to avoid putting trigraph
	  in C string literal inadvertently.

2013-05-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/record.scm: Export <pseudo-record>.

2013-05-18  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm: Let #<module gauche> export history
	  variable, so that it can be imported to the r7rs REPL for the
	  convenience.

2013-05-17  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/record.scm: Support pseudo records for <list> and
	  uniform vectors.  Support rtd-predicate for pseudo records.

2013-05-16  Shiro Kawai  <shiro@acm.org>

	* src/load.c (Scm_RegisterPrelinked, Scm_DynLoad): Experimentally
	  added support for statically linking extensions.
	* src/Makefile.in, ext/*/Makefile.in, src/gen-staticinit.scm:
	  Changes to support creating static linking version of libgauche.

2013-05-15  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/procedure.scm (generator-find): Added.
	* lib/gauche/generator.scm (gbuffer-filter): Added.

	* lib/rfc/http.scm (%http-request-adaptor): If the caller gives :sink
	  or :flusher, we mandate both should be given.  Giving just either
	  one should be rare case (and it's not likely to be working in the
	  current version---suppose you pass a file port to sink but not
	  giving flusher; then the current code raises an error, since the
	  adaptor provides the default flusher that calls get-output-string
	  on the sink.)  It is better to mandate both, so that we can catch
	  caller's misspelling of :sink or :flusher.

2013-05-11  Shiro Kawai  <shiro@acm.org>

	* ext/net/net.c: Plugged resource (fd) leak on Windows.  We need to
	  close fds opened by _open_osfhandle, but the trick is that we only
	  can do it at the time when the socket is closed.

	* src/number.c (Scm_FloatSign, print_double, scm_div): Basic support
	  for negative inexact zero.  We actually have the representation of
	  -0.0 internally, but didn't have printer honor it.  Most calculations
	  just works because libc does the job.  However, we need to
	  distinguish positive-zero imaginary part and negative-zero imaginary
	  part, which requires some surgery since we implicitly coerce complex
	  numbers with zero imaginary part to real numbers.
	* src/libnum.scm (%log): Likewise.  (log 0.0) ==> -inf.0 but
	  (log -0.0) ==> -inf.0+3.141592653589793i.

2013-05-10  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm: Imports R7RS-small standard libraries
	  when gosh is invoked in interactive r7rs mode, so that they are
	  available in REPL.

2013-05-06  Shiro Kawai  <shiro@acm.org>

	* src/read.c (read_sharp_word): Support #true and #false.  This
	  also changes how the #-word is delimited: #t and #f used to delimit
	  themselves (except #f8, #f16 and #f32), but now we read a word
	  then match the token.  So, #f.1 used to be read as #f and 0.1,
	  but now it raises an error saying "invalid #-token: #f.1".
	  I don't think this causes a problem in existing code, but there
	  may be a datafile that relies on the old behavor; we'll watch.
	  Note that this isn't fully R7RS compatible yet.  The way R7RS
	  delimits tokens is different (e.g. we read "#false#false" as two
	  boolean falses, but iiuc, R7RS reader should read it as one token
	  and raise an error of invalid token.)
	  This also changes how the tokens with hash signs are read;
	  ".#" used to be read as a symbol, but now it is an error.
	  See the comment in 'Symbols and Numbers' section of the code.
	  Again, I doubt it causes any problem in existing code; and I worry
	  less about datafiles, since when such weird symbols are written,
	  it is |-escaped, so it can read back with the current reader.

2013-05-05  Shiro Kawai  <shiro@acm.org>

	* src/libsym.scm (symbol=?): Added for R7RS.
	* src/libbool.scm (boolean=?): Added for R7RS.

	* src/liblist.scm (list-set!): Make it built-in.

	* libsrc/file/util.scm (delete-file, remove-file): Added for R7RS
	  compatibility.
	* lib/r7rs.scm (delete-file): Changed accordingly.

2013-05-04  Shiro Kawai  <shiro@acm.org>

	* src/gauche/writer.h: Splitted writer related decls.

	* src/main.c (main): Experimentally support -r7 option to start up
	  gosh with R7RS environment as default.  Currently this is mainly
	  for the convenience of developing R7RS compatibility code.

	* lib/gauche/numerical.scm (floor/ etc.): Added R7RS integer division
	  operators.
	  (square): ditto.
	* autoloads.scm: Changed accordingly.

	* lib/r7rs.scm (define-library): Support R7RS define-library.
	* autoloads.scm (define-library): Autoload define-library so that
	  Gauche native code can use R7RS library seamlessly.

2013-05-03  Shiro Kawai  <shiro@acm.org>

	* src/libmod.scm, src/module.c (module-name->path, path->module-name):
	  Moved definition of these two from C to Scheme, and supports
	  module name components to have dot in it.  It won't so much useful
	  from Gauche, but R7RS library name may have (foo.bar baz) and
	  we need to map it to Gauche's module name.

	* lib/r7rs.scm, lib/scheme/base.scm: Start adding R7RS compatibility
	  stuff.

	* src/load.c (Scm_Require): Make sure we set the current module
	  to #<module gauche> when actually loading the file.  This was
	  never explicitly stated, but we always assumed so.  It doesn't
	  make sense to use caller's current module, since the caller
	  doesn't know if the file will actually be loaded or not, so
	  there's no guarantee that the current module is in effect.
	  This change might cause an incompatibility in the code that
	  took advantage of the old require behavior, but I doubt such
	  code exists.
	  (Scm_ResolveAutoload): The exception of above 'require' spec
	  is autoloading; we do need to load the file into a specific
	  module.

2013-05-01  Shiro Kawai  <shiro@acm.org>

	* src/libsys.scm: Feature identifiers gauche.sys.setenv,
	  gauche.sys.unsetenv, gauche.sys.clearenv, gauche.sys.sigwait,
	  and gauche.sysgetloadavg weren't defined properly.

2013-04-28  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (take-right*): When the list is long and k is
	  small, try not to keep entire list on memory - would help when
	  taking the last k elements of a lazy sequence.  Not an ideal
	  solution, but would work for the time being.

2013-04-27  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (length<=?): Added.

2013-04-25  Shiro Kawai  <shiro@acm.org>

	* src/module.c (Scm_ExportSymbols): Fixed a bug that searched
	  external table with internal name (patch from enami).
	  Also added a check to see if 'export' overrides the previous exports.

2013-04-24  Shiro Kawai  <shiro@acm.org>

	* ext/sparse/sparse.scm: Added generalized setter to
	  sparse-table-ref and sparse-vector-ref.

2013-04-23  Shiro Kawai  <shiro@acm.org>

	* src/gauche/module.h (ScmModule), src/gauche/gloc.h (ScmGloc),
	  src/module.c, src/gloc.c: Changed the way exported bindings
	  are handled.  Instead of having a flag in GLOC, we now have
	  to hashtables in ScmModule, one for internal (all) bindings and
	  another for exported bindings.  This allows us to implement
	  export-time renaming easily.
	  This changes the struct layout of ScmModule and ScmGloc, and
	  IT MIGHT BREAK ABI COMPATIBILITY, although both of those structs
	  are always allocated at runtime and accessed via API from
	  outside of libgauche, I expect it won't affect much.
	  The 'exported' list in ScmModule is dropped; if you want a
	  list of exported symbols, call Scm_ModuleExports() to calculate
	  the list.
	  NB: Scm_ExportSymbols no longer returns a list of exported symbols.
	* src/module.c (Scm_ExportSymbols): Allow export-time renaming,
	  as specified in R[67]RS.

2013-04-21  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm: Added include-ci support, and allows multiple
	  files with include/include-ci, as R7RS.
	* doc/coresyn.texi: Added docs for include and include-ci.

2013-04-19  Shiro Kawai  <shiro@acm.org>

	* src/libobj.scm (object-apply): Made char-set applicable.

2013-04-18  Shiro Kawai  <shiro@acm.org>

	* lib/dbm.scm (call-with-iterator, coerce-to): Added missing
	  collection framework support to dbm.

2013-04-17  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (command-line): Added R7RS-ish command-line access
	  procedure.  This is better than old *program-name*/*argv* variables.
	* src/core.c (Scm_InitCommandLine): A convenience C API to initialize
	  command-line, *program-name* and *argv* from C code.
	* src/main.c: Changed to use Scm_InitCommandLine.
	* lib/gauche/logger.scm: Changed accordingly.

2013-04-16  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c (regexp-compile): Fixed a bug that failed to handle
	  named subgroups and unordered group counts in the input AST.
	  The named subgroups are handled in parser, so the rxs created by
	  regexp-compile from AST didn't have the info.  Now rc_setup_context
	  is fixed to deal with named subgroups.  There was another bug
	  in rc_setup_context that made group ordering not to work.

2013-04-15  Shiro Kawai  <shiro@acm.org>

	* lib/control/thread-pool.scm (terminate-all!): Fixed a timing hazard
	  that could cause terminate-all! to throw a 'queue full' exception.
	* test/control.scm: Adjusted pool termination test for robustness.

	* lib/gauche/dictionary.scm: Revised.  Provided fallback methods
	  for optional interface.  A new macro define-dict-interface is
	  provided to define dictionary API concisely.
	* lib/dbm.scm, ext/sparse/sparse.scm: Use define-dict-interface
	  to define dict interfaces.
	* lib/util/trie.scm: Added dictionary interface to <trie>.

2013-04-12  Shiro Kawai  <shiro@acm.org>

	* src/*, lib/gauche/cgen/type.scm (ScmSmallInt): Bulk fix to avoid
	  integer overflow in indexes that accepts <fixnum>.  We used to
	  map <fixnum> to int, but that could cause overflow on 64bit
	  architecture.  We changed the mapping to ScmSmallInt, and changed
	  vector and string APIs to use it instead of int for indexes.
	  (NB: We still have 2G limit on string size & length for ABI
	  compatibility.  Check codes are inserted to detect out-of-range
	  case.  See src/string.c for the details.)
	  POSSIBLY INCOMPATIBLE CHANGE: We also enhanched
	  Scm_GetInteger()-family API to cover 8-,16-,32-bit integers, and
	  made it throws an error when the input is out-of-range.  The old
	  Scm_GetInteger[U][64]() API clamped the out-of-range arg.  We think
	  clamping is unsafe and shouldn't be the default behavior.  This
	  can break code that relies on the clamping behavior.

2013-04-09  Shiro Kawai  <shiro@acm.org>

	* ext/dbm/gdbm.scm (gdbm-strerror): Avoid using 'errno' as a variable,
	  for it may be a macro.
	* src/write.c (Scm_Vprintf): Handle 'l' modifier properly when we use
	  va_arg.
	* lib/gauche/cgen/type.scm: <fixnum> needs to be mapped to C long,
	  not int.  It's surprising that we've been missed this for long time.
	* src/number.c (Scm_Ash): Changed the second arg to long from int,
	  for this can be called via exact_expt and the second arg can be
	  outside of the range of int.  To prevent a silly bug gobbles huge
	  amount of memory, set a limit in the positive shift amount.

2013-03-30  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (throw_cont_body): Fixed bug that failed to set vm->numVals
	  when the continuation gets 0 args.

2013-03-19  Shiro Kawai  <shiro@acm.org>

	* ext/binary/io.scm (write-ber-integer): Fixed a bug that ignores the
	  port argument.  Patch from Nozomi Isozaki.
	* src/libnum.scm (%exact-integer-sqrt): Fixed the range to be used
	  FP sqrt.  If input is >= 2^52, the result of FP sqrt can be rounded.

2013-03-14  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test/generative.scm: Initial check in.  API is still
	  fluid.

2013-03-12  Shiro Kawai  <shiro@acm.org>

	* data/random.scm: Added initial version.

2013-03-11  Shiro Kawai  <shiro@acm.org>

	* configure.ac, lib/gauche/config.h.in: Added check for lgamma and
	  tgamma.
	* src/libnum.scm, lib/gauche/numerical.scm, src/autoloads.scm
	  (gamma, lgamma): Added.  We use system's tgamma and lgamma
	  if available, and alternative approximation if not.
	* test/number.scm: Tests for alternative gamma function implementation;
	  this is commented out by default, for it requires system's
	  tgamma and lgamma.
	* src/libsys.scm: Moved math.h functions (fmod, frexp, ldexp, log10)
	  to libnum.scm.

2013-02-19  Shiro Kawai  <shiro@acm.org>

	* lib/math/prime.scm (mc-find-divisor-1): Fixed a bug that made
	  the algorithm loop unnecessarily long.
	  (mc-factorize): Removed :num-tries arg, since now mc-find-divisor-1
	  can take much longer for inputs that's hard to factorize, so limiting
	  execution time by :num-tries doesn't have much use except preventing
	  infinite loop in case the input has a large prime factor.
	  Practical applications would need some timeout mechanism anyway so
	  it wouldn't be a show-stopper.  We'll address the infinite loop issue
	  by implementing deterministic primality test in future.

2013-02-16  Shiro Kawai  <shiro@acm.org>

	* src/autoloads.scm (sinh, cosh, tanh, asinh, acosh, atanh): No longer
	  needed since they have been moved to libnum.scm.

2013-02-14  Shiro Kawai  <shiro@acm.org>

	* src/number.c, src/gauche/number.h (Scm_PrintNumber): New API for more
	  general handling of number to external representation conversion.
	  (Scm_NumberToString): Rewritten to use Scm_PrintNumber internally.
	  The last argument is changed from 'int use_upper' to
	  'ScmNumberFormat*'.  It is an incompatible change, but we hope almost
	  all calls of this function had specified 0 or FALSE in the last arg
	  and expect it to work (if not, recompilation would take care of it.)
	  (Scm_StringToNumber): The last arg is changed for 'int strict' to
	  'u_long flags'.  Again, this is an incompatible change, but we no
	  longer use this arg at this moment (the semantics of 'strict' wasn't
	  well defined, and deemed unnecessary---for real strict check we need
	  different semantics.)  Thus existing code should work.
	  Note that existing cgen-generated code may contain a call with
	  the third arg to be TRUE.
	* src/libnum.scm, src/read.c, src/regexp.c, src/write.c,
	  lib/gauche/cgen/literal.scm: Changed accordingly.

2013-02-06  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/lazy.scm (lconcatenate): Added.

2013-02-05  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/regexp.scm (rxmatch-substrings, rxmatch-positions): Added.
	* src/librx.scm (rxmatch-named-groups): Added for completeness.
	* src/autoloads.scm, test/regexp.scm: Changed accordingly.

2013-01-28  Shiro Kawai  <shiro@acm.org>

	* src/string.c (Scm_GetStringConst),
	  lib/gauche/cgen/type.scm (<const-cstring>): Instead of having
	  a special 'safe' version that checks NUL character, we made the
	  default GetStringConst safe.  It doesn't make much sense anyway
	  to have two versions, for there's no way to use beyond NUL byte
	  of a C string returned by Scm_GetStringConst---you need a string
	  length separately, and Scm_GetStringContent is for that purpose.

2013-01-24  Shiro Kawai  <shiro@acm.org>

	* src/string.c (Scm_StringSplitByCharWithLimit),
	  lib/gauche/stringutil.scm (string-split): Supported optional limit
	  argument, based on Bizenn's patch.

2013-01-23  Shiro Kawai  <shiro@acm.org>

	* src/string.c (string_scan, string_scan_reverse): Use optimized
	  scan for utf-8 multibyte-multibyte case and when the searched
	  string is a single byte.  The effect is significant.

2013-01-21  Shiro Kawai  <shiro@acm.org>

	* src/libnum.scm (twos-exponent, twos-exponent-factor): Renamed
	  power-of-two? to twos-exponent, for now we returns more meaningful
	  result than just a booelan.  The previous twos-exponent is renamed
	  to twos-exponent-factor.

2013-01-16  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1): Made the compiler reject too may literal
	  arguments that wouldn't fit in VM stack, instead of SEGVing at
	  runtime.

2013-01-14  Shiro Kawai  <shiro@acm.org>

	* src/bignum.c (Scm_BignumRemSI): Avoid unnecessary allocation of
	  bignums when calculating modulo/remainder of a bignum by a fixnum.
	  This makes (modulo <bignum> <fixnum>) about 3x faster, though
	  the practical observable effects is much smaller unless the
	  program specifically calls the specific combination.

2013-01-09  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass5/prepare-args): Fixed incorrect stack
	  estimation that caused stack overrun.

	* src/lazy.c (Scm_Force): Fixed leak that prevented tail-recursive
	  lazy loop consumes unbounded memory (regression introduced
	  between 0.9.2 and 0.9.3.)

2013-01-06  Shiro Kawai  <shiro@acm.org>

	* lib/util/digest.scm, lib/rfc/hmac.scm, ext/digest/sha.scm:
	  Let digest algorithm metacless have the default block size
	  to be used in HMAC.  HMAC needs to know it to do appropriate
	  preprocessing of the key.  In old days block size is fixed
	  to 64 bytes, but now sha384/512 insists 128 bytes.

	* src/compile.scm (case): Fixed empty items in a case clause.
	  Patch from leque.

2013-01-05  Shiro Kawai  <shiro@acm.org>

	* lib/math/prime.scm: Added jacobi, totient and bpsw-prime?.
	  (mc-factorize): Improved using bpsw-prime? to bail out with
	  large primes.
	  (naive-factorize): Made memoization thread-safe.

	* src/libnum.scm (twos-exponent, power-of-two?): Added.  These are
	  trivial to write in Scheme, but usually they are wanted in optimized
	  code, and I've seen it enough to include a native, fast version.

2013-01-04  Shiro Kawai  <shiro@acm.org>

	* lib/math/prime.scm: Exposed small-prime?.

2013-01-03  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/cise.scm (.type): Added (.type typename) to embed
	  type names in some context; e.g. the argument of sizeof.
	* ext/uvector/uvlib.stub.tmpl (TAGvector-multi-copy!): Added.
	* lib/math/prime.scm: Fix reset-primes (do not return
	  the value of *primes*; othewise running (reset-primes) on REPL
	  would cause a trouble), small-integer-prime? (need to handle 2
	  and 3 specifically.  Also make it return #f for large numbers).
	  Added factorization procedures, naive-factorize and mc-factorize.

2013-01-02  Shiro Kawai  <shiro@acm.org>

	* src/libnum.scm (exact-integer?): Added.
	* lib/gauche/numerical.scm (expt-mod): Added.

2012-12-23  Shiro Kawai  <shiro@acm.org>

	* src/vminsn.scm (GSET): Missing FLONUM_ENSURE_MEM caused flonum
	  assigned to a global variable to be overwritten.

2012-11-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/process.scm (%prepare-remote): Fixed regexp to recognize
	  hostname (thanks to BIZENN).

2012-11-19  Shiro Kawai  <shiro@acm.org>

	* src/signal.c (Scm_SigCheck),
	  ext/threads/threads.c (wait_for_termination): Fixed timing hazard
	  when a thread is killed via pthread_kill().  The hazard was visible
	  on cygwin.

2012-11-18  Shiro Kawai  <shiro@acm.org>

	* src/class.c (Scm_MakeForeignPointer): Make the identity hashtable
	  lookup thread-safe.  Added Scm_MakeForeignPointerWithAttr (see
	  the comment; the attributes should be used mostly in read-only
	  manner.
	  (Scm_ForeignPointerAttrSet): Made it thread-safe. Not tuned for
	  performance, but modifying attrs are not encouraged anyway.
	* src/libmisc.scm (foreign-pointer-attribute-set!): Rename it with
	  bang for the consistency.  Keep old name (no bang) for the backward
	  compatibility.
	* src/test-extra.c, src/libextra.scm, test/capi.scm: Added
	  to test stuff that aren't exposed to Scheme by default.

2012-11-01  Shiro Kawai  <shiro@acm.org>

	* lib/file/filter.scm (file-filter): Added :leave-unchanged option,
	  allow #t to :temporary-file option.
	  (file-filter-fold, file-filter-map, file-filter-for-each): Added.

2012-10-29  Shiro Kawai  <shiro@acm.org>

	* src/read.c (read_reference): Reject indeterminate read reference,
	  e.g. #0=#0#.

	* src/write.c (write_walk, write_ss_rec): Avoid recursion, for it
	  may bust the C stack when dealing with deeply nested structures.

2012-10-25  Shiro Kawai  <shiro@acm.org>

	* ext/peg/peg.scm (peg-run-parser): Let it return the "rest of the
	  input" as the second value for the generality.  This is an
	  incompatible change.
	* lib/rfc/json.scm (parse-json*): Added.

2012-10-24  Shiro Kawai  <shiro@acm.org>

	* ext/peg/peg.scm ($fmap): Experimentally added functor interface.
	  ($do [x parser1] [y parser2] ($return (f x y))) can be writtern
	  as ($fmap f parser1 parser2).  See how it works.
	* lib/rfc/json.scm (json-array-handler, json-object-handler)
	  (json-special-handler):  Make json array|object -> Scheme
	  mapping customizable.
	  (construct-json): Generalized array and object handling: Now
	  any <dictionary> instance is mapped to json object (and its keys
	  can be anything, converted by x->string), and any <sequence>
	  except strings and lists is mapped to json array.
	  Above two enhancements are inspired by Teppei Hamada's
	  Gauche-text-json package (http://teppey.github.com/Gauche-text-json/).

2012-10-22  Shiro Kawai  <shiro@acm.org>

	* libsrc/util/match.scm (gendefine): Fixed match-define expansion
	  (patch from rallentando).

	* src/gauche/float.h (SCM_FP_ENSURE_DOUBLE_PRECISION_BEGIN),
	  (SCM_FP_ENSURE_DOUBLE_PRECISION_END): A compatibility layer
	  to tweak FPU control register.
	* src/number.c (Scm_GetDouble): Make sure ratnum -> flonum
	  routine uses IEEE double, not x87 extended double
	  (so far, on MinGW and Linux.)

2012-10-17  Shiro Kawai  <shiro@acm.org>

	* src/string.c (Scm_GetStringConstSafe),
	  lib/gauche/cgen/type.c (<const-cstring-safe>): Converting Scheme
	  string to C string with extra check of NUL character.  This should
	  be used to obtain strings to be passed to system procedures
	  (e.g. pathnames for file operations) to avoid security risk.
	* src/libio.scm (%open-input-file, %open-output-file),
	  src/libsys.scm (sys-remove, sys-rename, sys-system, sys-setenv,
	  sys-unsetenv, sys-stat, sys-lstat, sys-mkfifo, file-exists?,
	  file-is-regular?, file-is-directory?, sys-utime, sys-access,
	  sys-chdir, sys-chmod, sys-chown, sys-lchown, sys-link, sys-mkdir,
	  sys-rmdir, sys-unlink, sys-truncate, sys-symlink, sys-readlink):
	  Use <const-cstring-safe>.

2012-10-07  Shiro Kawai  <shiro@acm.org>

	* src/number.c: Raises an error for division by exact zero, instead
	  of coercing it to inexact; R5RS allows implicit coercing, but R6RS
	  explicitly requires raising error.  Patch from leque.
	  Also making 1/0 an error, while we still allow #i1/0 => +inf.0.
	  (scm_div): Also fixed (/ <compnum> <zero>) cases.  Patch from leque.

2012-09-30  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/literal.scm: Temporarily replaced refereces of expt
	  for %expt, otherwise compiling HEAD with 0.9.3.3 could trigger
	  autoload of expt, while it is no longer in gauche/numerical.scm
	  in the current source tree.  We can revert it after 0.9.4 release.

	* src/number.c (Scm_Exact), lib/gauche/numerical.scm (real->rational):
	  Let 'exact' return the simplest rational within the precision of
	  the flonum, instead of the dumb rationalization.  E.g.
	  (exact (/ 3.0)) => 1/3 instead of 6004799503160661/18014398509481984.
	  The calculation is implemented in real->rational, and Scm_Exact
	  calls it when needed.
	* src/libnum.scm, lib/gauche/numerical.scm: Moved R5RS procedures
	  from the latter to the former.
	* src/autoloads.scm: Changed accordingly.

2012-09-29  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/literal.scm (define-cgen-literal): Fixed complex
	  literal generation when real-part and/or imag-part contains
	  NaN or infinities.

2012-09-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/numerical.scm (rationalize, real->rational): Factored
	  out more general rationalization algorithm as real->rational,
	  and implemented rationalize on top of it.  Also fixed the case
	  when e >= 1 in rationalize.

2012-09-24  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/numerical.scm (rationalize, continued-fraction): Added.

2012-09-07  Shiro Kawai  <shiro@acm.org>

	* src/gauche/treeutil.scm (make-tree-map): Allow a single 'compare'
	  procedure instead of '=' and '<'.

2012-08-28  Shiro Kawai  <shiro@acm.org>

	* src/read.c, src/libio.scm, src/main.c, src/compile.scm,
	  src/gauche/vm.h: *HIGHLY EXPERIMENTAL*: Support srfi-105 draft
	  cexpr to try it out.  This feature may be changed incompatibly
	  at any time, according to how the srfi will turn out.

2012-08-04  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (gmerge): Added.

2012-07-25  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (receive-body-chunked): Rewrote to avoid using
	  shift/reset.  The naive use of delimited continuation won't work
	  if the caller also tries to use delimited continuations.

2012-07-21  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (Scm_VMCallPC): Fixed a bug that a valid partial
	  continuation usage caused "attempt to return from ghost
	  continuation" error when the captured partial continuation
	  was empty.

	* src/number.c (Scm_IntegerP): Fixed (integer? +inf.0) => #t etc.

2012-07-20  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (iota): Reject if count is non-integer.  And even
	  if count is inexact, we still return exact numbers if start and step
	  are exact.
	* src/liblazy.scm (liota, lrange): Fix inexact/exact number handling
	  and the case when step isn't an integer.
	* lib/gauche/generator.scm (giota, grange): Fix inexact/exact handling.

2012-07-14  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (gslices): Added.
	  (bits->generator, reverse-bits->generator): Fixed the semantics
	  of start and end arguments; the previous spec wasn't useful, for
	  we get used to count the bit numbers from LSB to MSB; it is much
	  more convenient to be able to say (bits->generator num 0 8) to
	  take always the least significant 8 bits.  The direction of bits
	  is also reversed, to align to start/end; bits->generator takes
	  bits from LSB, while reverse-bits->generator takes from MSB.

2012-07-11  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm (read-eval-print-loop): Make extended
	  REPL feature available when gauche.interactive is loaded.
	* src/main.c: Changed to call "visible" read-eval-print-loop.  This
	  makes the extended REPL available by default, but uses the
	  gauche#read-eval-print-loop if gauche.interactive isn't loaded.
	* src/repl.c: Scm_Repl is no longer used.  Marked obsoleted.

2012-07-10  Shiro Kawai  <shiro@acm.org>

	* src/repl.c, src/libeval.scm (read-eval-print-loop): Reimplemented
	  read-eval-print-loop in Scheme instead of C.  C API Scm_Repl calls
	  Scheme version.  Scm_VMRepl is obsoleted (it never was an official
	  API).

2012-07-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive.scm (describe): When a symbol is described,
	  show the known bindings on the symbol for the convenience.

2012-07-08  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (get_debug_info), src/main.c (main): Fixed lost stack
	  trace.  Patch from Vitaly Magerya.

	* src/char.c (<char-set>), libsrc/gauche/collection.scm: Let <char-set>
	  class inherit <collection> and implement collection framework.
	* src/libchar.scm, lib/srfi-14/query.scm (char-set-size): Moved
	  char-set-size to builtin.

2012-07-07  Shiro Kawai  <shiro@acm.org>

	* ext/srfi/srfi-19.scm (tm:leap-second-table): Reflected the leap
	  second in 2012-07-01.

2012-07-06  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-14.scm (char-set-hash): The hash value wasn't distributed
	  enough.  NB: This changes the hash value.  Watch out if it causes
	  any inter-version compatibility issues.

2012-07-02  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (find-load-file): Allow non-regular file (e.g.
	  device files and pipes) to be loaded.  It can be used as a dummy
	  script for one-liner: 'gosh -E... /dev/null "$@"', for example.

2012-06-27  Shiro Kawai  <shiro@acm.org>

	* src/string.c (string_search_reverse): Fixed off-by-one bug.

2012-06-26  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (port->sexp-generator)
	  port->line-generator): Added for completeness.

2012-06-21  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-basic-auth-handler): Added support
	  for basic authentication, using :auth-user and :auth-password
	  passed to http-requrest.  The caller no longer need to create
	  authorization header by itself.   Patch from Bizenn.
	  Whether the current architecture is enough to handle
	  other authentication schemes isn't clear yet (apparently
	  digest authentication requires a lot more complicated handling).
	  So we don't make the :auth-handler argument and
	  http-default-auth-handler official yet.

2012-06-16  Shiro Kawai  <shiro@acm.org>

	* ext/sxml/adaptor.scm (parse-error): Fixed that 'msg' part
	  wasn't included in the error message.

2012-06-06  Shiro Kawai  <shiro@acm.org>

	* ext/tls/axTLS: updated to axTLS 1.4.6.  Also tweaked "client
	  renegotiation" test in ssltest.c, for it seems to depend on
	  openssl version/architecture difference.

	* src/gauche.h (SCM_MAKE_CHAR): When extended character (e.g.
	  #\uffffff) was given in an 'int' variable, it became negative
	  by the shift op and was sign extended in 64bit architecture,
	  ending up an incorrect character representation.

	* src/char.c (charset_print_ch): Use unicode escape for all
	  control and mark characters.
	* src/libobj.scm (write-object <regexp>): Use \U syntax for the
	  unicode chars beyond BMP.

	* src/regexp.c (Scm_RegComp): Avoid keeping the original pattern
	  string as the value of regexp->string.  The regexp->string return
	  value is calculated from AST when it is used for the first time.
	  Rationale: There's a many-to-one mapping from input string to
	  the actual regexp.  We use regexp->string value to make the
	  external representation of regexp, and we need proper escaping
	  for that.  But escaping "non-canonical" input string gets pretty
	  cumbersome.  For example, both "\\/" and "/" would be parsed as
	  (0 #f #\/), and when printed, both should be printed as #/\//.
	  It is easier to make regexp->string return "/" in both cases.
	  A side effect: #/abc/i is now printed as #/(?i:abc)/, reflecting
	  the internal AST representation.  Let's see if this becomes
	  an issue.
	* src/libobj.scm (write-object <regexp>): Rewritten to adapt
	  the above change, and also to use \uXXXX for non-printable
	  characters.
	* lib/gauche/regexp.scm (regexp-unparse): Do not display extra
	  grouping (?:..) unless necessary in repetition, e.g. #/a?b/
	  instead of #/(?:a)?b/.  The extra grouping becomes annoying
	  because of the above change, although it isn't logicaly incorrect.
	* src/char.c (charset_print_ch): Fixed a bug that didn't escape
	  '\' within charset.

2012-06-04  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (gconcatenate): Added.

2012-06-02  Shiro Kawai  <shiro@acm.org>

	* src/Makefile.in: Avoid race between install-aux and relink in
	  make -j install.

2012-05-31  Shiro Kawai  <shiro@acm.org>

	* ext/threads/thread.c (Scm_ThreadTerminate): Fixed SEGV bug when
	  thread-terminate! is called on a thread that's not running.

2012-05-28  Shiro Kawai  <shiro@acm.org>

	* gc/dyn_load.c: Backport a patch for NetBSD 6.

	* release 0.9.3.3

2012-05-27  Shiro Kawai  <shiro@acm.org>

	* src/port.c (Scm__SetupPortsForWindows): Protect the original
	  scm_stdout and scm_stderr from being GC-ed, for not having fd 1 and 2
	  open causes problems when spawning child processes and communicate
	  with them via pipes.  Thanks to @natsutan for tracking the problem.
	* src/main.c (init_console): make sure fd 0, 1, and 2 are redirected
	  to NUL in no console mode.

	* src/string.c (Scm_StringScanRight, Scm_StringScanCharRight),
	  src/libstr.scm (string-scan-right): Added.

2012-05-26  Shiro Kawai  <shiro@acm.org>

	* gc/*: Bumped to bdwgc 7.2b.

2012-05-25  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (every): In multi-arg case, the return value
	  should have been the first non-false return value of PROC but
	  it was #t.  Patch from leque.
	* lib/util/stream.scm (stream-every): Similar fix as above for
	  the consistency.  Patch from leque.

	* src/gauche/vm.h, src/signal.c (SCM_NSIG): On FreeBSD, NSIG doesn't
	  count RT signals, having caused signal.c overrun when setting
	  a handler for SIGRT* signals.  Thanks to Vitaly Magerya for
	  tracking this down.

2012-05-24  Shiro Kawai  <shiro@acm.org>

	* test/system.scm (normalize): Avoid using $HOME to calculate the
	  expected value of tilde-expansion, for $HOME may be altered
	  during testing.  Use getpwuid instead.

2012-05-12  Shiro Kawai  <shiro@acm.org>

	* src/Makefile.in: If install location was redirected by DESTDIR,
	  install-aux target in src/Makefile failed, since it tried to
	  use ./gosh which was already relinked to use libgauche.so under
	  $(libdir).   Changed the order of install-aux and install-core
	  so that we'll first install headers and scripts, then relink and
	  install binaries.

	* lib/text/info.scm (read-info-file-split): Since we now have rfc.zlib,
	  use it instead of external gunzip process to read compressed
	  info files (bonus: it works on Windows/MinGW too).

2012-05-11  Shiro Kawai  <shiro@acm.org>

	* release 0.9.3.2 : Follow-up release.

	* doc/extract: Fixed a bug that caused doc build fail if native
	  encoding isn't utf-8.  The bug was introduced by out-of-tree
	  build modification.

2012-05-10  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (%vm-parameter-ref, %vm-parameter-set!): The
	  compatibility definition of these procedures was incorrect.
	  If files using parameterize and precompiled by 0.9.2 or before
	  are used in 0.9.3 an error will be signalled.  Let's see how big
	  the problem will be and decide whether we'll make another follow-up
	  release or not.

	* lib/gauche/procedure.scm (generator-map): Fixed a bug that depended
	  on argument evaluation order.

	* release 0.9.3.1 : Special follow-up release for MinGW because
	  of the previous bug.

	* src/libsys.scm (check-trailing-separator): It raised an error
	  erroneously when "" is given.  It prevented self-building
	  0.9.3 on Windows/MinGW.

	* lib/gauche/portutil.scm, lib/gauche/procedure.scm: Removed
	  duplicated definitions of port-fold etc. which was need to compile
	  0.9.3 by 0.9.2.  The procedures are kept as aliases of
	  generator-fold etc.
	* src/autoloads.scm: Autoload port-fold etc. from gauche.procedure
	  instead of gauche.portutil.

2012-05-09  Shiro Kawai  <shiro@acm.org>

	* release 0.9.3

2012-05-08  Shiro Kawai  <shiro@acm.org>

	* src/parameter.c, src/gauche/parameter.h, src/libeval.scm,
	  libsrc/gauche/parameter.scm: Fixed semantics of parameters created
	  by other threads.  Accessing parameters created by unrelated threads
	  used to be an error; now it works as if the parameter is defined
	  in every thread.  This reduces the annoyance if parameter creation
	  timing is shifted by autoloads, for example.
	  The internal API is slightly changed.  See the comment in
	  src/libeval.scm.
	* src/load.c: Adapted to the above change.

2012-05-07  Shiro Kawai  <shiro@acm.org>

	* winnt/*: Removed old MSVC project files and NSIS-related
	  sources.  Using MinGW and WiX is now the official way to build
	  Windows native version.  If anyone wants to support alternative
	  builds, she can always resurrect those files from the repository.

	* src/liblist.scm, libsrc/srfi-1.scm: Moved remove, remove! and
	  filter-map to the core.

	* gc/libatomic_ops: Backported d923334022938240c43c167d66549b1211aed2ba
	  of git://github.com/ivmai/libatomic_ops.git to avoid build errors
	  on certain Xcode version.

2012-05-05  Shiro Kawai  <shiro@acm.org>

	* ext/tls/Makefile.in, ext/tls/system-fix.c, ext/tls/kick_openssl,
	  ext/tls/test.scm, ext/tls/axTLS/ssl/test/killopenssl.sh,
	  ext/tls/axTLS/ssl/test/ssltest.c: TLS test fixes
	  - Avoid using system(), for it doesn't go well with MT on some
	  OSes (e.g. OSX).  This fix calls /bin/sh explicitly, which may
	  have its own problem, but let's see.
	  - Avoid using 'ps' to extract openssl servers to kill.  Instead,
	  we intercept openssl invocations and record pids.  This (1) avoids
	  complications of 'ps' difference between OSes, and (2) prevents
	  collateral damange when there are more than one test is going on.
	  Again, this fix is quite a kludge and may have other problems.
	  Note that we substitute strings "openssl " in the ssltest.c in
	  order to make this work, so be careful changing ssltest.c not to
	  include the code that can be affected by this substitution
	  inadvertently.

2012-05-03  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-27.scm: Fixed bugs in random-source-make-reals.
	* ext/mt-random/test.scm: Added tests for srfi-27.

2012-05-01  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator (x->generator): The implementation for
	  the generic collection was incorrect.

2012-04-20  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test.scm (test-end, test-summary-check): Extended
	  the module to enable exitting gosh with nonzero status so that
	  it can be detected by make and/or other build monitoring tools.

2012-04-18  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test.scm (arity-invalid?): Exclude check on generics
	  with no methods.  See the comment.

2012-04-14  Shiro Kawai  <shiro@acm.org>

	* ext/tls/Makefile.in, ext/tls/tls.ac, ext/tls/tls.c,
	  ext/tls/gauche-tls.h: Enable compilation with --disable-tls.
	* lib/rfc/http.scm: Fixed to raise a proper error when :secure
	  is given on a platform without tls support.

2012-04-12  Shiro Kawai  <shiro@acm.org>

	* libsrc/util/match.scm (validate-pattern): Temporary fix for
	  interference with hygienic macro.

	* src/liblazy.scm (lcons*, llist*, liota): Added for completeness.
	* doc/corelib.texi: Added lazy sequence examples.

2012-04-11  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (Scm__VMUnprotectStack),
	  src/lazy.c (Scm_ForceLazyPair): Fixed a bug that corrupts VM stack
	  when lazy-pair forcing occurs during a comined instruction such
	  as CAR-PUSH.  The original code pushed an extra continuation frame
	  during forcing to protect the stack.  If that happened, CAR-PUSH
	  pushes the result on top of the extra continuation.  However,
	  the next instruction to be executed after this CAR-PUSH will be
	  RET, set by Scm__VMProtectStack, which discards the just pushed
	  value by CAR-PUSH.  The fix correctly adjusts the VM stack
	  after forcing is done.

	* src/librx.scm (regexp-num-groups, regexp-named-groups): Added
	  accessors to these internal info.
	* doc/corelib.texi: Made reference from regexp-replace-all to
	  lrxmatch and grxmatch.

2012-04-03  Shiro Kawai  <shiro@acm.org>

	* src/libeval.scm (add-load-path): Enable adding load path
	  relative to the currently loaded file.  Handy to distribute
	  scripts that can just copied by directories.

2012-03-31  Shiro Kawai  <shiro@acm.org>

	* src/vm.c, src/gauche/vm.h: Changed continuation frame structure.
	  It turned out we don't need to save argp, so we have one word less
	  in each cont frame.  Previously we marked C continuation frame
	  by argp=NULL; now it is marked by a special value in env.
	  The C continuation frame is also changed to have pushed data
	  before ScmContFrame, which is symmetric to ordinary continuation
	  frames.  6-8% performance improvement is observed in heavily
	  recursive micro benchmarks (e.g. fibonacci or ackerman).

2012-03-30  Shiro Kawai  <shiro@acm.org>

	* src/char.c (Scm_CharSetCaseFold), src/regexp.c (match_ci):
	  Fixed case-folding match beyond ASCII range.  Patch from
	  OOHASHI Daichi.

2012-03-26  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-request, http-default-redirect-handler):
	  Fixed the behavior of redirection for 3xx responses, and made it
	  customizable.

2012-03-21  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/cookie.scm (parse-av-pairs): RFC2616 allows period
	  appear in cookie attr name.  Fixed.  (Patch from Kirill Zorin).

	* libsrc/gauche/parameter.scm (object-apply): Splitted methods for
	  getter and setter; it makes arity checking work better.

	* lib/gauche/test.scm (test-module): Added a feature to check arity
	  of global procedures, based on the patch by Masahiro Hayashi.
	* lib/rfc/ip.scm, lib/binary/ftype.scm: Fixed bugs catched by the
	  above check.

	* src/class.c (<bottom>), src/libobj.scm (subtype?): Added the bottom
	  type <bottom>, and type relation predicate subtype?.  <bottom> is
	  needed for applicable? to be useful.
	* doc/corelib.texi, doc/object.texi: Reorganized a bit to have
	  brief introduction of type/class system on top of corelib.texi.

2012-03-19  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm: Removed consume, for it is the same thing
	  as generator-for-each.

	* lib/gauche/procedure.scm (generator-fold, generator-fold-right,
	  generator-for-each, generator-map): Supersedes port-fold etc.
	  (To avoid build compilication, we still keep port-fold etc.
	  in portutil.scm until 0.9.3 release; see the comments in
	  portutil.scm.)
	* src/autoloads.scm: Added autoloads for the above procedures.
	* various files: Replaced port-for-each to generator-for-each etc.

2012-03-17  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-42.scm: Added :generator ec-qualifier.

2012-03-16  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (do-generator): Added.

2012-03-14  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (fold-left): Added according to R6RS, for the
	  completeness.

2012-03-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/portutil.scm (port-map, port-fold): Guarantee to call
	  fn before retrieving the next item by the reader; it just makes
	  more sense.

2012-02-26  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (send-headers): Try to send headers in one chunk,
	  for some http servers prefer headers coming in a single packet.

	* src/compile.scm (quasiquote): Fixed a broken hygienity bug in
	  unquote-splicing handling used within hygiene macros.

	* src/vminsn.scm (NUMIDIV2), src/libnum.scm (/.),
	  src/number.c (scm_div):  There was an overflow issue in NUMIDIV2 and
	  /. when both the dividend and the divisor are too big to be coerced
	  to double, but the result can be representable in double.  We
	  shouldn't coerce the arguments to inexact beforehand.  To address
	  this, we delegate exact / exact -> inexact case into Scm_DivInexact
	  C routine.  Now, Scm_DivInexact has been used for the backward
	  compatibiltiy of `inexact-/' (compat.norational) but its behavior
	  is different from `/.'.   We changed Scm_DivInexact to match the
	  behavior of `/.', and added Scm_DivCompat to support `inexact-/'.
	  The compatibility behavior will be removed in 1.0.

2012-02-22  Shiro Kawai  <shiro@acm.org>

	* ext/tls: Added TLS/SSL support module based on Cameron Rich's axTLS.
	  The binding is originally written by Kirill Zorin.  If building
	  of axTLS fails, configure with --enable-tls=none to suppress
	  building it.
	* lib/rfc/http.scm: Repleaced TLS/SSL support with ext/tls, from
	  the previous ad-hoc stunnel-based one.

2012-02-21  Shiro Kawai  <shiro@acm.org>

	* ext/peg/peg.scm: Rewrote using lazy sequences instead of
	  specialized streams for input.  Also simplified API (e.g. dropped
	  $do* and $do distinction, for they are more a performance hack
	  rather than a benefit for users.)  This may degrade the performance.
	  We rely on future compiler improvements to address the performance
	  issue.  Do not count on the current API; they're still subject to
	  change.

2012-02-20  Shiro Kawai  <shiro@acm.org>

	* src/Makefile.in: Fixed install process to call makeverslink
	  before using gauche-install; the latter depends on the installed
	  libgauche.so to be properly symlinked.

2012-02-19  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (consume): Added.

2012-02-18  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (map, for-each), src/proc.c (Scm_Map, Scm_ForEach):
	  Define these in Scheme.  The C API is obsoleted; they are just
	  calling Scheme version now, and will be gone in 1.0.

2012-02-17  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (glet*, glet1): Added convenience macors
	  that captures the monadic pattern frequently appear in generator
	  code.

2012-02-14  Shiro Kawai  <shiro@acm.org>

	* src/load.c, src/libeval.scm (load, find-load-file): Moved Scm_VMLoad
	  and Scm_FindFile functions from C to Scheme.  C API Scm_VMLoad()
	  remains for the backward compatibility.  Scm_FindFile() is deleted,
	  for it was never made public.
	  (%add-load-path-hook!, %delete-load-path-hook!): *EXPERIMENTAL*
	  Added a mechanism to trigger a hook function when *load-path* includes
	  a regular file instead of a directory.  The hook function allows
	  the application to load files from archive files (e.g. zip fie).
	  See libeval.scm for the details.

2012-02-12  Shiro Kawai  <shiro@acm.org>

	* src/libsys.scm, lib/gauche/fileutil.scm (file-exists?),
	  (file-is-regular?, file-is-directory?): Moved these from fileutil
	  to libsys.scm because of the dependency.
	* src/autoloads.scm: Changed accordingly.

2012-02-11  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h (SCM_BIND_PROC): Introduced a macro to capture the
	  common pattern in calling a Scheme procedure from C.  The macro
	  can be used to ensure a C variable is initialized by the value
	  of the named Scheme variable (so it isn't restricted to 'PROC',
	  but in practice using it for something other than procedure doesn't
	  make much sense.)
	* src/load.c, src/vm.c, src/system.c: Changed accordingly.

2012-02-10  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm__InternalCondWait): Fixed a hazard when timeout
	  occurs.  Also fixed the handling of cond->mutex so that it is safe
	  to call CondSignal and CondBroadcast without holding the related
	  mutex (although it's not recommended).

2012-02-07  Shiro Kawai  <shiro@acm.org>

	* ext/sxml/*: Fixed a problem that out-of-source-tree build generated
	  some Scheme files into srcdir instead of builddir.

	* src/compile.scm (pass1/open-include-file),
	  src/gauche/vm.h (SCM_COMPILE_INCLUDE_VERBOSE),
	  src/main.c (-finclude-verbose): Add a new compile-time flag to
	  report 'include' operation to stderr.  It is separated from
	  -fload-verbose, since 'include' works in compile-time and
	  'load' works in runtime (although typically they are interleaved).

	* src/libio.scm (open-input-file): Allow ":encoding #t" to make
	  open-input-file wrap the iport with a coding-aware port.  It's
	  convenient to process source files that may have coding comment.

2012-02-06  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (Scm_AttachVM, Scm_DetachVM): Protect active VMs explicitly
	  from GC.  Thread-specific area may not be scanned by GC.

2012-02-05  Shiro Kawai  <shiro@acm.org>

	* ext/net/net.c (Scm_MakeSocket): Fix Windows/MinGW problem that
	  sockets can't be used with threads.  Thanks to SAITO Atsushi for
	  tracking this down.

2012-02-03  Shiro Kawai  <shiro@acm.org>

	* src/liblist.scm (iota): Fixed a bug in the case of inexact
	  number sequence (thanks to Toshihiro Morisaki).

2012-01-31  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/lazy.scm: More lazy sequence utilities.
	* doc/modgauche.texi: Documented gauche.lazy.

2012-01-29  Shiro Kawai  <shiro@acm.org>

	* lib/util/stream.scm (stream-count): Bug fix (thanks to KOGURO Naoki).

2012-01-27  Shiro Kawai  <shiro@acm.org>

	* Makefile.in, wirebuildlibs, configure.ac, gc/configure.ac,
	  */Makefile.in, ext/xlink, */tset.scm, src/main.c: Re-enable
	  out-of-source-tree build.  Just call top configure from
	  any directory and it should build and install with make &
	  make install.

2012-01-25  Shiro Kawai  <shiro@acm.org>

	* src/class.c (Scm_MethodApplicableForClasses),
	  lib/gauche/procedure.scm (applicable?): Added applicable?.
	* src/autoloads.scm, doc/corelib.texi, test/object.scm: Changed
	  accordingly.

2012-01-23  Shiro Kawai  <shiro@acm.org>

	* src/gauche/pthread.h: Fix for cygwin pthread: Real-time signals
	  are not available on cygwin, so we use SIGPWR for inter-thread
	  communication.  Nees to be documented.

	* src/Makefile.in: Exclude unnecessary object files in gc/ to be
	  linked to libgauche.so.

	* configure.ac, src/Makefile.in, src/gauche.h: The previous trick,
	  committed for Win32 thread support, to extract GC thread config
	  settings and adding it to gauche/config.h, doesn't work.  The extra
	  code won't be executed by running ./config.status.  So we changed
	  the strategy---at build time, we generate gauche/config_threads.h
	  from the GC's thread configuration.

2012-01-21  Shiro Kawai  <shiro@acm.org>

	* src/port.c (Scm__SetupPortsForWindows): Made implicit
	  AllocConsole() thread-safe for gosh-noconsole.
	* test/win-noconsole-threads.scm: Manual test for the above feature.

	* ext/threads/threads.scm (gauche-thread-type): Returns 'win32
	  on Windows/MinGW threads support.

2012-01-20  Shiro Kawai  <shiro@acm.org>

	* configure.ac, src/gauche/wthread.h, src/system.c, src/vm.c,
	  src/core.c, ext/threads/*, ext/util/queue.scm: Added support of
	  Windows thread on MinGW.  Run ./configure --enable-threads=win32
	  to enable the support.  Unit tests pass, but needs more test
	  with actual applications.

	* src/load.c (Scm_Require): Fix a hazard in parallel require case;
	  the loop around condition variable wait wasn't actually looped
	  due to the bug.  Thanks to Kirill Zorin for tracking this down.

	* src/core.c (finalizable): Fix to protect in the case that GC
	  is run before Gauche is fully bootstrapped.

2012-01-18  Shiro Kawai  <shiro@acm.org>

	* doc/*: Documented basic lazy sequence operations.
	* lib/gauche/lazy.scm (lappend): Added.  Will add more lazy
	  sequence utilities.

2012-01-08  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (grxmatch, port->char-generator)
	  (port->byte-generator): Added stream regexp match generator
	  grxmatch, and a couple of convenience procedures to read
	  from an input port.

2012-01-07  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (gcons*, gappend): Changed gcons -> gcons*,
	  for it's more general.  Modified gappend to delay autocoercing
	  the arguments, so that gappend can be used as a lightweight lazy
	  sequence concatenation.

2012-01-06  Shiro Kawai  <shiro@acm.org>

	* src/class.c (method_more_specific): Don't panic if
	  method-more-specific? gets two methods that can't be ordered;
	  It may be just an erroneous MOP code.  Now we throws an error
	  with descriptive messages.

2012-01-03  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm: Allows generator operations to take
	  collections, which are implicitly coerced to generators, for
	  the convenience.

2011-12-27  Shiro Kawai  <shiro@acm.org>

	* lib/util/list.scm, src/liblist.scm, src/libdict.scm,
	  lib/gauche/common-macros.scm, src/autoloads.scm: Obsoleted
	  util.list; entries are moved to liblist, libdict and common-macros.
	  The module is kept for the backward compatibility, but its officially
	  removed from the document.

2011-12-26  Shiro Kawai  <shiro@acm.org>

	* src/gauche/wthread.h, src/gauche/vm.h, src/vm.c, src/signal.c,
	  ext/threads/mutex.c, ext/threads/threads.c, configure.ac:
	  Start adding Windows thread support on Gauche/MinGW, and improved
	  thread-terminate! semantics.  On POSIX, if real-time signal is
	  available, we reserve one signal (GAUCHE_PTHREAD_SIGNAL) to notify
	  termination request.  With the signal, the terminated thread can
	  shut itself down gracefully.  We also use vm->stopRequest mechanism
	  to terminate the thread.

2011-12-25  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/cise.scm (.if): Make sure '#if' stars from the
	  fresh line.
	* src/libsys.scm: The fd range check added recently was invalid on
	  Windows/MinGW (see the comment).  Conditionalized.

	* gc/*: Updated to gc7.2-alpha6.

	* src/compile.scm (quasiquote): Fixed to recognize unquote and
	  unquote-splicing hygienically.

	* lib/control/job.scm: Added 'cancellable' job flavor, which may not
	  be waitable but job-mark-killed! can be used on.  We need mutex
	  if we allow threads other than the job runner to change the job
	  status.  See the comment for the details.
	* lib/control/thread-pool.scm: Use cancellable jobs, for we might
	  want to kill them.

	* ext/threads/mutex.c, ext/threads/threads.scm:
	  (mutex-locker, mutex-unlocker): Added.
	  (with-locking-mutex): rewrite using above, and made it inline.
	  This change prevents with-locking-mutex from making closures
	  at runtime.

2011-12-24  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm: Extended API
	* doc/modgauche.texi: Documeted gauche.generator.

2011-12-23  Shiro Kawai  <shiro@acm.org>

	* src/port.c (Scm_FdReady),
	  src/libsys.scm (sys-fdset-ref, sys-fdset-set!): Check if fd is
	  in the valid range.

2011-12-22  Shiro Kawai  <shiro@acm.org>

	* src/string.c (Scm_MaybeSubstring): Allow #f as start or end arguments,
	  for the convenience.

	* src/liblist.scm, libsrc/srfi-1.scm, lib/util/list.scm: Moved
	  take-right, drop-right, take!, drop-right!, take*, drop*,
	  take-right*, drop-right* and split-at* to the core.

2011-12-21  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm (generate): Added coroutine-based
	  generator.
	* doc/modgauche.texi: Start adding generator documents.

2011-12-20  Shiro Kawai  <shiro@acm.org>

	* src/main.c: Added '-m module' option to specify the module where
	  the 'main' procedure is looked for when a script is loaded.
	* test/scripts.scm: Added a test for the above.  Eventually we can
	  add more tests for command-line options of gosh.

2011-12-18  Shiro Kawai  <shiro@acm.org>

	* src/string.c (Scm_StringBodyPosition): Deprecate Scm_StringPosition
	  since it is difficult to use in MT-safe way.  Introduced safer
	  Scm_StringBodyPosition.

2011-12-10  Shiro Kawai  <shiro@acm.org>

	* lib/control/job.scm (job-wait): fixed a bug that it looked result
	  where it should've looked status.
	  (job-run!, job-mark-killed!): Called condition-variable-broadcast!
	  with a wrong argument.  Patch for this and above bugs are from ayatoy.

2011-11-28  Shiro Kawai  <shiro@acm.org>

	* configure.ac, src/gauche/config.h.in (HAVE_CRT_EXTERNS_H),
	  src/system.c (Scm_Environ): Newer OSX doesn't allow to access
	  global environ variable directly; we should use _NSGetEnviron().

	* lib/gauche/cgen/cise.scm: Added .undef macro
	* src/libsys.scm: Fix for mingw.

	* configure.ac: Enable HAVE_SELECT on Windows/mingw, altohugh on it
	  select() can only be used on sockets.
	* src/system.c, src/port.c: Changed accordingly.

2011-11-26  Shiro Kawai  <shiro@acm.org>

	* src/*, ext/auxsys, lib/*, doc/*, libsrc/*: Code reorganization:
	  src/*.stub and src/*.scm files are merged, and then splitted
	  accodring to each function's feature instead of the module it
	  belongs.  This keeps related code together and eases maintenance.
	  The new sources are named as src/lib*.scm.
	    By this change, we hide some internal routines into gauche.internal;
	  which we couldn't do before, since each *.stub file could be
	  associated to one module.  Now we can switch the modules inside
	  precompiled scm files as we like.
	    We also merged ext/auxsys into core (mostly in libsys.scm), for
	  we no longer need them to be in an extension module.
	    We've already moved some list utilities from srfi-1 into core;
	  by this commit we do so more, and updated the document accordingly.
	    We also removed SCM_DEBUG_HELPER conditional; we've never had it
	  turned off, so we can just always keep those debug routines.  NB:
	  Those debug dump routines (%*-dump) are now in gauche.internal
	  module.
	* lib/gauche/cgen/precomp.scm: *Experimental*: Allow define-cproc
	  to appear as the toplevel form.  It is easier to read than always
	  putting them in inline-stub.  I might change my mind later, for
	  it may be confusing as well.

2011-11-24  Shiro Kawai  <shiro@acm.org>

	* src/code.c (Scm_CompiledCodeDump): Fixed a bug that can cause
	  infinite loop when printing lifted procedures.

	* src/compile.scm (subst-lvars): The traversal of $LET didn't update
	  lvar-initval, causing the following passes to fail to do some
	  closure elimination.
	  (pass1/define-inline): Wrong check of `closed' value caused
	  all define-inline'd procedures to go through the slower pass.
	  The above to bugs prevented the procedures defined in define-inline
	  from being optimized enough.  Notably, local tail-calls didn't
	  get optimized to loops.

2011-11-20  Shiro Kawai  <shiro@acm.org>

	* src/genconfig (gauche-config): Emit usage message to stderr instead
	  of stdout.  By this, feeding gauche-config output to sh wouldn't
	  confuse sh if you give incorrect option.

	* lib/gauche/cgen/stub.scm (<stub>): Fix the problem that cproc's
	  binding isn't inserted into the tmodule at the time of define-cproc,
	  but at the time of the final rendering.
	* lib/gauche/cgen/precomp.scm: Fixed a similar bug.

	* src/scmlib.scm (generator->lseq): Renamed from lseq to make
	  it more descriptive, since it turned out this function wouldn't
	  be used frequent enough to demand a short name.

2011-11-19  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c (rc1_parse, rc3_rec): Fixed regexp parser and code
	  generateor to recognize BOL/EOL assertions within (?=...),
	  (?!...), (?<=...), (?<!...) and (?>...).  For '^' and '$, we
	  should parse these constructs as if they are stand-alone, no
	  matter where they appear.  That is, '^' appearing at the
	  beginning of these constructs are BOL assertions and '$' at
	  the end are EOL.  This is consistent to Perl and Oniguruma.
	  NB: The code that counted on the previous (buggy) behavior
	  may break by this change.

2011-11-11  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vm/debugger.scm, src/autoloads.scm: Export
	  debug-print-(pre|post) and set them to be autoloaded.  These
	  symbols are inserted by debug-print macro.  If such a source
	  is pre-compiled, gauche.vm.debugger won't be autoloaded at
	  execute time unless we make debuf-print-(pre|post) autoloaded too.
	  This is not an ideal solution, for those procs are internal.

2011-11-06  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/tmodule.scm (<tmodule>, all-tmodules): Use a
	  parameter instead of a class slot to record tmodules encountered
	  during precompilatoin.  Class slots are global and fragile for
	  multiple invocation of cgen-precompile and/or MT.
	  (with-tmodule-recording): A macro to initialize the module list.
	* lib/gauche/cgen/precomp.scm, lib/gauche/cgen/stub.scm: Changed
	  accordingly.

2011-11-04  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/common-macros.scm (values->list): Support a common
	  pattern.  CL's multiple-value-list.
	* src/autoloads.scm (values->list): changed accordingly.

2011-10-29  Shiro Kawai  <shiro@acm.org>

	* src/lazy.c (Scm_ForceLazyPair): Fixed a bug that the second value
	  from the generator could have leaked out.

2011-10-28  Shiro Kawai  <shiro@acm.org>

	* ext/util/queue.scm (make-mtqueue, enqueue/wait!, dequeue/wait!):
	  Added support of zero-length mt-queue.  Zero-length queue cannot
	  hold any values, but can be used to synchronize producers
	  and consumers---a thread can directly hand a value to another
	  thread.  THIS IS AN INCOMPATIBLE CHANGE: It used to be that
	  zero max-length meant to be unlimited length.  Now you have to
	  give #f to max-length to make the mtqueue unlimited length.
	* ext/threads/test.scm: Tests added for zero-length queue.
	* lib/control/thread-pool.scm: Changed accordingly.

	* lib/rfc/http.scm (http-proxy): Added a parameter to specify the
	  default http proxy.

	* libsrc/file/util.scm (touch-file, touch-files): Extended to
	  take :time, :type and :create options; these are similar switches
	  the touch(1) command has.  Also, touch-files hasn't been exported
	  although the manual has its entry.
	* ext/file/test.scm: Added tests accordingly.

2011-10-24  Shiro Kawai  <shiro@acm.org>

	* src/regexp.h (ScmRegexpRec), src/regexp.c (rc3, Scm_RegExec):
	  Improved unanchored regexp search by skipping the input.  We
	  calculate a set of characters that can possibly match at the
	  beginning of the regex (lookahead set, or laset).  When we
	  advance the input pointer, we check the character and if it
	  isn't in the laset we can skip matching from that position.
	  We also adopt a strategy that when /A+B/ fails to match, where
	  A is a char or charset, and A and B has distinct laset,
	  then we can skip the input as long as it matches A.  These
	  strategy improves the performance greatly in commonly occurring
	  patterns, especially when the input is long.
	* test/regexp.scm, src/extlib.stub: Added some tests.

2011-10-17  Shiro Kawai  <shiro@acm.org>

	* src/scmlib.scm (make-case-lambda),
	  src/intlib.stub (make-case-lambda-dispatcher),
	  src/compile.scm (case-lambda): Changed case-lambda info vector
	  for better diagnostics; the first element now contains the
	  procedure name if available.
	  NB: Eventually we intend to change case-lambda to be a special
	  object instead of the current hack with subr.  The current way
	  of using info slot is temporary.
	* lib/gauche/procedure.scm (disasm): Adapted to the above change.

2011-10-16  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/regexp.scm (regexp-unparse): Handles '|' and control
	  characters properly.

2011-10-15  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c (rc3_rec): Fixed the bug that (regexp-compile '(alt))
	  gets Bus Error.  Now we allow empty altenation.  Although such
	  AST never happens as a result of parsing string regexp, it may
	  be produced in programmatically generated AST.  An empty alternation
	  always fails.
	* lib/gauche/regexp.scm (regexp-unparse): When converting empty
	  alternation to a string, we use negative lookahead assertion (?!),
	  since such alternation can't be represented using '|' operator.
	  Also fixed a bug when converting empty assert/nassert nodes.

2011-10-05  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/json.scm (print-string): Fixed string writer bug that didn't
	  handle ASCII control characters and chars between [U+80,U+fff].

2011-09-30  Shiro Kawai  <shiro@acm.org>

	* src/lazy.c (Scm_ForceLazyPair): Added check of recursive forcing
	  to prevent self-deadlock.

2011-09-28  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/lazy.scm (lfilter): Added for the convenience.

	* lib/gauche/generator.scm (grange): Added grange for the convenience.

2011-09-16  Shiro Kawai  <shiro@acm.org>

	* src/lazy.c (Scm_DecomposeLazyPair), src/extlib.stub (%lazy-snoc),
	  src/scmlib.scm (%lcons), lib/gauche/common-macros.scm (lcons):
	  Added support of lcons, a primitive to write corecursive code.

2011-09-12  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h (SCM_PAIRP),
	  src/lazy.c (Scm_PairP, Scm_ForceLazyPair, Scm_MakeLazyPair),
	  src/class.c (SCM_CLASS_OF), src/extlib.stub (%lazy-cons),
	  src/scmlib.scm (lseq, lrange), lib/gauche/lazy.scm:
	  Added lazy sequence support.
	* lib/gauche/cgen/stub.scm, src/vm.c, src/gauche/vm.h,
	  src/vmcall.c, src/vminsn.scm: Modifications to make lazy sequences
	  forced safely.
	* src/Makefile.in: Make sure *.stubs are reprocessed if gauche.cgen.stub
	  is updated.  It is crucial for this commit, since the *.c files
	  generated by previous genstub aren't safe for lazy sequences.
	* test/primsyn.scm: force/delay tests are moved to test/lazy.scm.
	* test/lazy.scm, ext/gauche/test-lazy.scm: lazy evaluation tests.
	* test/lazy-performance.scm: some code for benchmarking.

	* src/vm.c (user_eval_inner): We no longer save the signal mask and
	  restore it in case of the error.  We don't see any reason to restore
	  the mask.  From the commit logs, this mask manipulation was
	  originally kept in 2004-03-15 change; it says, without restoring
	  the mask, a hang occurred on cygwin.  We can no longer reproduce
	  the hang, so we decided to drop this code.  It has now become
	  a major slowdown factor.

2011-08-25  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_GetTimeSpec): Fixed a bug that didn't handles
	  exact rationals properly (it was rounded down to the nearest
	  integer).
	* ext/threads/test.scm: Improved thread-sleep! test.  Thread-sleep!
	  was affected by the above bug.

2011-08-23  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass2/shrink-let-frame): A small optimization
	  possibly replaces let to nested function call.

2011-08-22  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/common-macros.scm ($): Incorporated the chained apply
	  macro into the core.  Note that the semantics is slightly changed;
	  we drop $* macro, and the $ and $* delimiters determines whether
	  apply to be used for the procedure *before* the delimiter.
	* src/autoloads.scm: Changed accordingly.
	* lib/gauche/experimental/app.scm: Now this is just a placeholder.

2011-08-17  Shiro Kawai  <shiro@acm.org>

	* src/gauche-package.in ("list"): "gauche-package list" now displays
	  packages that are installed by other versions of Gauche, as far
	  as it is abi-compatible to the current gauche version.

2011-08-11  Shiro Kawai  <shiro@acm.org>

	* src/promise.c: Renamed to lazy.c
	* src/lazy.c (Scm_Force): Made force thread-safe.  Now more than
	  one thread can call force simultaneously.
	* ext/threads/test.scm: Added tests for thread-safe force.

2011-08-10  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (lazy): Directly generates $ASM node, eliminating
	  the need of $PROMISE IFrom node.  We have to keep $PROMISE node
	  throughout 0.9.x series for the compatibility of precompiled
	  files in earlier 0.9.x versions, but it will go away in 1.0.

	* lib/gauche/cgen/literal.scm (<cgen-scheme-symbol>): Handle
	  unintered symbols.

	* src/code.c (Scm_CompiledCodeDump): The disassembler now shows
	  the closures lifted to the toplevel procedures.

2011-08-08  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_Quotient): Fixed a bug in the path of
	  inexact quotient calculation.  The path is
	  used by div and mod, relvealing the bug.

2011-08-05  Shiro Kawai  <shiro@acm.org>

	* release 0.9.2.

2011-08-02  Shiro Kawai  <shiro@acm.org>

	* libsrc/srfi-1.scm: Export procedures that are defined in the gauche
	  core.  They are not exported from the gauche module, but they should
	  be exported from srfi-1.

	* lib/rfc/uri.scm (uri-merge): Fix a bug when base-path is empty
	  and rel-path is relative.

2011-08-01  Shiro Kawai  <shiro@acm.org>

	* configure.ac, src/gauche/arith_x86_64.h: Added inline assembly
	  of fullword numberic operations for x86_64.
	* src/bignum.c: Some routines used incorrect type (long vs int) as
	  the argument for arith macros.  On ILP32 machines it didn't matter,
	  but on LP64 it does.

	* src/number.c (scm_mul): The previous version of overflow detection
	  of multiplying two longs depended on C's undefined behavior.
	  clang-llvm does certain optimizations as if the calculation never
	  overflows, and that's valid, since once calculation overflows the
	  result can be anything.  Fixed to use SMULOV macro in gauche/arith.h
	  which detects overflow reliably (but the portable fallback is
	  expensive).

2011-07-31  Shiro Kawai  <shiro@acm.org>

	* test/multibyte.scm, test/char.scm: Splitted multibyte tests
	  and char-only tests.  Character case mappings can be tested
	  separately, and we need more tests focused on characters anyway.

	* src/stdlib.stub (char-ci-cmp): Use foldcase to compare
	  case-insensitive character comparison, and support more than
	  2 arguments a la r6rs.
	  (char-cmp): support more than 2 args.

2011-07-30  Shiro Kawai  <shiro@acm.org>

	* doc/modgauche.texi: Documented gauche.cgen; now the API for
	  cgen.unit, cgen.literal and cgen.type are official.

	* lib/gauche/cgen/unit.scm: Dropped :pre-decl and automatic insertion
	  of "#include <gauche.h>".  If we let the module user to insert
	  "#include <gauche.h>", then we don't need pre-decl stuff and it's
	  conceptually simpler.
	* lib/gauche/cgen/stub.scm, lib/gauche/cgen/precomp.scm,
	  src/autoloads.scm, src/builtin-syms.scm: Changed accordingly.

	* lib/gauche/type.scm: Some integer stub types used SCM_EXACTP for
	  checking exact integers; that's an old convention.  After we have
	  ratnums, it must be checked with SCM_INTEGERP.  Fixed.

2011-07-27  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/generator.scm: Added gauche.generator experimentally.
	  API may change later.
	* ext/gauche/test-generator.scm: Tests for gauche.generator.

	* src/gauche/symbol.h (ScmSymbolRec), src/symbol.c (make_sym): Changed
	  'interned' field to 'flags' field for future extension.  See the
	  comment in symbol.h about the binary compatibility.
	* src/builtin-syms.scm: Changed accordingly.

2011-07-26  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen.scm: Include gauche.cgen.cise too.

	* configure.ac (ipv6): Turn on --enable-ipv6 by default.  To compile
	  on a platform that doesn't have getaddrinfo etc, say --disable-ipv6
	  explicitly.

2011-07-25  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm, lib/gauche/cgen/stub.scm,
	  lib/gauche/cgen/tmodule.scm: Dropped the dependency on an implicitly
	  defined local variable 'mod' in the init function.  In the precomp-
	  generated C source, a local variable ScmModule *mod used to be
	  defined to hold the module of the compiled source.  It's ugly
	  to depend on such implicit names, and also it was awkward to
	  handle the situation when multiple modules are defined in the
	  precompiled source.  Now, if you want to refer to the module
	  inside init functin, you can call Scm_CurrentModule().
	* ext/sparse/sparse.scm, ext/threads/threads.scm, ext/text/unicode.scm:
	  Changed accordingly.

	* configure.ac (multibyte): If --enable-multibyte is given without
	  ENCODING, assume utf-8 instead of euc-jp.

	* ext/net/addr.c: Allow comparing socket addresses based on the
	  content; that is, (equal? x y) => #t if x and y represents the
	  same address, even they are different instances.

	* configure.ac, ext/auxsys/auxsysconf.h.in: Check for clearenv()
	* ext/auxsys/auxsyslib.stub, ext/auxsys/auxsys.scm (sys-clearenv):
	  Support clearenv(3).  If we don't have it but have sys-unsetenv,
	  we define sys-clearenv using it.  To check availability, use
	  (or gauche.sys.clearenv gauche.sys.unsetenv) in cond-expand.
	  (sys-setenv): Fixed a bug that you couldn't omit the overwrite
	  optional argument.
	* src/autoloads.scm: Changed accordingly.

	* lib/rfc/cookie.scm (construct-cookie-string): Recognize :http-only
	  cookie attribute introduced in RFC6265.

	* src/write.c (format_proc): Allow ~* to position at the next to
	  the last argument.  (patch from leque.)

	* gc/libatomic_ops-1.2/src/atomic_ops/sysdeps/gcc/x86_64.h,
	  gc/configure.ac, gc/Makefile.in, configure.ac: Fix for MacOSX Lion
	  (patch from KOGURO Naoki).

2011-07-24  Shiro Kawai  <shiro@acm.org>

	* winnt/wix/* : Support Windows installer based on WiX.  This will
	  replace NSIS-based installer.
	* src/mingw-dist.sh: Changed to make wix installer instead of nsis
	  installer.

2011-07-20  Shiro Kawai  <shiro@acm.org>

	* src/char.c, src/char_attr.c, src/gauche/char_attr.h: Added
	  character category and case mapping tables according to Unicode
	  character database.  New/revised APIs: Scm_CharGeneralCategory,
	  Scm_CharAlphabeticP, Scm_CharUppercaseP, Scm_CharLowercaseP,
	  Scm_CharTitlecaseP, Scm_CharNumericP, Scm_CharUpcase,
	  Scm_CharDowncase, scm_CharTitlecase, Scm_CharFoldcase.
	* src/gauche/char_utf_8.h, src/gauche/char_euc_jp.h,
	  src/gauche/char_sjis.h, src/gauche/char_none.h: Some new encoding-
	  specific routines to handle the above functionality.
	* src/stdlib.stub: Changed char-alphabetic?, char-numeric?,
	  char-upper-case?, char-lower-case?, char-upcase and char-downcase
	  to use the new APIs.
	* src/extlib.stub: Added char-title-case?, char-titlecase,
	  char-foldcase, char-general-category.
	* src/gen-unicode.scm: A script to generate character attribute
	  tables from Unicode character database.  The generated files are
	  checked in to repos, so developers don't need to run this script
	  regularly.  Tables need to be regenerated only when Unicode is
	  updated.  To run this script, go down to src/ and do 'make char-data'
	  and follow the instructions.

	* ext/text/unicode.scm, ext/text/unicode_attr.h: text.unicode
	  module provides unicode-defined operations, including unicode
	  encoding conversions, grapheme-cluster and word segmentation,
	  and string-upcase, string-downcase, string-titlecase and
	  string-foldcase.

	* doc/corelib.texi, doc/modsrfi.texi, doc/modutil.texi: Added
	  description of new case handling scheme, text.unicode module,
	  and relation to srfi-13 string-upcase etc.

	* test/chars-strings.scm: Renamed from test/mb-chars.scm and added
	  more tests.

2011-07-13  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass4/scan): Fixed a bug that unnecessarily
	  marked dissolved lambda in pass4, confusing the later passes.

2011-07-09  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/procedure.scm, src/compile.scm, src/scmlib.scm:
	  Moved case-lambda handling into the core.  This is the initial
	  step towards aggresive inlining of case-lambda.
	* src/autoloads.scm: changed accordingly.
	* lib/util/queue.scm: changed to use case-lambda; we couldn't use
	  it because of inter-module dependency.  now case-lambda is in
	  core and we can use it here.

2011-06-30  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/json.scm (print-value, construct-json): Should handle with
	  empty list.  Patch from leque.

2011-06-27  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/redefutil.scm, test/object.scm: Fixed change-class
	  on class metaobjects to work.
	* src/class.c, src/gauche.h, src/objlib.scm: Added a mechanism to
	  'seal' the core slots of class metaobjects that are essential
	  for object system to work; for example, changing num-instance-slots
	  after some instances are created would cause disaster.  Now these
	  core slots can only be set during class initialization.

2011-06-11  Shiro Kawai  <shiro@acm.org>

	* src/port.c (coding_port_recognize_encoding): Fixed a bug in the
	  state machine of encoding magic comment; the lines weren't counted
	  correctly for \r-only or \r\c line endings.

2011-06-10  Shiro Kawai  <shiro@acm.org>

	* src/extlib.stub (integer-length): Fixed a bug in the edge
	  case on the boundary of fixnum/bignum switch.

2011-05-31  Shiro Kawai  <shiro@acm.org>

	* libsrc/file/util.scm (create-directory-tree): Fixed a bug
	  to treat content-less file spec.  Thanks to teppey for the fix.

2011-05-30  Shiro Kawai  <shiro@acm.org>

	* lib/control/thread-pool.scm (worker): Fixed a hazard that the
	  worker flagged it was done before queueing the result.
	  Thanks to enami for spotting this.

	* lib/rfc/json.scm (print-string): Fixed a bug that generates
	  incorrect json string if it contains double-quotes.

2011-05-28  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-60.scm: Added srfi-60 support.  Most of APIs are just
	  aliases or re-exports of Gauche's builtin bitwise operators.
	  There are also several new APIs.
	* doc/concepts.texi, doc/corelib.texi, doc/modsrfi.texi: Adjusted
	  accordingly.
	* test/srfi.scm: Tests for srfi-60 additional procedures.

2011-05-27  Shiro Kawai  <shiro@acm.org>

	* src/extlib.stub (logand, logior, logxor): Allows zero and one
	  argument a la SRFI-60.
	  (integer-length): Moved here, for we now have Scm_BitsHighest*
	  API and we can efficiently implement integer-length.
	* src/autoload.scm, lib/gauche/logical.scm: Removed integer-length.

	* src/number.c (Scm_LogNot, Scm_LogAnd, Scm_LogIor, Scm_LogXor):
	  The argument check was incorrect (probably a leftover from
	  the time we didn't have rationals), allowing rational numbers
	  to passed to bignum routines, causing crash.

2011-05-25  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/common-macros.scm (ecase): Added CL's ecase.
	* src/autoloads.scm: set ecase to be autoloaded.

2011-05-18  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/uri.scm (uri-parse): Added a procedure to resolve relative
	  URI.  Originally written by teppey.

2011-05-15  Shiro Kawai  <shiro@acm.org>

	* src/read.c (read_list_int): Fixed a bug regarding a dot followed
	  by non-space delimiting characters.

2011-04-29  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/extended-lambda): Dropped the support of
	  obsoleted keyword argument spec (var keyword init), in favor of
	  formally supported ((keyword var) init).   The former spec was never
	  supported officially, and the latter is supported officially since
	  0.9, so this change shouldn't affect the user code.
	* lib/gauche/cgen/precomp.scm (cgen-precompile),
	  lib/rfc/http.scm (http-request): Changed accordingly.

	* src/list.c (Scm_Reverse, Scm_ReverseX), src/stdlib.stub (reverse),
	  src/extlib.stub (reverse!): Experimentally added 2-argument reverse.
	  The rationale: If we consider (reverse xs) == (fold cons '() xs),
	  then definining (reverse xs tail) == (fold cons tail xs) looks
	  a natural extension.

	* libsrc/srfi-1.scm (append-reverse, append-reverse!): These are
	  effectively the same as 2-arg reverse and reverse!, so define them
	  accordingly.

	* src/list.c (Scm_MonotonicMerge1), src/extlib.stub (monotonic-merge):
	  Cleaned up API of Scm_MonotonicMerge, and monotonic-merge (the Scheme
	  proc is undocumented; the C API is kept during 0.9.x for the ABI
	  compatibility.)

	* test/list.scm, test/TESTS: Added more tests to list.scm and included
	  it in the standard tests.

	* src/objlib.scm (%expand-define-method): Support extended argument
	  specifications (:optional etc.) in define-method.

2011-04-28  Shiro Kawai  <shiro@acm.org>

	* src/scmlib.scm (map*): Added.
	* test/procedure.scm: Added tests for map*.

2011-04-22  Shiro Kawai  <shiro@acm.org>

	* src/string.c (substring): Fixed a bug that the range check
	  didn't take byterange into account.

2011-04-21  Shiro Kawai  <shiro@acm.org>

	* libsrc/file/util.scm (with-lock-file): Fixed stealing logic.

2011-04-19  Shiro Kawai  <shiro@acm.org>

	* libsrc/file/util.scm (with-lock-file): Added file-based
	  inter-process locking utility.
	* ext/file/test.scm: Added test for with-lock-file.

2011-04-10  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (quasiquote): Added support for zero or multi-
	  argument unquote/unquote-splicing.  They are R6RS compatible.

2011-03-30  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass3/optimize-call): Fixed a bug that may
	  introduce infinite loop in the compiler.

2011-03-24  Shiro Kawai  <shiro@acm.org>

	* ext/threads/thread.scm (atom, atomic, atomic-update!, atom-ref):
	  Added atom, a convenience wrapper for thread-safety.

2011-03-21  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_SysExec): Support SCM_EXEC_DETACHED flag to
	  detach the exec'ed process from the parent's process group.  Useful
	  for starting a daemon process.
	* src/syslib.stub (sys-exec, sys-fork-and-exec),
	  lib/gauche/process.scm (run-process): Support :detached keyword
	  argument.
	* test/system.scm: Added tests for :detached #t.

2011-03-15  Shiro Kawai  <shiro@acm.org>

	* libsrc/util/match.scm (gen): Reverting the change in 2010-05-29 to
	  avoid exponential growth of expansion time.  It turned out that
	  the change can introduce exponential growth of compilation time
	  in certain patterns.  (We still keep the change of 2011-03-06,
	  though).

2011-03-14  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/time.scm (time-this, time-these, time-these/report):
	  Dropped with-times introduced blow, and instead added comprehensive
	  benchmarking utilities inspired by Perl's Benchmark module.

2011-03-13  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/define-inline-finish): Fixed a bug that
	  affects inline expansion during precompilation.  See the comment
	  for the details.   The code since commit d6f23ad1 (2011-03-05)
	  until this fix should not be used to compile Gauche itself, since
	  it yields a corrupt compiler.

2011-03-12  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/time.scm (with-times): Added a new procedure to treat
	  the result of 'time' macro programatically.

2011-03-07  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass4/lift): Set lifted $lambda name
	  comprehensively as possible.  Since lifted lambdas don't have a
	  link to parent code, the scheme of deriving hierarchical name
	  in Scm_CompiledCodeFullName doesn't work.   Instead we give
	  the list (<toplevel-name> <name>) in each lifted $lambda node,
	  where <name> is the node's original name if any, or gensym'ed
	  name.

	* src/main.c (cleanup_main): Fixed -pload option; the original code
	  failed if gauche.vm.profile wasn't loaded.  Since we autoload
	  profiler-show-load-stats, we can evaluate it in the gauche module
	  and we don't need FIND_MODULE(gauche.vm.profile).

2011-03-06  Shiro Kawai  <shiro@acm.org>

	* libsrc/util/match.scm (inline-let, gen): Removed inline-let, since
	  it does the duplicate work with Gauche's compiler.  Also made
	  length>= as a global definition instead of local, since Gauche can
	  inline it anyway.

2011-03-05  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/vm/profiler.scm (entry-name): Workaround a problem when
	  case-lambda generates an output that can't be read back.

	* src/gauche/vm.h, src/intlib.stub, src/main.c: Added a compiler flag
	  -fno-lambda-lifting-pass (SCM_COMPILE_NO_LIFTING) to turn off
	  pass4 for troubleshooting.  Also renamed SCM_COMPILE_NO_PASS2OPT to
	  SCM_COMPILE_NO_POST_INLINE_OPT, for the pass numbers can be changed
	  (and indeed they were changed).

	* src/compile.scm (pass4): Revised pass4 to lift closures for
	  obvious cases (independent, and self-recursive calls).
	  We no longer have compile-toplevel-lambda, since a single toplevel
	  lambda can be compiled into multiple definitions because of lifted
	  lambdas.
	* src/precomp.scm (handle-define-macro): Changed not to use
	  compile-toplevel-lambda.

	* lib/gauche/listener.scm (listener-read-handler): Fixed a bug
	  that referenced undefined variable.
	* lib/gauche/cgen/stub.scm (process-body-spec): ditto.
	* ext/dbm/gdbm.scm (dbm-open), ext/dbm/ndbm.scm (dbm-open),
	  ext/dbm/odbm.scm (dbm-open): ditto.

	* src/extlib.stub (method-code), lib/gauche/procedure.scm (disasm):
	  Support disassembling generic functions and methods.

2011-02-28  Shiro Kawai  <shiro@acm.org>

	* Repository moved to git.

	* src/system.c (time_print): Fixed display when time-second is
	  negative.

2011-02-27  Shiro Kawai  <shiro@acm.org>

	* src/string.c (Scm_StringCmp): It is supposed to return either
	  -1, 0 or 1 if we want to use the value for generic compare,
	  but it could return values as if only its sign matters.

	* src/gauche/number.h (Scm_VMExactToInexact): Fixed a bug introduced
	  on 2010-06-19 that breaks the binary compatibility from 0.9.

2011-02-25  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/package.scm (get-all-version-paths): Fixed a bug that
	  caused an error if *load-path* contains a nonexistent path.

2011-02-24  Shiro Kawai  <shiro@acm.org>

	* ext/threads/threads.c (Scm_ThreadStop): Fixed a bug that prevented
	  timeout from working.

2011-02-23  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/test.scm (test-one-of, test-check): Added 'one-of' type
	  test result match.  Also add optional arg to test-check so that one
	  can customize fallback comparison procedure.
	* test/process.scm: Use test-one-of in checking exit status of "cat",
	  for it differs on Solaris.  Also make sure we execute the same
	  commands of ls, cat and grep to compare the results, by finding
	  absolute paths for them.

2011-02-22  Shiro Kawai  <shiro@acm.org>

	* configure.ac: Added special handling of CFLAGS on Solaris.  See
	  http://practical-scheme.net/chaton/gauche/a/2011/02/22#entry-4d6439f9-a10fb

2011-02-18  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/interactive/info.scm, lib/text/info.scm: Support
	  bzip2-ed info files.

2011-02-10  Shiro Kawai  <shiro@acm.org>

	* lib/util/combinations.scm (combinations): Substituted for an
	  optimized version written by Teranishi-san
	  ( http://practical-scheme.net/wiliki/wiliki.cgi/teranishi ).

	* rfc/http.scm (with-connection, reset-http-connection): Added
	  tentative support of persistent connection.  Currently it doesn't
	  handle the case when the server abandons the connection---we
	  should detect it and retry.   Besides, the connection should be
	  reset if an error occurs during handling the communication.
	  Use with care, and do not assume this is the final behavior.
	  (receive-body): Changed the handling of the case when response size
	  is unknown.  Now we pass the receive handler #f in that case.  The
	  receive handler should read as much data as it want and need to call
	  the retriever thunk again.  The predefined *-receivers are adjusted
	  accordingly.

2011-02-05  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-42.scm (%replace-keywords): Made it hygiene.  The previous
	  versions failed when the inserted srfi-42-* symbols were not imported.

2011-02-02  Shiro Kawai  <shiro@acm.org>

	* src/number.c (algorithmR): Correct error estimation at the
	  normalized/denormalized boundary.  This avoids the infinite loop
	  while reading 2.2250738585072012e-308.

2011-01-17  Shiro Kawai  <shiro@acm.org>

	* lib/binary/ftype.scm, ext/binary/io.scm, ext/binary/test.scm:
	  Splitted foreign type stuff into separate module.  API naming is
	  still undecided.

2011-01-12  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/parameter.scm (%parameterize): Fixed another bug
	  that appear when the outer binding of a parameter object (not the
	  value of the parameter object) is altered during execution of
	  the body.

	* lib/gauche/portutil.scm (port->string, port->string-list): Fixes
	  a bug that these procs return prematurely if the input contains
	  an illegal octed sequence for the internal encoding.  Now they
	  return incomplete string(s).

	* src/stdlib.stub (numcmp): Fixed a bug that handles more than four
	  arguments incorrectly.

2011-01-09  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_NormalizePathname): Support '~' expansion on
	  Windows native platform.
	* libsrc/file/util.scm (home-directory): Use the above feature to
	  obtain the home directory.

2011-01-08  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/json.scm (construct-json): Allow optional output port,
	  for the consistency.

	* lib/control/thread-pool.scm: (<thread-pool>): Added shut-down slot.
	  (<thread-pool-shut-down>): A new condition raised by add-job!.
	  (thread-pool-results, thread-pool-shut-down?): External API.
	  (add-job!): Raises <thread-pool-shut-down> if the pool is shut down.
	  (termiante-all): Added cancel-queued-jobs keyword argument.
	  marks executing jobs to be killed when terminating threads forcibly.

2011-01-07  Shiro Kawai  <shiro@acm.org>

	* lib/control/thread-pool.scm (add-job!): Added timeout optional
	  argument, and made the default timeout behavior from returning
	  immediately to wait indefinitely.
	  (wait-all): Added timeout optional argument before check-interval
	  optional argument.
	  THESE ARE INCOMPATIBLE CHANGES.

2011-01-06  Shiro Kawai  <shiro@acm.org>

	* lib/binary/pack.scm (make-number-pack-dispatcher): Fixed a bug
	  that used peek-char to see if input reached at end.  As of 0.9.1,
	  the return value of peek-char is unspecified if the next input is
	  an invalid char, and the current impelemntation happened to
	  return #<eof> in such case.

	* libsrc/gauche/parameter.scm: Fixed a bug that the filter procedure
	  was called unintentionally when the old value was restored upon
	  exitting parameterize.
	  Also fixed another bug that appear when the parameterize body is
	  reentered.  See the added test in ext/gauche/test-parameter.scm.

2011-01-02  Shiro Kawai  <shiro@acm.org>

	* src/gauche/load.h, src/gauche/vm.h, src/load.c, src/vm.c:
	  Moved load-time dynamic environment stuff (load_history, load_next,
	  load_port out of ScmVM structure, and manage them by the parameter
	  slots.  It is inconvenient to have these thread-specific dynamic
	  enviornment within ScmVM, since we can't change them freely because
	  of the binary compatibility.  (We keep dummy slots in place of
	  these slots of ScmVM during 0.9.x series for binary compatibility,
	  though.)
	  New APIs in load.h: Scm_CurrentLoadHistory(), Scm_CurrentLoadNext(),
	  Scm_CurrentLoadPort(), to access these dynamic values.
	  Also start adding SCM_LOAD_MAIN_SCRIPT flag support (not functional
	  yet.)
	* src/stdlib.stub (load), src/extlib.stub (load-from-port,
	  current-load-history, current-load-next, current-load-port):
          Changed accordingly.  A new keyword argument :main-script is
	  added to load and load-from-port to turn on SCM_LOAD_MAIN_SCRIPT
	  flag during loading.

	* src/module.c (Scm_FindBinding): Fixed a mpl search bug reported
	  by Ryo Akagi.  This is a quick fix, and may have negative
	  impact on Scm_FindBinding performance.  Need to come back later
	  to evaluate it.
	* test/module.scm: Added regression tests for the above bug.

2010-12-31  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass4): Some more preparation of lambda
	  lifting.  The feature is not completed yet, so pass4 is basicaly
	  no-op for the time being.

2010-12-24  Shiro Kawai  <shiro@acm.org>

	* ext/binary/io.scm, ext/binary/binarylib.scm: Experimentally
	  adding foreign struct infrastructure.  API is still fluid,
	  so do not count on the current state.

	* lib/gauche/record.scm (compute-get-n-set): Fixed a bug that
	  the slot index was calculated incorrectly when inheritance was
	  used.  It didn't affect if you only uses record accessors, but
	  it became visible when you tried to access the record with
	  slot-ref and slot-set!.   See the added tests in
	  ext/gauche/test-record.scm.

2010-12-23  Shiro Kawai  <shiro@acm.org>

	* ext/uvector/uvlib.stub.tmpl (uvector-copy!): Added generic copy
	  procedure.

	* configure.ac, src/gauche/config.h.in (HAVE_LONG_LONG): Added check
	  for long long.

2010-12-22  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (Scm_NewVM): Fixed not to copy vm->cstack from proto
	  vm; they may contain a bogus stack value from a different thread.

2010-12-21  Shiro Kawai  <shiro@acm.org>

	* ext/util/queue.scm (list->queue): Fixed a bug that prevented
	  list->queue from working for any arguments.  :rest arguments
	  shouldn't have default value, since its default value is ()
	  by definition.  (But it should be reported as syntax error.)

2010-12-19  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm: Renamed pass4 -> pass5, and created pass4 for
	  free variable scanning for lambda lifting.  free-lvars procedure
	  is removed.  (The transition isn't completed yet.)
	* src/vminsn.scm (LOCAL-ENV-CLOSURES): Allow literal closure
	  to appear in the operand.

2010-12-16  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass3/optimize-call): Fixed an optimizer bug
	  that caused reset-lvars to be called on the same set of lvars
	  more than once, screwing up lvar counts.  See the added test
	  in test/primsyn.scm.

2010-12-15  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm: Allow toplevel closure to be a
	  compile-time literal.

	* src/vm.c (Scm_VMEval): Fixed a bug that made "eval"-ed expression
	  to be executed under the caller's local environment, instead of
	  toplevel environment.  Compilation was done in toplevel env, so
	  it didn't affect meaning of the program; however, closures created
	  at runtime got unnecessary environment.

	* src/compile.scm: Renamed Pass 3 to Pass 4, and Pass 2p to Pass 3,
	  since Pass 2p was actually a separate pass.

2010-12-14  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h (ScmBox), src/vminsn.scm (BOX), src/box.c: Added 'box'
	  object for mutable local variable optimization.
	* src/compile.scm, src/vminsn.scm: Changed pass3 to use boxes for
	  mutable local variables.

	* lib/gauche/regexp.scm (rxmatch-case): Allow (else => proc) form,
	  just like 'case'.

2010-12-12  Shiro Kawai  <shiro@acm.org>

	* release 0.9.1 (repackaging): The gauche-config bug will be
	  huge annoyance, so we repackage 0.9.1.

	* src/genconfig.in: The directory structure change wasn't reflected
	  in gauche-config --pkg{inc|lib}dir.

	* DIST (doc): Needs some tweaking.  Maybe texi2html has changed.
	* doc/ja-init.pl: Turned off USE_UNICODE.  Somehow the original
	  code started produce incorrect encoding in the titles only
	  I don't know if this is a correct fix, but it seems working.

2010-12-11  Shiro Kawai  <shiro@acm.org>

	* release 0.9.1

2010-12-10  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_SysExec): Honor the directory argument on
	  Windows-native code path as well.

	* src/scmlib.scm: Modify *load-path* to include pre-0.9.1
	  directory structure for the backward compatibility.

	* src/makeverslink.in: Create a symlinc from libgauche.so to
	  libgauche-0.9.so for the backward compatibility; extensions
	  compiled for 0.9 refers to libgauche.so, and they need to
	  be working after installation of 0.9.1.

	* configure.ac, */Makefile.in, src/genconfig.in:
	  Changed library installation directory from ${datadir}/gauche
	  to ${datadir}/gauche-${ABI_VERSION}.   This is also for the
	  consistency with architecture-dependent libraries.

	* test/scripts.scm: Kludge to make gauche-package work during
	  tests without installed Gauche.

2010-12-09  Shiro Kawai  <shiro@acm.org>

	* rfc/json.scm: Renamed API procedures for the consistency:
	  ->json to construct-json (cf. rfc.cookie), the base
	  procedures now take a port, and *-string version takes
	  string.

2010-12-08  Shiro Kawai  <shiro@acm.org>

	* src/vmcall.c: Detect the attempt to invoke a method directly
	  without using a generic function, and make it an error.

2010-12-07  Shiro Kawai  <shiro@acm.org>

	* lib/Makefile.in: Install rfc.json.

	* ext/peg/*, ext/Makefile.in, configure.ac: Enabled parser.peg.
	  It is only to expose rfc.json officially.  The API of parser.peg
	  is still unofficial, and it is very likely to be changed before
	  the final version.  Do not directly use it.

2010-12-04  Shiro Kawai  <shiro@acm.org>

	* test/scripts.scm, test/TEST, test/TEST2: More tests for utility
	  scripts.  It uses extension modules, so moved to TEST2.

	* ext/template.configure.ac, ext/template.Makefile.in,
	  examples/mqueue-cpp/{Makefile.in,configure.ac},
	  examples/spigot/{Makefile.in,configure.ac}: Take care of the
	  case when Gauche is installed under pathnames with spaces.

2010-12-03  Shiro Kawai  <shiro@acm.org>

	* configure.ac, src/genconfig.in: Reverted -I and -L *not* to quote
	  the pathnames.  Since quote processing is done before parameter
	  substitution, we cannot include quoted pathnames for the output
	  to be used in `command` and $parameter substitutions.  In fact,
	  there's no way to have pathnames with whitespaces in it to be
	  used with `gauche-config -I` magic.   Instead, --incdirs and
	  --archdirs options are added that returns (semi)colon-separated
          list of directories to be used for -I and -L option.
	  `gauche-config -I` and `gauche-config -L` are kept for backward
	  compatibility.
	* lib/gauche/package/compile.scm: Changed to use --incdirs and
	  --archdirs instead of -I and -L, so that it can handle pathnames
	  with spaces correctly.

2010-12-01  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/collection.scm (call-with-builder): Fixed <tree-map>
	  builder that barfed about :size keyword argument.

2010-11-29  Shiro Kawai  <shiro@acm.org>

	* src/read.c (read_char): Fixed a bug that recognized character
	  names only when prefix matches, e.g. #\spa.  It wasn't a design
	  to allow arbitrarily abbreviated names.

2010-11-26  Shiro Kawai  <shiro@acm.org>

	* src/main.c: We don't need event_loop here; it is more natural for
	  Windows script to code event loop within it.

2010-11-25  Shiro Kawai  <shiro@acm.org>

	* examples/windows/*: Start adding some crude examples for
	  windows-specific scripting.

2010-11-24  Shiro Kawai  <shiro@acm.org>

	* ext/windows/*, ext/configure.in, configure.ac: Added os.windows
	  module to provide Windows specific procedures.  Windows Console
	  functions previously defined in gauche.termios are also moved here.
	* ext/termios/termiolib.stub, ext/termios/termios.scm: Moved
	  Windows Conosle functions to ext/windows/console.stub.

2010-11-23  Shiro Kawai  <shiro@acm.org>

	* configure.ac, src/Makefile.in: Renamed windows no-console binary
	  to more descriptive gosh-noconsole.exe.  This is something
	  users do not type manually, so long name is ok.

	* src/number.c (Scm_IsInf): Added extra volatile to suppress gcc
	  to be too clever; gcc-4.5.0 on MinGW seems to optimize away
	  the inifinity check without this.  Won't affect to platforms
	  that provides isinf().

	* src/port.c (Scm__SetupPortsForWindows): Added a hack for Windows
	  no-console application.  If Scheme program attempts to write to
	  stdout or stderr, a new console is allocated and the output will
	  be redirected to it.  API should be reconsidered to abstract away
	  platform-dependence.
	* src/main.c (main): Refactored away some platform-specific stuff
	  from main().

	* src/gauche/win-compat.h: Explicitly support Windows 2000 or later
	  by defining WINVER before including windows.h.

	* src/extlib.stub (standard-*-port), src/port.c (Scm_SetStd*):
	  Allow standard-input-port etc to be altered by the optional
	  argument.

2010-11-22  Shiro Kawai  <shiro@acm.org>

	* src/genconfig.in: Quote pathnames in -I and -L option.  They may
	  have spaces in them.  Note: For other options that directly returns
	  pathnames, it's up to the caller to properly quote them, since
	  the tool doesn't know who is calling it.

	* winnt/nsis/setup.nsi.in: Adds $INSTDIR\bin to the PATH on
	  installation.

	* src/main.c (init_console): Adapted to windows non-console mode.
	* src/winmain.c: A kludge to compile non-console binary for windows.
	  On windows, we create gosh.exe and gish.exe, where the former
	  is a console application and the latter is a non-console
	  application.
	* configure.ac, src/Makefile.in: Changed accordingly.
	* winnt/nsis/setup.nsi.in: Install gish.exe as well, and create
	  an association from .scm suffix to gish.exe---so that Scheme
	  script starts with non-console mode by double-clicking.
	* winnt/nsis/Makefile, winnt/README.txt, DIST: Adapted for
	  MinGW+MSYS build.  We no longer need cygwin.  Also allow
	  Gauche-gl to be included in the installer.

2010-11-21  Shiro Kawai  <shiro@acm.org>

	* src/paths.c (Scm_GetRuntimeDirectory), src/paths.h
	  src/core.c (Scm__RuntimeDirectory), src/gauche.h,
	  src/extlib.stub (%gauche-runtime-directory): A quick hack to
	  expose runtime directory on limited platforms.  Needed to fix
	  gauche.config on windows.  Not for general use.
	* src/genconfig.in (gauche-config): The gauche-config procedure
	  in gauche.config to replace '@' prefix included in the return
	  value, on Windows.  The return value now matches what you get
	  with the command-line version.

	* lib/gauche/package/util.scm (run): Fixed so that the build
	  commands can be run on Windows (MinGW+MSYS).  Now gauche-package
	  works on it.

2010-11-20  Shiro Kawai  <shiro@acm.org>

	* libsrc/file/util.scm (console-device): Added.

	* libsrc/gauche/parameter.scm (setter): Added generalized setter
	  for parameters; suggested by KOGURO, Naoki.

	* lib/gauche/process.scm (%setup-iomap): Use sys-tmpdir to decide
	  the location of temporary file when needed.
	* libsrc/file/util.scm (temporary-directory): Also uses sys-tmpdir
	  as the default value.

	* src/system.c (Scm_TmpDir), src/syslib.stub (sys-tmpdir): Added
	  for the consistent treatment of temporary directories across
	  platforms.

	* src/system.c (Scm_Mkstemp): Fixed PRNG for tmp file name; the lower
	  bits has low entropy.

	* lib/rfc/http.scm (http-secure-connection-available?): Exported for
	  general use.
	* doc/motutil.texi (rfc.http): Officially document :secure option.

	* ltmain.m4, gc/acinclude.m4, gc/aclocal.m4, gc/libtool.m4: Updated.
	  Note: now it requires autoconf-2.65 or later.

2010-11-19  Shiro Kawai  <shiro@acm.org>

	* depcomp, compile, config.guess, config.sub, mkinstalldirs,
	  missing, install-sh, aclocal.m4: Updated to catch up to the
	  recent autotools.

	* src/compile.scm (pass2/check-constant-asm): Added constant folding
	  for $asm nodes with ASSQ, ASSV, VEC-REF, VEC-LEN and NEGATE insns.
	  If these weren't inlined to VM instructions, constant expression
	  using these would be precomputed because corresponding SUBRs are
	  constant function.  However, inlining to VM instructions is done
	  at pass1, where constant folding with SUBRs are done in pass2, so
	  the compiler failed to fold constant expressions using these
	  functions.  Eventually we want some means to integrate implementation
	  of SUBRs and optimization of corresponding $asm nodes.

2010-11-12  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm: Changed receiver and sender interface to make
	  them simpler and composable.  For receiver we use partial
	  continuation to make it work like coroutine.  The predefined
	  receivers and senders are updated.

	* lib/control/thread-pool.scm (terminate-all!): Make force-timeout
	  keyword arg.  We might add more keyword args to tweak behavior
	  of termination.

2010-11-11  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/process.scm (run-process): Added support of '<<<',
	  '<&' and '>&' in :redirects argument.  Allow uniform vector
	  for '<<' redirection.

2010-10-15  Shiro Kawai  <shiro@acm.org>

	* ext/sxml/src/sxpath.scm (sxpath): Reflected sxpath bug fix on
	  namespace alist from upstream.  Fix from teppey.
	* ext/sxml/test.scm: A test added for the above fix.

2010-10-06  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/ftp.scm (<ftp-error>): Documented but not exported.
	  Fix from Masatake YAMATO.

	* ext/sxml/src/txpath.scm (sxml:parse-function-call): Fix txpath's
	  'contains' operator.  The upstream fix http://ssax.cvs.sourceforge.net/viewvc/ssax/sxml-tools/txpath.scm?r1=1.6&r2=1.7
	  Fix from teppey.

2010-09-18  Shiro Kawai  <shiro@acm.org>

	* ext/srfi/srfi-19.scm (tm:leap-second-table): Updated to reflect
	  new leap seconds.

2010-09-12  Shiro Kawai  <shiro@acm.org>

	* lib/dbm/dump, lib/dbm/restore: Added utility scripts.
	* lib/dbm.scm (dbm-type->class): Added a utility procedure to load
	  and use specific dbm at run-time.

2010-09-04  Shiro Kawai  <shiro@acm.org>

	* src/signal.c (Scm_SetSignalHandler): Represent the status of
	  signal handler that "Gauche does not handle the signal" by
	  #<undef>.  It used to be #f, but it is also used to represent
	  SIG_DFL and caused an unwanted alteration of signal handlers
	  by with-signal-handler.   The original fix is provided by
	  enami.

	* lib/rfc/http.scm: More rubust support of external stunnel handling
	  for https connection.
	* lib/gauche/process.scm (run-process): Generalized I/O redirection
	  handling to allow more flexible redirection, closer to shell.

2010-08-23  Shiro Kawai  <shiro@acm.org>

	* libsrc/file/util.scm (home-directory): Added support for Windows.
	  (null-device): Added.

2010-08-04  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/mime.scm (<mime-part>): Fixed typo (Patch from
	  Hayashi Masahiro).
	* lib/rfc/http.scm (http-compose-form-data): Respect content-transfer-
	  encoding keyword argument.  (Patch from Hayashi Masahiro).

2010-08-01  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/dictionary.scm (call-with-iterator): Implemented
	  minimum collection protocol for bimap.  Need to think more
	  about bulders and other shortcuts, but this one fills the
	  needs for the time being.
	* test/dict.scm: Added bimap collection test.

2010-07-01  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/precomp.scm (handle-define, handle-define-macro):
	  Escape strings in C-comment properly.

2010-06-30  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/numerical.scm (%exact-integer-sqrt): Fixed a bug
	  when the given arg is too large to coerce to double.

2010-06-19  Shiro Kawai  <shiro@acm.org>

	* src/number.c (Scm_Numerator, Scm_Denominator): Bug fix for
	  inexact arguments.
	  (Scm_Exact, Scm_Inexact, Scm_VMInexact): We're naming
	  Scm_InexactToExact etc.; they are more concise without loss
	  of meaning.  To keep binary compatibility, shorter names are
	  macros during 0.9.x.  In 1.0 we'll switch macros and instances.
	* src/write.c, src/number.c, src/vminsn.scm, src/stdlib.stub,
	  src/extlib.stub: Modified according to the above change.

	* lib/gauche/numerical.scm (div, mod, div0, mod0, div-and-mod)
	  (div0-and-mod0): Added R6RS integer divisions.

2010-06-17  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/numerical.scm (inexact, exact, real-valued?)
	  (rational-valued?, integer-valued?): Added for R6RS compatibiltiy.

	* src/stdlib.stub (rational?): Exclude +inf.0, -inf.0 and +nan.0 from
	  the set of rational numbers.  These are the only numbers that are
	  real but not rational.

	* lib/gauche/numerical.scm (exact-integer-sqrt): Added.
	  (sqrt): Revised so that it returns exact number if the argument
	  is a square of exact real number.
	* src/autoloads.scm (exact-integer-sqrt): Added.

2010-06-16  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass2/check-constant-asm): Fold numeric operation
	  $ASMs on constant arguments.

2010-06-08  Shiro Kawai  <shiro@acm.org>

	* src/write.c (write_ss_rec): Fixed an infinite recursion problem
	  when attempting to print (cdr #1='#1#).

2010-06-07  Shiro Kawai  <shiro@acm.org>

	* ext/template.DIST: Exclude .git from being included to distribution
	  tarball.

2010-05-29  Shiro Kawai  <shiro@acm.org>

	* libsrc/util/match.scm (gen): For certain patterns, this function
	  can be called exponential times, taking very long for expansion.
	  This fixes exponential expansion time by avoiding calling gen
	  on the same patterns.

2010-05-28  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-request): Committing tentative SENDER
	  protocol.  NB: I'm going to try a different protocol,
	  so take this version with a grain of salt.

	* ext/uvector/uvlib.stub.tmpl (uvector-size): Allow start and end
	  optional arguments, for the consistency with write-block.
	  Also documented this function.

2010-05-26  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-request): Revised RECEIVER protocol;
	  now it takes the total response size in the third arg.  It allows
	  the retriever to track the progress.

2010-05-23  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-request): Changed main API of rfc.http.
	  High-level APIs are consolidated to http-request, instead of
	  having separate calls for each request method, since method
	  is often parameterized.  SINK and FLUSHER arguments to handle
	  response is deprecated and superseded by RECEIVER argument
	  for flexibility.

2010-05-19  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/parseopt.scm (build-option-parser): Let let-args raise
	  an error of condition type <parseopt-error> for invalid arguments,
	  so that the program can capture this particular type of runtime
	  error.

2010-05-13  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (define-syntax, let-syntax, letrec-syntax)
	  (syntax-rules, pass1/eval-macro-rhs): Generalize syntactic
	  binding as evaluating rhs in compile-time environment.  The
	  syntactic keyword is bound to the resulting macro transformer.
	  This is the first step to open up variations of macro
	  transfomers other than syntax-rules.   Now syntax-rules are
	  implemented as first-class compile-time syntax, and eventually
	  will become just one of ordinary macro transformers.
	  (compile): Enable to take CENV as the second argument.
	  (pass1): Adjusted to expect resolution of local syntactic
	  bindings be #<syntax>.  This happens when let-syntax etc.
	  are used to add aliases, e.g. (let-syntax ((xif if)) (xif ...)).
	* src/macro.c (Scm_CompileSyntaxRules): allow NAME to be #f
	  for it may be so when syntax-rules is used stand-alone.
	* src/intlib.stub (syntax?): Added.  Note: The name syntax? may
	  be renamed, for it is confusing with syntax-case's use of "syntax".

	* src/port.c (Scm_MakePortWithFd): Set seeker if the given fd is
	  seekable.  For example, Scm_SysMkstemp calls this function on
	  an fd associated to a file, so it is natural to be seekable.
	  OTOH, sys-pipe passes pipe fd, which isn't seekable.

	* src/objlib.scm (ref, (setter ref)): Added generic slot reference
	  with fallback, and setter to list, for consistency.
	  Patch from Masatake YAMATO.

2010-05-12  Shiro Kawai  <shiro@acm.org>

	* ext/net/netaux.scm (make-server-sockets): If the system defaults
	  v6 sockets to be dual-stack (i.e. IPV6_V6ONLY is off by default),
	  the current strategy fails since v6 socket tries to bind both
	  v4 and v6 addresses.  The default is system-dependent, so we
	  adopt a heuristic: First we bind v6 addresses, and then we try
	  v4 ones; if v4 one fails with EADDRINUSE, we just ignore it.

2010-05-11  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (POP_CONT): fixed a bug that refers wrong pointer.

	* src/port.c (register_buffered_port): Fixed a race condition
	  accessing the active port vector.  Pointed by enami.

	* src/vm.c (user_eval_inner, Scm_VMCallPC):
	  src/intlib.stub (%call/pc):
	  lib/gauche/partcont.scm: Experimentally added partial (delimited)
	  continuation support.  A partial continuation is marked by
	  ep->cstack == NULL.  Its 'root' is cut by %call/pc.  It is
	  executed on the cstack where it is invoked.  When execution of
	  a partial continuation ends, popping continuation frame yields
	  vm->cont == NULL, which caused run_loop() to return to
	  user_eval_inner, which in turn hands the control over the latest
	  continuation delimited by reset().   Note that reset() operator
	  is simply Scm_VMApplyRec0---user_eval_inner implicitly delimits
	  the continuation.   No partial continuation frames should include
	  c stack frames in it.

2010-05-10  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (user_eval_inner, throw_continuation): Allow execution
	  of "ghost continuations", the continuations whose dynamic extent
	  of C stack is effectively expired.   For example, if a
	  continuation is captured within the callback function from C,
	  and the callback has already returned to C, then the continuation
	  becomes a ghost.  Ghost continuation cannot return to C at its
	  bottom, for it is not allowed in C to return from already expired
	  stack frame.  We used to raise an error when ghost continuation
	  is invoked.  However, the Scheme portion of a ghost continuation
	  is still effective and executable.  This change allows a ghost
	  continuation to be executed on the current C stack.  If the
	  continuation tries to return to C, an error is signalled.

2010-05-04  Shiro Kawai  <shiro@acm.org>

	* src/char.c (Scm_CharSetComplement): Fixed to handle complement
	  correctly for the cases that the range touches the lower bound,
	  or the range has one-character gap.

2010-05-03  Shiro Kawai  <shiro@acm.org>

	* ext/util/queue.scm (any-in-queue, every-in-queue): added.

	* lib/gauche/common-macros.scm (unwind-protect): Allow multiple
	  handlers, as in CL.

	* src/module.h (origin, prefix): Added these slots to support
	  wrapper module with prefix.  Modules are not statically allocated,
	  so this shouldn't affect ABI.
	* src/module.c (Scm__MakeWrapperModule): An implicit module inserted
	  to support prefixed symbols.  This obsoletes the change on
	  2009-09-23, using module and prefix pair in the import list.
	  (Scm_FindBinding): Consider prefix from the wrapper module
	  Dropped support of (#<module> . prefix) in the import list.
	  (Scm__InitModulePost): Made module information visible as slots.
	  We should call Scm_InitStatiClassWithMeta in module.c, but
	  that needs to be done after the class system is initialized.
	  Scm__InitModule needs to be called before Scm__InitClass,
	  so we need another initialize function, which is called
	  after Scm__InitClass.
	* src/core.c (Scm_Init), src/class.c (Scm__InitClass): Changed
	  accordingly.
	* src/compile.scm (process-import): Support :rename.  Rewrote
	  :only and :except support to use wrapper modules.

2010-05-02  Shiro Kawai  <shiro@acm.org>

	* lib/control/job.scm, lib/control/thread-pool.scm: Added.
	* test/TESTS2, Makefile.in, src/Makefile.in: Set up some tests
	  to be run after ext/* tests.
	* test/control.scm: Added.

	* ext/util/queue.scm (mtqueue-room): Added.

2010-05-01  Shiro Kawai  <shiro@acm.org>

	* ext/net/test.scm: Fix test failure on ipv6 enabled host.

	* src/gauche-init.scm (use): Allow options that can be passed
	  to import.

	* doc/modgauche.tex (gauche.mop.propagate): Made it officially
	  documented.
	* lib/gauche/mop/propagate.scm: Enable initialization of propagated
	  slot via init-keyword.

2010-04-30  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/define, pass1/lambda): Defines R5RS version
	  and Gauche version of define and lambda separately; Gauche version
	  supports extended formals, R5RS version not.  For those who want
	  vanilla versions for whatever reason, say (extend scheme).

2010-04-25  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/define-inline): Revamp inlining mechanism
	  of lambdas with closed environment.  The new scheme doesn't
	  require separate form such as %inlinable-lambda.  I check in the
	  current state, which works on basic cases but needs more refinement
	  for the practical cases.  This change shouldn't affect the existing
	  valid code (that is, the path to inline lambdas with no closed
	  enviornment isn't changed).
	  Also reverting the change on 2010-03-28 about the packed information
	  of inlinable procedure (the info in $lambda-flag).  With this new
	  scheme we can just use packed IForm; no need to keep extra info.
	* src/intlib.stub (%insert-binding): Allow optional flags.

2010-04-21  Shiro Kawai  <shiro@acm.org>

	* ext/bcrypt: Change module name from gauche.bcrypt to crypt.bcrypt,
	  for it represents the module better.

2010-04-20  Shiro Kawai  <shiro@acm.org>

	* src/Makefile.in: Re-adding $(LIBS) to link gauche-config, for
	  it is needed on mingw.

2010-04-19  Shiro Kawai  <shiro@acm.org>

	* configure.ac, src/gauche/config.h.in: Added GNU/kfreebsd and
	  GNU/Hurd support.  Patch from NIIBE Yutaka.

	* lib/gauche/treeutil.scm (tree-map-map, tree-map-for-each): Added.
	* src/autoloads.scm, doc/corelib.texi: Modified accordingly.

	* src/Makefile.in: Fix linking gauche-config; patch from Debian build,
	  by YAEGASHI Takeshi.

	* configure.ac: Support for arm-unknown-linux-gnueabi and
	  arm-unknown-linux-gnulp architecture.  Patch from NIIBE Yutaka.

	* src/number.c (Scm_NumLE, Scm_NumLT, Scm_NumGE, Scm_NumGT):
	  Added these APIs that handles NaN properly.  Scm_NumCmp alone
	  is not suitable to handle comparison involving NaNs.
	* src/number.h: ditto.
	* src/vminsn.scm ($w/numcmp): Use above APIs to handle NaNs.
	* src/stdlib.stub (=, <, <=, >, >=): Use above APIs to handle NaNs.
	* test/number.scm: Added tests of numeric comparison involving NaNs.

	* src/gauche/float.h (SCM_HALF_FLOAT_IS_NAN, SCM_HALF_FLOAT_CMP):
	  Recognizes and handles NaN bitpattern of ScmHalfFloat.
	* src/vector.c (compare_f16vector): ditto.
	* ext/uvector/test.scm: Added tests for uvector comparison.

2010-04-18  Shiro Kawai  <shiro@acm.org>

	* src/gauche/vector.h (struct ScmVectorRec): The 'size' field
	  must have the same length as ScmObj, otherwise vector literals
	  allocated in ScmObj[] by precompiler doesn't work on big-endian
	  machines.  Patch from Stephen Lewis.

2010-04-13  Shiro Kawai  <shiro@acm.org>

	* lib/srfi-98.scm, lib/Makefile.in: Added srfi-98 support.
	* src/core.c: Made cond-expand aware of srfi-98, srfi-99.
	* doc/concepts.texi, doc/corelib.texi, doc/modsrfi.texi: srfi-98.

2010-04-11  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (dynamic-wind): Fixed a bug that leaves lvar's
	  refcounts wrong after inline transformation.

2010-04-08  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (save_env): Revised the previous fix to make it
	  clearer, based on the analysis of NIIBE Yutaka.

2010-04-07  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (save_env): Avoid copying ScmEnvFrame header as an
	  array of ScmObj*.  Doing so apparently violates the strict
	  aliasing rule and results unintended compilation on some
	  architectures (gcc on ia64 confirmed).  Patch contribution
	  from NIIBE Yutaka.

2010-03-30  Shiro Kawai  <shiro@acm.org>

	* doc/*.texi: Moved 'coding: utf-8' to the end of the file,
	  since texinfo-multiple-files-update seems to blindly assume
	  the first line of a file is a node command.

2010-03-28  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/inlinable-lambda, pass1/expand-inliner etc):
	  Changed inlining info in $LAMBDA node to allow closed lvars
	  plus future extensions, from a simple vector of packed IForm.
	  Changed places that uses info, though currently they only deal
	  with the case that no lvars are closed.
	  This affects the dumped format of precompilation; the old format
	  is still recognized and supported, but will be dropped in the
	  next major release.

2010-03-25  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/record.scm: Added support of vector-backed pseudo record.
	  The procedure returned by rtd-accessor has a setter if the field
	  is mutable.

2010-03-22  Shiro Kawai  <shiro@acm.org>

	* libsrc/util/match.scm: Fixed a bug that caused match-let* fail
	  (required identifiers are not defined).

2010-03-09  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (iform-copy): Fixed a bug that yielded a wrong
	  optimization when flagged closure is inlined.  Thanks to
	  Michael Campbell for the detailed report.

2010-02-27  Shiro Kawai  <shiro@acm.org>

	* lib/www/cgi.scm (get-mime-parts): Fixed a bug that didn't parse
	  option values in content-disposition header are unquoted.

	* ext/threads/threads.scm, ext/threads/Makefile.in:
	  Integrated thrlib.stub into threads.scm.

2010-02-24  Shiro Kawai  <shiro@acm.org>

	* src/gauche/vm.h, src/vm.c, src/gauche/pthread.h, src/gauche/uthread.h:
	  Abstract thread handle type as ScmInternalThread.

2010-02-23  Shiro Kawai  <shiro@acm.org>

	* src/gauche/win-compat.h (struct timespec), src/system.c (nanosleep):
	  Added nanosleep emulation on Windows.
	* src/syslib.stub (sys-nanosleep): Enable on windows as well.

2010-02-23  Shiro Kawai  <shiro@acm.org>

	* most sources: Removed $Id...$ from most of the sources.  We have
	  moved away from CVS, so it is no longer relevant.  It may even
	  cause confusion, since it's not updated anymore.  (It is left
	  to the source taken from outside; in which case the line shows
	  which version we've taken from).

	* ext/util/queue.scm (with-mtq-mutex-lock): Made mutex locking
	  cancellation safe.

2010-02-22  Shiro Kawai  <shiro@acm.org>

	* src/regexp.c (rc1_lex_minmax): Changed to treat re{,M} as re{0,M}
	  in the regexp parser, which is compatible to Oniguruma.
	  This is, strictly speaking, an INCOMPATIBILE CHANGE; the previous
	  version is compatible to Perl, which makes {,M} to match the
	  string literally.  It should be written \{,M} now.

	* lib/gauche/fileutil.scm (make-glob-fs-fold): Fixed a bug in glob
	  that fails if an intermediate directory in the fully-specified
	  path is searchable but unreadable.

	* src/gauche/regexp.h, src/regexp.c: Added 'ast' field in ScmRegexp
	  to save parsed AST.
	* lib/gauche/regexp.scm (regexp-unparse): An utility to reconstruct
	  string representation of regexp from AST.
	* src/extlib.stub, src/scmlib.scm (regexp->string): Changed
	  regexp->string so that if the 'pattern' field of ScmRegexp is
	  #f (i.e. the regexp is directly created from AST), it uses
	  regexp-unparse to reconsturct the string representation.  The
	  constructed string is set to the 'pattern' field so that the
	  subsequent call of regexp->string will use it.
	* src/autoloads.scm: Mark regexp-unparse autoload.

2010-02-21  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (request-response): Exclude keyword arguments
	  for the receiver from request headers.

	* src/scmlib.scm (delete-keywords, delete-keywords!): Added.

2010-02-20  Shiro Kawai  <shiro@acm.org>

	* src/char.c (charset_print): Fixed char-set writer that violated
	  read/write invariance if the set includes '^' as the first
	  character.

2010-02-19  Shiro Kawai  <shiro@acm.org>

	* test/system.scm: Exclude sys-wait test on cygwin, since sigmask
	  doesn't seem to work reliably on cygwin 1.7.

	* INSTALL.in: switched to utf-8.

2010-02-12  Shiro Kawai  <shiro@acm.org>

	* src/system.c: Do not treat '\\' as a directory separator on
	  non-windows platforms (On GAUCHE_WINDOWS, we still treat both
	  '/' and '\\' as a separator.)

2010-02-06  Shiro Kawai  <shiro@acm.org>

	* src/objlib.scm (slot-pop!): Added for the consistency with other
	  *-push!/pop! API pairs.
	* src/treemap.c (core_bound), test/treemap.scm: Fixed a bug that
	  tree-map-pop-min! didn't update num_entries.  Patch from
	  Masatake YAMATO.

2010-02-05  Shiro Kawai  <shiro@acm.org>

	* doc/*.texi: Switched from euc-jp to utf-8.
	* doc/extract: Changed accordingly.

	* doc/gauche-install.1.in, doc/gauche-package.1.in,
	  doc/gauche-cesconv.1.in: Added these manpages based on the ones
	  provided by Jens Thiele.
	* doc/gosh.1.in, doc/gauche-config.1.in: Updated.
	* configure.ac: Changed to process the added manpages.

2010-02-02  Shiro Kawai  <shiro@acm.org>

	* ext/util/queue.scm (enqueue/wait! etc.): Implemented synchronizing
	  operations.
	* ext/threads/test.scm: Added tests of interacting between threads
	  using mtqueue.
	* doc/modutil.texi: Extended descriptions of util.queue.

2010-01-21  Shiro Kawai  <shiro@acm.org>

	* libsrc/gauche/collection.scm, lib/gauche/mop/instance-pool.scm:
	  Remove dependency to util.queue; it caused build problem.

	* ext/util/queue.scm, lib/util/queue.scm: Rewrote util.queue
	  partly using C, in order to support thread-safe queue efficiently.
	* ext/util/Makefile.in, ext/Makefile.in, test/util.scm,
	  ext/util/test.scm: Changed accordingly.

2010-01-18  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm: Experimentally added https support, using
	  stunnel as an external agent to handle SSL.  Pass :secure #t
	  to http-get etc.  Needs more test to become 'official'.
	  (Current problem: There seems to be no way to get erroneous
	  condition in stunnel side).

2010-01-17  Shiro Kawai  <shiro@acm.org>

	* src/objlib.scm, lib/gauche/procedure.scm, src/autoloads.scm,
	  lib/gauche/experimental/ref.scm (~): Integrated '~' into the
	  core (currently autoloaded from gauche/procedure.scm).  Now
	  it's officially supported.  'ref*' became an alias of '~', but
	  it's only for the backward compatibility and will fade out.

	* doc/corelib.texi (Combinators): formally account '.$' as an
	  altenative name of 'compose'.

2010-01-16  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (transparent?/rec): Treat $GREF of inlinable
	  bindings as referentially trasparent.

2010-01-15  Shiro Kawai  <shiro@acm.org>

	* src/link-dylib: Adjust install_name according to the ABI version
	  (patch from Tatsuya BIZENN).

	* src/compile.scm (pass1/define-inline, pass1/inlinable-lambda):
	  Factored out the part to save intermediate IForm to $lambda node.
	  This is to prepare for further aggressive inlining.

	* lib/gauche/record.scm: Added srfi-99/srfi-9 compatible record type.
	* src/class.c (Scm__AllocateAndInitializeInstance),
	  src/objlib.scm (%make-record,%make-recordv,%record-ref,%record-set!):
	  Auxiliary internal procedures to support record type efficiently.
	* lib/srfi-9.scm: Just extend gauche.record.

2010-01-10  Shiro Kawai  <shiro@acm.org>

	* ext/Makefile.ext.in (GAUCHE_ARCHDIR etc): Reverted not to use
	  gauche-config, for it caused problem on MinGW, on which gauche-config
	  returns a pathname relative to the executable.

2010-01-09  Shiro Kawai  <shiro@acm.org>

	* doc/coresyn.texi: officially document extended lambda formals, ^,
	  and ^c.

	* src/compile.scm (pass1/extended-lambda): If :optional spec is given
	  but not :key nor :rest, and given arguments exceeds maximum number
	  of optional arguments, signals an error.  It is consistent to
	  SUBR with :optional args, and also to Common Lisp.
	  NB: The error message needs to be improved.  Thinking to change that
	  when we adopt better compilation strategy for optiona arguments.

2010-01-08  Shiro Kawai  <shiro@acm.org>

	* src/scmlib.scm (let-keywords*): Grace period expires; raises an error
	  if unknown keyword is given (see 2007-01-21).

2010-01-07  Shiro Kawai  <shiro@acm.org>

	* src/scmlib.scm (let-keywords, let-keywords*): Allow single variable
	  without default value, for the consistency with let-optionals*.

	* lib/gauche/common-macros.scm (^ ^a ...),
	  lib/gauche/experimental/lamb.scm,
	  src/autoloads.scm:
	  Moved ^ and ^x macro from experimental to built-in.

	* src/autoloads.scm: Allow multiple symbols in :macro entry, for
	  conciseness.

2010-01-05  Shiro Kawai  <shiro@acm.org>

	* libsrc/file/util.scm (temporary-directory): Make this a parameter,
	  for sometimes it is useful to change the temporary directory.

	* src/compile.scm (pass1/open-include-file): Check the platform at
	  run-time instead of compile-time, since compile.scm is likely to be
	  pre-compiled on a machine different from the one actually runs it.

	* src/genconfig.in: Use unique name for temporary file to avoid
	  race condition when make is run in parallel.

2010-01-04  Shiro Kawai  <shiro@acm.org>

	* configure.ac, */Makefile.in, src/genconfig.in, src/makeverslink.in,
	  src/gauche/config.h.in: Adopted the new installation directory
	  strcture to keep binary compatibility for the same ABI version.
	  Bumped to 0.9.1_pre1.
	* src/scmlib.scm: Added a temporary workaround to use extension
	  modules compiled for 0.9 to work with 0.9.x series.

	* Gauche.spec: Fix rpm build problem caused by missing micro version.
	  This is peculiar to the new minor version up; remember to revert it
	  upon 0.9.1 release.

2010-01-03  Shiro Kawai  <shiro@acm.org>

	* ext/bcrypt: Added crypt_blowfish binding.  We chose to include it
	  in the main distribution instead of providing it as an external
	  package, in order to encourage users to use a modern password
	  hashing scheme rather than relying on crypt(3) or rolling their own.

2009-12-30  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm: (id->bound-gloc): Refactored.
	  (cenv): Added 'source-path' slot to support include.
	  (pass1/body): Factored out the recursive parts as pass1/body-rec.
	  (syntax/include): Added 'include'.

2009-12-29  Shiro Kawai  <shiro@acm.org>

	* src/scmlib.scm (current-load-path): Added.  It is going to be more
	  reliable and convenient to obtain the path than via current-load-port.

	* src/compile.scm (dynamic-wind): Added builtin inliner for
	  dynamic-wind.  This expansion uses PUSH-HANDLERS and POP-HANDLERS
	  instructions.

2009-12-28  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass2p/precompute-constant): Support the case
	  when the precomputation procedure returns multiple values
	  (for now, we give up optimization if the proc returns more than
	  one value.  will be fixed in future.)

2009-12-22  Shiro Kawai  <shiro@acm.org>

	* src/vminsn.scm (PUSH-HANDLERS): Fixed: the order of arguments is
	  reversed; "before" comes first (hence in the stack) and "after"
	  follows (hence in VAL0).

2009-12-21  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass1/call): Expand immediate lambda here, too,
	  for such a form can appear as a result of macro expansion.
	  Elimiating lambda here helps later pass to optimize clsures.

2009-12-16  Shiro Kawai  <shiro@acm.org>

	* src/vmcall.c: Pass the actual # of args in the stack via VAL0
	  to Scheme-defined procedures/methods.  This info will be used
	  for efficient optional argument handling.

	* src/intlib.stub (gloc-ref, gloc-bound?): Fix a bug that gloc-ref
	  potentially leaks out #<unbound> to the Scheme world.  Now gloc-ref
	  raises an error if it doesn't have a binding.  You can give a
	  fallback value to avoid an error.  Also provides gloc-bound? to
	  check if the gloc has a value.
	* src/compile.scm: Changed accordingly to avoid dereferincing unbound
	  glocs.

	* src/compile.scm (pass2p/optimize-call): Added some heuristics
	  to deduce result of built-in predicate from what we know about
	  its argument.
	  (lvar-const-value): Factored out the common usage to get initval
	  of lvar if it is a constant binding.

2009-12-15  Shiro Kawai  <shiro@acm.org>

	* lib/text/parse.scm: Rewritten to take advantage of the new
	  compiler optimization.
	* libsrc/srfi-13.scm: Avoid creation of closure by %get-char-pred.
	* ext/sxml/sxml-ssax.scm.in, ext/sxml/trans.scm, ext/sxml/adaptor.scm:
	  Make some global bindings constant so that the compiler can perform
	  more optimization.

	* src/gauche.h (ScmProcedure): Added 'constant' bit.  See the
	  comment for the details.
	  (SCM_DEFINE_SUBRX): A new macro to specify 'constant' bit.  This
	  macro is mainly for autogenerated C code.  Other procedure
	  initializer macros are adjusted accordingly.
	* src/proc.c (proc-constant): Added accessor for 'constant' bit.
	* lib/gauche/cgen/stub.scm (define-cproc): Added a support for
	  flag :constant, that turn on the constant bit of SUBR and
	  make the SUBR inlinable.  This allows the compiler to precalculate
	  constant values using buiting procedures.
	* src/stdlib.stub, src/extlib.stub: Added :constant flags to
	  cprocs when applicable.

	* src/compile.scm (pass2p/optimize-call): Enables constant folding
	  involving procedures marked as 'constant'.
	  (pass2, pass2p/$IF, pass2p/optimize-call): If IForm structure
	  is changed significantly during pass2 post, repeat pass2 post again
	  for further optimization.
	  (pass2, compile-p2): Added dump? argument for troubleshooting.
	  (initval-list-cdr): Fixed a bug that creates invalid $LIST node.
	  (%attach-inline-er-transformer): Preserve inliner info attached
	  by define-inline, so that we can set a compiler macro on
	  procedures defined by define-inline.
	  (pp-iform): Include identifier's module info.

	* src/intlib.stub (identifier-module): Removed after all.  Speed is
	  no so critical, so we can use (slot-ref id 'module) instead.

2009-12-14  Shiro Kawai  <shiro@acm.org>

	* src/scmlib.scm (let-optionals*): Improved not to emit unnecessary
	  code to advance a pointer in the last of optional argument.

	* src/compile.scm (pp-iform): Slightly changed output format for
	  better readability.
	  (pass2/$IF, pass2p/$IF): Moved $if-$it optimization to the pass2p,
	  for it won't affect main pass2 optimization, but it introduces
	  shared node and makes later pass cumbersome.
	  (pass2/$ASM, pass2p/$ASM, pass2/check-constant-asm): Perform
	  $ASM-node constant folding in pass2 main as well.  This benefits
	  other pass2 main optimization.
	  (reset-lvars): Re-adjust lvar reference count after pass2 main,
	  for the pass may prune subtree from IForm.
	  (pass2p/$CALL): Another call optimization.  At this point we know
	  a lot about $CALL node, so we can perform some more optimization.
	  (pass2p/$SEQ): Eliminate dead code if we know it is safe to do so.

	* src/intlib.stub (identifier-module): Added to be used in
	  pass2p/inlinable-gref? in compile.scm.

2009-12-13  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (unpack-iform): Recover lvar's initvals after
	  unpacking.  Missing initvals prevented some optimizations.
	  (transparent?): Check circular/shared reference of $LABEL node.
	  (pass2p): Passing labels table to avoid recursing into circular/
	  shared $LABEL node.

	* src/main.c (-fno-post-inline-pass),
	  src/gauche/vm.h (SCM_COMPILE_NO_PASS2POST),
	  src/intlib.stub (vm-compiler-flag-no-pass2-post?),
	  src/compile.scm (pass2): Added a new compiler flag to skip post-pass2
	  optimization, mainly for troubleshooting.

	* src/intlib.stub (vm-compiler-flag-noinline-locals?): Bug fix:
	  Missing 'result' caused this function always return false.

	* src/compile.scm (transparent?): More sophisticated check to see if
	  we can safely move around or eliminate subtree of IForm.
	  (pass2/remove-unused-lvars): If an lvar became unused and its initval
	  is transparent, we eliminate the initval expr (previously we only
	  eliminate if initval is $const or $lambda).
	  (pass2p/$IF): If the test becomes a constant due to prior optimization,
	  expands then or else node directly.
	  (pass2p/$ASM): Partially evaluate some assemblers if we know enough
	  about the arguments.

2009-12-12  Shiro Kawai  <shiro@acm.org>

	* src/compile.scm (pass2/local-call-embedder): Bug fix: It could
	  generate an embed $call node without inserting $label node in its
	  child's $lambda.  Pass3 assumes there's always a $label node, thus
	  fails in such a case.  This bug has been covered by the another bug
	  fixed below:
	  (pass2/remove-unused-lvars): Bug fix: It didn't decrement lvar ref
	  count when $lref is removed from the inits of the $let.  This didn't
	  cause a malfunction but caused slightly inefficient code, and covered
	  up the aforementioned bug.
	  ($const?, $lref?, $it?): Added for conciseness.
	  (pass2p/$CALL): Do not recurse if the call is marked 'jump, since
	  its body is shared by other call nodes.

	* src/scmlib.scm (every), libsrc/srfi-1.scm: Make 'every' built-in,
	  for it is used in compile.scm now.

	* src/compile.scm (adjust-arglist): Emit ($CONST ()) for the restarg
	  instead of ($LIST).  This allows further constant elimination.
	  (pp-iform): Fix missing close paren in $LIST, $LIST* and $VECTOR
	  branch.  Also replaced ';' by ':' for Emacs-friendliness.
	  (pass2): Introduced extra pass after pass2 to do further optimizations
	  that are made available by closure optimization.
	  When closures are inlined, we have a good chance to partially evaluate
	  the original body, since some of the provided arguments can be
	  constants.

2009-12-11  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/procedure.scm (make-dispatcher): Attach a compiler macro
	  to case-lambda so that if we know # of args at the call site we
	  can skip dispatcher.

	* src/compile.scm (%attach-inline-er-transformer)
	  (%bind-inline-er-transformer),
	  src/intlib.scm (%mark-binding-inlinable!),
	  src/scmlib.scm (define-compiler-macro): Added tentative compiler-
	  macro API.  This is still a kind of stub; don't expect it to work
	  universally (esp. it is unlikely to go well with precompilation.)
	* ext/uvector/uvutil.scm: Adjusted TAGvector-ref expander to the
	  above API.

	* src/gauche/gloc.h, src/gloc.c (Scm_GlocInlinableSetter, Scm_GlocMark):
	  Laying out the base to support proper inlining behavior.
	* src/module.c (Scm_MakeBinding): Added support of inlinable bindings.
	* src/compile.scm (pass1/define-inline, pass3/$DEFINE): Ditto.
	  Define-inline will create an inlinable binding.
	* src/vminsn.scm (DEFINE): Support creating inlinable bindings.
	* lib/gauche/cgen/stub.scm (cgen-emit-init, variable-parser-common):
	  Add inlinable flag to the bindings of cprocs inlinable to vm insn.

	* src/intlib.stub (gloc-inlinable?): added.

2009-12-10  Shiro Kawai  <shiro@acm.org>

	* src/gauche/module.h, src/module.c (Scm_MakeBinding): A generic API
	  to insert global binding.  Eventually it will supersede Scm_Define.

	* src/stdlib.stub (+, *): Fixed these by removing SCM_NUMBERP checks,
	  since they should be handled in Scm_Add and Scm_Mul.  It can be
	  legal to pass non-numbers to them, because of object-+ and object-*
	  hooks.  (This bug haven't surfaced easily, since inlied version of
	  '+' and '*' handles it correctly.)

2009-12-09  Shiro Kawai  <shiro@acm.org>

	* src/intlib.stub (make-case-lambda-dispatcher): Put the dispatch
	  vector in the procedure info, so that disasm and other introspection
	  routines can dig into the body of the case-lambda.  The format
	  in which the info is stored is tentative and may be changed later.
	* lib/gauche/procedure.scm (disasm): Allow disassembling case-lambda,
	  using the info available by the above change.

2009-12-04  Shiro Kawai  <shiro@acm.org>

	* src/gauche/bytes_inline.h: Added swap_*_t for the union types
	  commonly used in the swapping operations.
	* ext/binary/binary.c: Changed to use above types.

	* ext/uvector/uvector.c.tmpl, ext/uvector/uvector.h.tmpl,
	  ext/uvector/uvectorP.h, ext/uvector/uvgen.scm,
	  ext/uvector/uvlib.stub.tmpl: Changed uvector-swap-bytes and
	  uvector-swap-bytes! to deal with ARM's mixed endian, by taking
	  optional argument.  Also changed read-block! and write-block to deal
	  with ARM mixed endian, and obey default-endian parameter if endian
	  argument is omitted.

2009-11-30  Shiro Kawai  <shiro@acm.org>

	* src/gauche/bytes_inline.h, src/binary.c: Factored out byte swapping
	  macros.

	* src/core.c (Scm_Init), src/parameter.c (Scm__InitParameter):
	  Removed InitParameter, since all we need is statically initialize
	  mutex.  This alleviates headache of ordering Scm__Init* routines
	  to satisfy dependencies.

	* ext/binary/binary.c, src/number.c, src/gauche/number.h
	  (Scm_DefaultEndian, Scm_NativeEndian, Scm_SetDefaultEndian):
	  Move the default-endian parameter from to the core, for it will
	  be used in all binary i/o consistently.  binary.c reflects the
	  change below to check ARM_LITTLE_ENDIAN at runtime.
	* ext/binary/binary.h, ext/binary/io.scm: changed accordingly.
	* src/extlib.stub (native-endian): added.

	* src/parameter.c (Scm_ParameterSet): Make it return the previous value,
	  for the consistency to Scheme-level parameter behavior.

2009-11-29  Shiro Kawai  <shiro@acm.org>

	* src/gauche/float.h: Moved ScmIEEEDouble definition to src/number.c.
	  Since ARM's double endian needs special care, it's no longer
	  casually usable.
	* src/number.c (check_armendian): On ARM, checks double's endian
	  at runtime.
	  (decode_double, Scm__EncodeDouble): Enclose ARM special handling
	  in these.
	  (Scm_DecodeFlonum, Scm_DoubleToHalf): No longer touches ScmIEEEDouble
	  directly.
	* src/bignum.c (Scm_BignumToDouble): No longer touches ScmIEEEDouble
	  directly.
	* configure.ac, src/gauche/config.h.in: Comment adjusted to reflect
	  above changes.

2009-11-28  Shiro Kawai  <shiro@acm.org>

	* ext/sxml/Makefile.in (SCMCOMPILE): Needs to add "provide" expr
	  in command line, since we removed explicit provides, but autoprovide
	  doesn't work in this particular case.

	* src/gauche.h (SCM_ALIGN8): Constrains some Scheme objects to
	  be aligned in 8-byte boundary using __attribute__.  See the comment
	  for the details.

	* Many files: Removed (provide "...") idioms, for it is no longer
	  necessary with the autoprovide feature.

	* lib/rfc/822.scm (date->rfc822-date): Added the reverse operation
	  of rfc822-date->date for the convenience.

2009-11-25  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (request-response): When server returns status
	  code 204 or 304, we should not try to retrieve the message body,
	  otherwise the function hangs waiting for the body.

2009-11-23  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/literal.scm, lib/gauche/cgen/literal-uv.scm:
	  Merged literal-uv.scm into literal.scm.

2009-11-21  Shiro Kawai  <shiro@acm.org>

	* release 0.9

	* examples/spigot, examples/mqueue-cpp: Updated to use the newer
	  stub forms.

	* lib/gauche/cgen/stub.scm (process-expr-spec, process-call-spec):
	  As a transition from old (expr ...) and (call ...) form, we make
	  these forms check the ::<type> style return-type if the result
	  type is not given in these forms.  We can't obsolete these forms
	  completely, for the new CiSE spec is not yet fixed and it won't
	  cover all cases (esp. C++ support is weak).  So the stub file
	  may still use expr or call form if CiSE can't be used.  However,
	  the stub can now use the new style of return type form, e.g.:
	  (define-cproc foo () ::<return-type> (expr "Some_C_Expr"))
	  instead of the old style:
	  (define-cproc foo () (expr <return-type> "Some_C_Expr"))

	* ext/template.DIST, examples/spigot/DIST, examples/mqueue-cpp/DIST:
	  Exclude .svn subdir from tarball as well as CVS.

	* lib/rfc/http.scm (consider-proxy): Fix host header handling with
	  proxy.  Now the server given to :proxy only used for the connection.
	  The host request header is the destination server, which may
	  be overwritten by :host keyword argument.   Patch for teppey.

2009-11-19  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h (SCM_CHAR_VALUE): make sure it returns unsigned value.

2009-11-18  Shiro Kawai  <shiro@acm.org>

	* src/gauche.h: Include gauche/arch.h as it should be.
	* src/main.c (version): Includes the architecture in output.

2009-11-15  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/fileutil.scm (glob-fold-1): Fixed a bug that caused
	  an error on (glob "**").

2009-11-11  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (with-connection): Fixed to make a connection
	  to the proxy if it is specified (pointed by Naohiro NISHIKAWA).

2009-11-10  Shiro Kawai  <shiro@acm.org>

	* src/vmcall.c (ADJUST_ARGUMENT_FRAME): Fixed a boundary case
	  of CHECK_STACK when unfolding rest args.  (Patch from enami).

2009-11-03  Shiro Kawai  <shiro@acm.org>

	* gc/dyn_load.c (GC_FirstDLOpenedLinkMap): Applied a patch
	  from enami to support the newest NetBSD-current.
	  NB: We avoid using __NetBSD_Prereq__, for its definition
	  was changed in incompatible way sometime around 4.99.x and
	  that made it unusable to test across wider range of
	  NetBSD versions.

	* gc/misc.c, gc/alloc.c, gc/os_dep.c, gc_pthread_support.c,
	  gc/pthread_stop_world.c, gc/include/private/gcconfig.h,
	  gc/include/private/gc_priv.h: Back port pthread_cancel safe
	  patch from gc cvs head.
	* gc_pthread_support.c (GC_new_thread): Remove duplicate entry
	  before registering a new one.  This particular case happens
	  with glibc-2.7/i386, where GC_exit_handler isn't called when
	  the thread exits with pthread_exit() or pthread_cancel().
	  I'm not sure the real cause is in gc or glibc, but at least
	  this change workarounds the deadlock situation caused by the
	  failure of GC_exit_handler.

2009-10-28  Shiro Kawai  <shiro@acm.org>

	* ext/net/net.c, ext/net/net.ac, src/gauche/config.h.in
	  (HAVE_STRUCT_IFREQ_IFR_IFINDEX, HAVE_STRUCT_IFREQ_IFR_INDEX):
	  FreeBSD7.2 has ifreq.ifr_index instead of ifreq.ifr_ifindex,
	  so we check which is available.  Patch from Naohiro NISHIKAWA.

2009-10-27  Shiro Kawai  <shiro@acm.org>

	* ext/zlib/zliblib.stub (Z_TEXT, Z_FIXED): Conditionally define
	  these, since older zlib doesn't have them.

2009-10-26  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/stub.scm (process-body): Recognize obsoleted
	  (return <c-func-name>) and (return <type> <c-func-name>) to
	  issue a warning and treat them as 'call' forms.  The extensions
	  that have not been updated recently may have thes forms, and
	  it will be inconvenient if we stop supporting them now.

2009-10-25  Shiro Kawai  <shiro@acm.org>

	* src/port.c (Scm_FdReady): Made it work with Windows pipe.

	* src/syslib.stub (sys-get-osfhandle): Added this for low-level
	  tweaking on Windows.

	* ext/termios/termios.scm (without-echoing): Added a high-level
	  utitily for reading input without echoing, which can be used
	  across platforms.
	* lib/gauche/package/util.scm (get-password): Rewrote this using
	  without-echoing.

	* lib/gauche/cgen/type.scm, ext/uvector/uvlib.stub.tmpl:
	  Moved stub type definitions of <s8vector> etc. from ext/uvector
	  to cgen/type.scm, since they are now supported by core.

	* ext/termios/termiolib.stub: Added bunch of Windows Console API
	  on GAUCHE_WINDOWS.

2009-10-24  Shiro Kawai  <shiro@acm.org>

	* src/syslib.stub (Scm_MakeWinHandle, Scm_WinHandleP etc.),
	  src/system.c (Scm_WinProcessPID), src/gauche/system.h:
	  Created generic Windows HANDLE wrapper and redefined Windows
	  process handle API on top of it.

	* src/scmlib.scm (%sys-escape-windows-command-line),
	  src/system.c (win_create_command_line),
	  lib/gauche/process.scm (shell-escape-string):
	  Moved Windows shell argument escape routine from shell-escape-string
	  to src/scmlib.scm, since it is also needed to implement
	  Scm_Exec on Windows correctly (well, almost.  Windows does not
	  enforce consistent rules of parsing command lines, so all we can
	  do is cross our fingers.)

2009-10-21  Shiro Kawai  <shiro@acm.org>

	* src/system.c (Scm_SysExec, pipe), src/gauche/win-compat.h:
	  Support I/O redirection using pipes on Windows, and try to
	  align process exit status handling.

	* src/port.c (Scm_PortFdDup), src/extlib.stub (port-fd-dup!):
	  Support these under Windows as well (via _dup2()).  They are
	  not fully compatible (Windows seems to have some restrictions
	  on which file descriptors can be dup'ed?) but it's better than
	  nothing.

	* src/error.c (Scm_SysError): On GAUCHE_WINDOWS, check both
	  errno and GetLastError; posix-compatible API uses the former
	  and Windows API uses the latter, and Scm_SysError doesn't know
	  which for sure.  We always reset both errors after Scm_SysError
	  so we can guess that non-zero one reflects the actual error.

	* src/syslib.stub (sys-stat): On GAUCHE_WINDOWS, remove trailing
	  path separator in PATH if any (excluding the root directory; e.g.
	  "/" or "c:\\" are untouched).  This is because Windows stat()
	  raises error if there's trailing separator, except the root
	  directory case.

	* src/main.c (main): On GAUCHE_WINDOWS, sets stdin, stdout and
	  stderr to binary mode.  This will align gosh's behavior the
	  same on Windows and Unix, and save lots of troubles.  Note that
	  applications that want to link libgauche.dll should take care
	  of this by themselves.

2009-10-20  Shiro Kawai  <shiro@acm.org>

	* src/syslib.stub (sys-unlink): On GAUCHE_WINDOWS, make file writable
	  before unlink(), since Windows doesn't allow unlinking a read-only
	  file.

2009-10-19  Shiro Kawai  <shiro@acm.org>

	* test/system.scm: Excluded fork&wait test on cygwin platform since
	  fork() on cygwin is so unreliable.

	* src/mingw-exify: Updated to use 0.9 API.

	* src/core.c (init_cond_features): Added a feature gauche.os.cygwin
	  on cygwin platform.  It comes short to provide an illusion of
	  complete unix emulation, so the program may want to switch its
	  behavior.

	* gencomp: Resurrected for the backward compatibility.  It issues
	  warning to move on to precomp.

	* src/gauche.h, src/gauche/load.h, src/gauche/hash.h, src/gauche/port.h,
	  src/main.c, src/test-vmstack.c, ext/Makefile.ext.in:
	  Removed GAUCHE_API_0_9 flags.  Now 0.9 API is the default.  The
	  backward compatibility API is available under a new flag,
	  GAUCHE_API_PRE_0_9.

2009-10-18  Shiro Kawai  <shiro@acm.org>

	* src/gauche/extend.h (SCM_INIT_EXTENSION): Revived data/bss area
	  registration code only for Cygwin; it still seems to need them.

	* gc/configure.ac: Applied a patch to avoid adding -lpthread -ldl
	  when building on Cygwin, for it causes link error.

2009-10-17  Shiro Kawai  <shiro@acm.org>

	* src/vm.c (vm_finalize): Issue a warning when a thread is terminated
	  by an uncaught exception and its state is never retrieved by
	  thread-join!.  Such a case must be a coding error, and usually
	  causes pain in debugging if such thread dies silently.
	* src/exclib.stub, src/gauche/exception.h, ext/thread/thrlib.stub:
	  Moved thread exception definitions from the thread subsystem to
	  the core; we need <uncaught-exception> in the core to implement
	  the above feature.
	* ext/threads/threads.c (Scm_ThreadJoin): Use SAEF_LOCK_BEGIN|END.

2009-10-16  Shiro Kawai  <shiro@acm.org>

	* src/gauche-install.in: Added -C|--canonical-suffix option that
	  renames *.sci to *.scm upon install.  This is to avoid confusion
	  when both foo.sci and foo.scm happens to be installed.
	* ext/Makefile.ext.in, ext/template.Makefile.in: Added -C option
	  to gauche-install.

2009-10-13  Shiro Kawai  <shiro@acm.org>

	* lib/gauche/cgen/cise.scm (define-cfn): Fixed a bug that didn't
	  escape identifiers for forward-declaration in record-static.

	* src/extlib.stub (%vm-show-stack-trace): experimentally expose
	  this function for diagnostics.

2009-10-11  Shiro Kawai  <shiro@acm.org>

	* configure.ac: platform match for freebsd allows *freebsd, in order
	  to support kfreebsd (Patch from Jens Thiele).

2009-10-10  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-generic): adds user-agent header automatically,
	  using default value from the parameter http-user-agent.
	  Also supports :proxy option.

2009-10-09  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-compose-form-data, http-generic):
	  Support automatic multipart/form-data composition in
	  http-post and http-put.

2009-10-08  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/http.scm (http-compose-query, http-generic): Support
	  application/x-www-form-urlencoded query composition in http-*
	  procedures.

2009-10-07  Shiro Kawai  <shiro@acm.org>

	* lib/rfc/mime.scm (mime-compose-message, mime-compose-message-string)
	  (mime-make-boundary): Added support of composing a MIME message.
	  (mime-parse-parameters, mime-compose-parameters): Expose those
	  APIs (the former renamed from mime-parse-parameter-value).

2009-09-29  Shiro Kawai  <shiro@acm.org>

	* src/gauche/gloc.h, src/gloc.c (Scm_GlocMarkConst,Scm_GlocUnmarkConst):
	  APIs for better encapsulation.  Also dropped Scm_MakeConstGloc,
	  because of duplicated feature.
	* src/module.c (Scm_Define, Scm_DefineConst): Factored out the
	  common parts, and make sure modules.mutex is unlocked.

2009-09-26  Shiro Kawai  <shiro@acm.org>

	* src/gauche/gloc.h, src/gloc.c,
	  src/gauche/module.h, src/module.c (Scm_HideBinding, Scm_FindBinding),
	  src/intlib.stub (%hide-binding): Added a hack to hide binding
